Unit SWCDIR;

{$F+}


Interface


Uses CRT,
     DOS,
     SWCVaria;



Procedure Dir(Var DI: Hand;SStr: STFF;Var ZStr: ST79;SAttr: Byte;
          Line: IntL;BoolDots,BoolGDir,BoolFree: Bool);
Procedure DirFree(Var DI: Hand);
Function  DirGetFDisk(DefLW: ST02;Var DTyp0: DTyp): ST02;
Function  DirGetHDisk(DefLW: ST02): ST02;
Function  DirTest(DI: Hand): Bool;
Procedure FindFirst(SStr: ST79;SAttr: Byte;Var DInfo: SRec);
Procedure FindNext(Var DInfo: SRec);
Function  GetFileAttr(Var DI: Hand;Index: IntL): ST06;
Function  GetFileChoo(Var DI: Hand;Index: IntL): Bool;
Function  GetFileDate(Var DI: Hand;Index: IntL): ST10;
Procedure GetFileName(Var DI: Hand;Index: IntL;Var FName: ST79);
Function  GetFileSiz2(Var DI: Hand;Index: IntL): IntL;
Function  GetFileSize(Var DI: Hand;Index: IntL): ST11;
Function  GetFileTime(Var DI: Hand;Index: IntL): ST08;
Procedure GetFreeDirHandle(Var DI: Hand);
Procedure GotoDir(Var SStr: ST79;FName: ST13);
Function  HelpGetX(IndexWin:  Byte): Byte;
Function  HelpGetY(IndexWin:  Byte): Byte;
Procedure MakeFDiskLSN;
Procedure MakeHDiskLSN;
Procedure MakeFileList(Var DI: Hand;SStr: STFF);
Procedure MoveDVecToXMS(Var DI: Hand;Index: IntL);
Procedure MoveXMSToDVec(Var DI: Hand;Index: IntL);
Procedure PageDir(Var DI: Hand);
Procedure PutFileChoo(Var DI: Hand;FName: ST12);
Procedure ReadIn(Var DI: Hand;SStr: STFF;
          SAttr: Byte;BDots,BSort: Bool);
Procedure SortDir(Var DI: Hand);




Implementation




Uses SWCLSN,
     SWCMask,
     SWCMouse,
     SWCOpt,
     SWCPGX,
     SWCSubPr,
     SWCUtil,
     SWCXMS;




Var
  Count         : IntL;
  Long0         : IntL;




Procedure GetCountFiles(Var DI: Hand;
          SStr: STFF;SAttr: Byte;BDots: Bool);        Forward;
Procedure Readin2(Var DI: Hand;
          SStr: STFF;SAttr: Byte;BDots: Bool);        Forward;
Procedure SetWin1(Var DI: Hand);                      Forward;
Procedure SetWin2(Var DI: Hand);                      Forward;
Procedure WriteF3(Var DI: Hand;IndexWin: Byte);       Forward;
Procedure WriteF32(Var DI: Hand;IndexWin: Byte);      Forward;




Procedure Dir(Var DI: Hand;SStr: STFF;Var ZStr: ST79;SAttr: Byte;
          Line: IntL;BoolDots,BoolGDir,BoolFree: Bool);
Label DIR2,
      DIR3,
      DIR4,
      DIR5,
      DIRD,
      DIREND,
      DIRHOME,
      DIRU,
      DIRL,
      DIRR,
      DIRE,
      DIRC,
      DIRF,
      DIRP,
      DIRPD,
      DIRPU;

Var
  Attr   : Word;
  Byte0  : Byte;
  Count  : Word;
  DStr   : ST67;
  EStr   : ST04;
  MouseH : Hand;
  MouseN : ST03;
  NStr   : ST09;
  Stri0  : ST80;
  Word0  : Word;

Begin

  ScreenParams(BT);
  If Line>=000 Then IndexLine:=Line;
  CrsrOff;

  DIR2:
  If Not DirTest(DI) Then
  ReadIn(DI,SStr,SAttr,BoolDots,BT);
  If Not BooleanErr Then
  Begin
    BoolAsk[DI]:=BT;
  End
  Else
  Begin
    ScreenParams(BF);
    Exit;
  End;
  AktDir:=DI;
  If IndexLine>DirEA[DI] Then IndexLine:=DirEA[DI];
  IndexPage:=IndexLine Div 064;

  DIR3:
  PageDir(DI);
  OptTableau3(003,018,070,002,'',BF);

  DIR4:
  SetWin1(DI);
  Stri0[000]:=#070;
  FillChar(Stri0[001],070,032);
  FSplit(SStr,DStr,NStr,EStr);
  MoveXMSToDVec(DI,IndexLine);
  With DirVec[DI] Do
  Begin
    Attr:=DAttr;
    FileName:=DName;
  End;
  DIRZURUECK:=CutString(DStr+FileName,050);
  Str(IndexLine+001,NStr);
  DIRZURUECK:='Line: '+NStr+'  '+DIRZURUECK;
  StringInString(DIRZURUECK,Stri0,(070-Length(DIRZURUECK)) Div 002);
  WriteVR(Stri0,005,020);
  Wait;
  SetWin2(DI);
  If BOOLMOUSEEVENT Then Goto DIR4;
  If Boolean13   Then Goto DIRE;
  If Boolean13C  Then Goto DIRF;
  If Boolean32   Then Goto DIRP;
  If BooleanDn   Then Goto DIRD;
  If BooleanEnd  Then Goto DIREND;
  If BooleanEx   Then Goto DIRE;
  If BooleanHome Then Goto DIRHOME;
  If BooleanLeft Then Goto DIRL;
  If BooleanRig  Then Goto DIRR;
  If BooleanUp   Then Goto DIRU;
  If BooleanPD   Then Goto DIRPD;
  If BooleanPU   Then Goto DIRPU;
  Goto DIR4;

  DIR5:
  Click;
  If IndexLine<=(IndexPage+001)*064-001 Then Goto DIR4;
  Inc(IndexPage);
  Goto DIR3;

  DIRD:
  If IndexLine=DirEA[DI] Then Goto DIR5;
  Inc(IndexLine);
  If IndexLine<064*(IndexPage+001) Then Goto DIR4;
  Inc(IndexPage);
  Goto DIR3;

  DIREND:
  IndexPage:=DirEA[DI] Div 064;
  IndexLine:=DirEA[DI];
  Goto DIR3;

  DIRF:
  FSplit(SStr,DStr,NStr,EStr);
  ZStr:=Copy(DStr,001,Length(DStr)-001);
  If BoolFree Then DirFree(DI);
  ScreenParams(BF);
  Exit;

  DIRHOME:
  IndexLine:=000;
  IndexPage:=000;
  Goto DIR3;

  DIRL:
  if indexline-016<000 then indexline:=000;
  If indexline=000 Then Goto DIR5;
  indexline:=indexline-016;
  if indexline>=indexpage*064 then goto dir4;
  dec(indexpage);
  goto dir3;

  DIRP:
  MoveXMSToDVec(DI,IndexLine);
  With DirVec[DI] Do
  Begin
    If DReserv And 001=001 Then
    DReserv:=DReserv And 65534
    Else
    DReserv:=DReserv Or 001;
  End;
  MoveDVecToXMS(DI,IndexLine);
  SetWin2(DI);
  Goto DIRD;

  DIRPD:
  If (IndexPage+001)*064<=DirEA[DI] Then Inc(IndexPage);
  IndexLine:=IndexPage*064;
  Goto DIR3;

  DIRPU:
  If IndexPage>000 Then Dec(IndexPage);
  IndexLine:=IndexPage*064;
  Goto DIR3;

  DIRR:
  If IndexLine+016>DirEA[DI] Then IndexLine:=DirEA[DI];
  If IndexLine=DirEA[DI]  Then Goto DIR5;
  IndexLine:=IndexLine+016;
  If IndexLine<=(IndexPage+001)*064-001 Then Goto DIR4;
  Inc(IndexPage);
  Goto DIR3;

  DIRU:
  If IndexLine=000 Then Goto DIR5;
  Dec(IndexLine);
  If IndexLine>=IndexPage*064 Then Goto DIR4;
  Dec(IndexPage);
  Goto DIR3;

  DIRE:
  If BooleanEx Then
  Begin
    DirFree(DI);
    ScreenParams(BF);
    Exit;
  End;
  MoveXMSToDVec(DI,IndexLine);
  With DirVec[DI] Do
  Begin
    Attr:=DAttr;
    Filename:=DName;
  End;
  If BoolFree Then DirFree(DI);
  If Attr And 016=000 Then
  Begin
    ZStr:=DStr+FileName;
    ScreenParams(BF);
    Exit;
  End;
  If BoolGDir Then
  Begin
    ZStr:=DStr+FileName;
    ScreenParams(BF);
    Exit;
  End;
  If Not BoolFree Then
  DirFree(DI);
  IndexLine:=000;
  GotoDir(SStr,FileName);
  Goto DIR2;

End;




Procedure DirFree(Var DI: Hand);
Var
  B13   : Bool;
  BEx   : Bool;
  BErr  : Bool;
  HandT : Hand;
  FNam2 : ST13;
  Long0 : IntL;
  PXX2  : ST04;
  SHWB0 : Bool;
  SHWH0 : Hand;
  Word0 : Word;

Begin

  B13:=Boolean13;
  BEx:=BooleanEx;
  BErr:=BooleanErr;
  If DI<255 Then
  If DirEA[DI]>=000 Then
  Begin
    BoolAsk[DI]:=BF;
    DirEA[DI]:=-001;
    If DirSel3[DI]=000 Then
    Begin
      If DirSel2[DI]>000 Then
      Begin
        XMSFree('DIR'+Chr(DI));
        FreeBuf(DirSel2[DI],Word0);
        MemErrorOut('DirFree',Word0,000);
      End;
    End
    Else
    If DirSel2[DI]>000 Then
    Begin
      FreeBuf(DirSel2[DI],Word0);
      MemErrorOut('DirFree',Word0,000);
      FreeBuf(DirSel3[DI],Word0);
      MemErrorOut('DirFree',Word0,000);
    End
    Else
    Begin
      FreeBuf(DirSel3[DI],Word0);
      MemErrorOut('DirFree',Word0,000);
    End;
    DI:=255;
  End;
  Boolean13:=B13;
  BooleanEx:=BEx;
  BooleanErr:=BErr;

End;




Function  DirGetFDisk(DefLW: ST02;Var DTyp0: DTyp): ST02;
Const
  LLine : IntL=000;

Var
  I     : Byte;
  Long0 : IntL;

Begin

  DirGetFDisk:='';
  LSNLoad('DRIVES',PRGPATH+'\7WCOPYFD.LSN','',RdWr);
  If Not BooleanErr Then
  Begin
    I:=LSNIGet('DRIVES');
    If DefLW<>'' Then
    Begin
      LSNSearchJ('DRIVES',DefLW,000,LastLine[I],000,Long0,Long0,BT,BF);
      If Long0>=000 Then LLine:=Long0;
    End;
    LSNEdit('DRIVES',000,000,036,000,
    PRGPATH+'\7WCOPYFD.LSN','',$00000004,BF,LLine,BT,BF,BT,BT,BT,BT);
    If Boolean13 Then
    Begin
      LLine:=ALnLSN;
      DirGetFDisk:=Copy(STRLSN,002,002);
      Long0:=GetListLong('DRIVES',ALnLSN,001);
      Case Long0 Of
      001 : DTyp0:=DT320;
      002 : DTyp0:=DT12;
      003 : DTyp0:=DT720;
      004 : DTyp0:=DT144;
      005 : DTyp0:=DT288;
      End;
      LSNFree('DRIVES');
    End;
  End;

End;




Function  DirGetHDisk(DefLW: ST02): ST02;
Const
  LLine : IntL=000;

Var
  I     : Byte;
  Long0 : IntL;

Begin

  DirGetHDisk:='';
  LSNLoad('DRIVES',PRGPATH+'\7WCOPYHD.LSN','',Rd);
  If Not BooleanErr Then
  Begin
    I:=LSNIGet('DRIVES');
    If DefLW<>'' Then
    Begin
      LSNSearchJ('DRIVES',DefLW,000,LastLine[I],000,Long0,Long0,BT,BF);
      If Long0>=000 Then LLine:=Long0;
    End;
    LSNEdit('DRIVES',000,000,000,000,
    PRGPATH+'\7WCOPYHD.LSN','',$00000004,BF,LLine,BT,BT,BT,BT,BT,BT);
    If Boolean13 Then
    Begin
      LLine:=ALnLSN;
      DirGetHDisk:=Copy(STRLSN,002,002);
    End;
  End;

End;




Function  DirTest(DI: Hand): Bool;
Begin

  DirTest:=BF;
  BooleanErr:=BT;
  If DI<255 Then
  If DirEA[DI]>=000 Then
  Begin
    DirTest:=BT;
    BooleanErr:=BF;
  End;

End;




Procedure FindFirst(SStr: ST79;SAttr: Byte;Var DInfo: SRec);
Begin

  With DInfo Do
  Begin
    DOS.FindFirst(SStr,SAttr,DInfo);
    If DOSError=000 Then
    If Attr And 008=008 Then
    FindNext(DInfo);
  End;

End;



Procedure FindNext(Var DInfo: SRec);
Begin

  With DInfo Do
  Begin
    DOS.FindNext(DInfo);
    If DOSError=000 Then
    If Attr And 008=008 Then
    FindNext(DInfo);
  End;

End;



Procedure GetCountFiles(Var DI: Hand;SStr: STFF;SAttr: Byte;BDots: Bool);
Var
  Byte0 : Byte;
  DStr  : ST67;
  EStr  : ST04;
  EStr2 : ST04;
  HandF : Hand;
  NStr  : ST09;
  Stri0 : STFF;

Begin

  Count:=000;
  Stri0:=SStr;
  Byte0:=Pos('\',Stri0);
  If Byte0=000 Then BoolMainRoot:=BT
  Else
  Begin
    Delete(Stri0,Byte0,001);
    Byte0:=Pos('\',Stri0);
    If Byte0=000 Then BoolMainRoot:=BT
    Else BoolMainRoot:=BF;
  End;
  If BoolMainRoot Then BDots:=BF;
  FSplit(SStr,DStr,NStr,EStr);
  Begin
    Repeat
      Byte0:=Pos(',',EStr);
      If Byte0>000 Then
      Begin
        EStr2:=Copy(EStr,001,Byte0-001);
        Delete(EStr,002,Byte0-001);
      End
      Else
      EStr2:=EStr;
      SStr:=DStr+NStr+EStr2;
      FindFirst(SStr,SAttr,DirInfo);
      If DosError=000 Then
      Begin
        With DirInfo Do
        Begin
          If BDots Then
          Begin
            BDots:=BF;
            If Name='.' Then
            Begin
              FindNext(DirInfo);
              Inc(Count);
            End
            Else
            Begin
              If Name<>'..' Then Inc(Count,002);
              If Name='..' Then Inc(Count);
            End;
          End
          Else
          Begin
            If Name='.' Then FindNext(DirInfo)
            Else
            If Name<>'..' Then Inc(Count);
          End;
        End;
        While DosError=000 Do
        Begin
          FindNext(DirInfo);
          Inc(Count);
        End;
        Dec(Count);
      End
      Else
      If Not BDots Or BoolMainRoot Then
      BooleanErr:=BT;
    Until Byte0=000;
    If Count=000 Then BooleanErr:=BT Else BooleanErr:=BF;
    If Not ChkPath(Copy(DStr,001,Length(DStr)-001)) Then BooleanErr:=BT;
  End;

End;




Function  GetFileAttr(Var DI: Hand;Index: IntL): ST06;
Var
  Stri0 : ST06;

Begin

  MoveXMSToDVec(DI,Index);
  With Dirvec[DI] Do
  Begin
    Stri0:='------';
    If DAttr And 001=001 Then Stri0[001]:='R';
    If DAttr And 002=002 Then Stri0[002]:='H';
    If DAttr And 004=004 Then Stri0[003]:='S';
    If DAttr And 008=008 Then Stri0[004]:='V';
    If DAttr And 016=016 Then Stri0[005]:='D';
    If DAttr And 032=032 Then Stri0[006]:='A';
  End;
  GetFileAttr:=Stri0;

End;




Function  GetFileChoo(Var DI: Hand;Index: IntL): Bool;
Begin

  MoveXMSToDVec(DI,Index);
  With DirVec[DI] Do
  If DReserv And 001=001 Then
  GetFileChoo:=BT Else GetFileChoo:=BF;

End;




Function  GetFileDate(Var DI: Hand;Index: IntL): ST10;
Var
  DT    : DateTime;
  Stri0 : ST10;
  Stri1 : ST10;

Begin

  MoveXMSToDVec(DI,Index);
  With DirVec[DI] Do UnpackTime(DTime,DT);
  With DT Do
  Begin
    Str(Day:002,Stri1);
    Stri0:=Stri1+'.';
    Str(Month:002,Stri1);
    Stri0:=Stri0+Stri1+'.';
    Str(Year:004,Stri1);
    Stri0:=Stri0+Stri1;
    Stri0:=FillString(Stri0,#032,#048);
  End;
  GetFileDate:=Stri0;

End;




Procedure GetFileName(Var DI: Hand;Index: IntL;Var FName: ST79);
Begin

  FName:='';
  MoveXMSToDVec(DI,Index);
  With DirVec[DI] Do
  Begin
    FName:=DName;
    If Length(DName)<=012 Then
    FName[013]:=Chr(DAttr);
  End;

End;




Function  GetFileSiz2(Var DI: Hand;Index: IntL): IntL;
Begin

  MoveXMSToDVec(DI,Index);
  With DirVec[DI] Do
  GetFileSiz2:=DSize;

End;




Function  GetFileSize(Var DI: Hand;Index: IntL): ST11;
Var
  Stri0 : ST11;
  Size  : IntL;

Begin

  MoveXMSToDVec(DI,Index);
  With DirVec[DI] Do Size:=DSize;
  Str(Size:011,Stri0);
  GetFileSize:=Stri0;

End;




Function  GetFileTime(Var DI: Hand;Index: IntL): ST08;
Var
  DT    : DateTime;
  Stri0 : ST08;
  Stri1 : ST08;

Begin

  MoveXMSToDVec(DI,Index);
  With DirVec[DI] Do UnpackTime(DTime,DT);
  With DT Do
  Begin
    Str(Hour:002,Stri1);
    Stri0:=Stri1+':';
    Str(Min:002,Stri1);
    Stri0:=Stri0+Stri1+':';
    Str(Sec:002,Stri1);
    Stri0:=Stri0+Stri1;
    Stri0:=FillString(Stri0,#032,#048);
  End;
  GetFileTime:=Stri0;

End;




Procedure GetFreeDirHandle(Var DI: Hand);
Var
  Byte0 : Byte;

Begin

  If DI=255 Then
  Begin
    For Byte0:=000 To SizeOf(BoolAsk)-001 Do
    Begin
      If DirEA[Byte0]=-001 Then
      Begin
        DI:=Byte0;
        Exit;
      End;
    End;
    ErrorOut('GetFreeDirHandle: No DIR-Handle free',001,'',#000);
  End;

End;




Procedure GotoDir(Var SStr: ST79;FName: ST13);
Var
  Byte0 : Byte;
  Stri0 : ST79;

Begin

  If Pos('..',FName)>000 Then
  Begin
    GetDir(000,Stri0);
    Stri0:=Copy(Stri0,001,002);
    Byte0:=System.Pos(Stri0,SStr);
    If  ((Byte0=000)
    And (SStr<>'\*.*'))
    Or  ((Byte0>000)
    And (Copy(SStr,003,004)<>'\*.*')) Then
    Begin
      Stri0:=SStr;
      For Byte0:=000 To Length(SStr)-001 Do
      Stri0[Length(SStr)-Byte0]:=SStr[001+Byte0];
      Delete(Stri0,001,004);
      Byte0:=Pos('\',Stri0);
      Delete(Stri0,001,Byte0-001);
      SStr:=Stri0;
      For Byte0:=000 To Length(SStr)-001 Do
      Stri0[Length(SStr)-Byte0]:=SStr[001+Byte0];
      SStr:=Stri0+'*.*';
    End;
  End
  Else
  Begin
    Byte0:=Pos('*.*',SStr);
    Stri0:=BuendigLR(Copy(FName,001,008))+
    BuendigLR(Copy(FName,009,004));
    If (Stri0='') Or (Stri0[Length(Stri0)]='\') Then
    Insert(Stri0,SStr,Byte0)
    Else
    Insert(Stri0+'\',SStr,Byte0);
  End;

End;




Function  HelpGetX(IndexWin: Byte): Byte;
Begin

  If IndexWin<016 Then
  HelpGetX:=002
  Else
  If IndexWin<032 Then
  HelpGetX:=021
  Else
  If IndexWin<048 Then
  HelpGetX:=040
  Else
  If IndexWin<064 Then
  HelpGetX:=059
  Else
  HelpGetX:=000;

End;




Function  HelpGetY(IndexWin: Byte): Byte;
Var
  Byte0 : Byte;

Begin

  Byte0:=IndexWin Div 016;
  HelpGetY:=IndexWin-Byte0*016+001;

End;




Procedure MakeFDiskLSN;
Var
  Byte0 : Byte;
  DrvX  : ST01;
  DSize : IntL;
  HandF : Hand;
  LaufW : Byte;
  LongA : IntL;
  LongC : IntL;
  LongD : IntL;
  Regs0 : Regi;
  SHWB0 : Bool;
  SHWH0 : Hand;
  Stri0 : ST80;
  Stri1 : ST80;
  Stri2 : ST01;
  Word0 : Word;

Begin

  TempI;
  Word0:=037;
  OFileF(HandF,PRGPATH+'\7WCOPYFD.LSN',FNew,001);
  BlockWrite(HandF,Word0,002,CntrHROW0);
  Stri0:='  List of all floppy-disk-drives     ';
  BlockWrite(HandF,Stri0[001],037,CntrHROW0);
  For Byte0:=000 To 001 Do
  With Regs0 Do
  Begin
    DX:=$0000+Byte0;
    AX:=$0800;
    Intr($13,Regs0);
    If Flags And FCarry=000 Then
    LaufW:=BX
    Else
    LaufW:=000;
    If LaufW>000 Then
    Begin
      Str(LaufW,Stri2);
      Stri0:='  '+#000+Chr(Byte0+065)+':'+#000+#000+#000;
      Case LaufW Of
      001 : Stri1:='5'+#000+'1/4"'+#000+#000+#000+'320'+#000+#000+'KB';
      002 : Stri1:='5'+#000+'1/4"'+#000+#000+#000+'1.2'+#000+#000+'MB';
      003 : Stri1:='3'+#000+'1/2"'+#000+#000+#000+'720'+#000+#000+'KB';
      004 : Stri1:='3'+#000+'1/2"'+#000+#000+#000+'1.44'+#000+'MB';
      005 : Stri1:='3'+#000+'1/2"'+#000+#000+#000+'2.88'+#000+'MB';
      End;
      Stri0:=Stri0+Stri1+#0+#0+#0+#0+#0+#0+#0+#0+#032+#032+Stri2;
      While Length(Stri0)<037 Do Stri0:=Stri0+#032;
      BlockWrite(HandF,Stri0[001],037,CntrHROW0);
    End;
  End;
  OFileF(HandF,'',FClose,001);
  TempO;

End;




Procedure MakeHDiskLSN;
Var
  Byte0 : Byte;
  DrvX  : ST01;
  DSize : IntL;
  HandF : Hand;
  LaufW : Byte;
  LongA : IntL;
  LongC : IntL;
  LongD : IntL;
  Regs0 : Regi;
  SHWB0 : Bool;
  SHWH0 : Hand;
  Stri0 : ST80;
  Stri1 : ST80;
  Word0 : Word;

Begin

  TempI;
  Word0:=037;
  OFileF(HandF,PRGPATH+'\7WCOPYHD.LSN',FNew,001);
  BlockWrite(HandF,Word0,002,CntrHROW0);
  Stri0:='  List of all hard-disk-drives       ';
  BlockWrite(HandF,Stri0[001],037,CntrHROW0);
  SHWB0:=BT;
  For Byte0:=000 To 026 Do
  Begin
    ShowP('Make list ...',
    SHWB0,SHWH0,040,020,015,Byte0,026,BF);
    If Byte0>002 Then
    Begin
      DrvX:=Chr(Byte0+064);
      With Regs0 Do
      If ChkDrvOK(DrvX) Then
      Begin
        AX:=$3600;
        DX:=Byte0;
        Intr($21,Regs0);
        LongA:=AX; {Sektoren pro Cluster}
        LongC:=CX; {Bytes pro Sektor}
        LongD:=DX; {Gesamtkapazitt des Laufwerks in Clustern}
        DSize:=LongA*LongC*LongD;
        FillChar(Stri0[001],037,#032);
        Stri0:='  '+#000+Chr(Byte0+064)+':'+#0+#0+#0+#0+#0+#0;
        DSize:=DSize Div 1048576;
        Str(DSize:013,Stri1);
        Stri1:=Stri1+#000+'MB';
        Stri1:=FillString(Stri1,#032,#000);
        Stri0:=Stri0+Stri1+#0+#0+#0+#0+#0+#0+#0+#0;
        BlockWrite(HandF,Stri0[001],037,CntrHROW0);
      End;
    End;
  End;
  OFileF(HandF,'',FClose,001);
  TempO;

End;




Procedure MakeFileList(Var DI: Hand;SStr: STFF);
Var
  Attr  : ST06;
  DatSz : ST11;
  FName : ST13;
  HandF : Hand;
  Long0 : Word;
  Stri0 : ST80;
  Word0 : Word;
  SHWB0 : Bool;
  SHWH0 : Hand;

Begin

  ReadIn(DI,SStr,063,BT,BT);
  If Not BooleanErr Then
  Begin
    OFileF(HandF,PRGPATH+'\7WCFILES.LSN',FNew,001);
    If IOResult2=000 Then
    Begin
      TempI;
      SHWB0:=BT;
      Word0:=062;
      BlockWrite(HandF,Word0,002,CntrHROW0);
      FillChar(Stri0[001],062,032);
      Stri0:='  '+CutString(SStr,060);
      BlockWrite(HandF,Stri0[001],062,CntrHROW0);
      For Long0:=000 To DirEA[DI] Do
      Begin
        ShowP('Make file list',SHWB0,
        SHWH0,030,025,016,Long0,DirEA[DI],BF);
        FillChar(Stri0[001],014,000);
        GetFileName(DI,Long0,FName);
        If FileName<>'.' Then
        Begin
          Attr:=GetFileAttr(DI,Long0);
          If Pos('D',Attr)=000 Then
          DatSz:=GetFileSize(DI,Long0)
          Else
          If FName='..' Then
          DatSz:=('    UP-DIR ')
          Else
          DatSz:=('    SUB-DIR');
          DatSz:=FillString(DatSz,#032,#000);
          Word0:=$2020;
          BlockWrite(HandF,Word0,002,CntrHROW0);
          Stri0:=FillString(FName,#032,#000);
          BlockWrite(HandF,Stri0[001],012,CntrHROW0);
          Word0:=$0000;
          BlockWrite(HandF,Word0,002,CntrHROW0);
          BlockWrite(HandF,DatSz[001],011,CntrHROW0);
          BlockWrite(HandF,Word0,002,CntrHROW0);
          Stri0:=GetFileDate(DI,Long0);
          BlockWrite(HandF,Stri0[001],010,CntrHROW0);
          BlockWrite(HandF,Word0,002,CntrHROW0);
          Stri0:=GetFileTime(DI,Long0);
          BlockWrite(HandF,Stri0[001],008,CntrHROW0);
          BlockWrite(HandF,Word0,002,CntrHROW0);
          BlockWrite(HandF,Attr[001],006,CntrHROW0);
          BlockWrite(HandF,Word0,002,CntrHROW0);
          Stri0:=#000;
          BlockWrite(HandF,Stri0[001],001,CntrHROW0);
          Word0:=$2020;
          BlockWrite(HandF,Word0,002,CntrHROW0);
        End;
      End;
      OFileF(HandF,'',FClose,001);
      TempO;
    End;
    DirFree(DI);
    BooleanErr:=BF;
  End;

End;




Procedure MoveDVecToXMS(Var DI: Hand;Index: IntL);
Var
  Word0 : Word;
  Word1 : Word;

Begin

  If DirSel3[DI]=000 Then
  Begin
    With XMSMOVSTRUC Do
    Begin
      XMSLen:=SizeOf(DirRec);
      HandleS:=000;
      Move(DirVec[DI],Mem[DirSel2[DI]:0],SizeOf(DirRec));
      Ptr0:=Ptr(DirSeg2[DI],$0000);
      Move(Ptr0,OffsS,004);
      HandleT:=XMSHANDLE;
      OffsT:=XMSOFFSETS[XMSGHand2(DirHandle[DI])]+Index*SizeOf(DirRec);
    End;
    XMSCallFunc(XMSGHand2(DirHandle[DI]),MoveEMB);
  End
  Else
  Move(DirVec[DI],Mem[DirSel3[DI]:Index*SizeOf(DirRec)],SizeOf(DirRec));

End;




Procedure MoveXMSToDVec(Var DI: Hand;Index: IntL);
Var
  Word0 : Word;
  Word1 : Word;

Begin

  If DirSel3[DI]=000 Then
  Begin
    With XMSMOVSTRUC Do
    Begin
      XMSLen:=SizeOf(DirRec);
      HandleS:=XMSHANDLE;
      OffsS:=XMSOFFSETS[XMSGHand2(DirHandle[DI])]+Index*SizeOf(DirRec);
      HandleT:=000;
      Ptr0:=Ptr(DirSeg2[DI],$0000);
      Move(Ptr0,OffsT,004);
    End;
    XMSCallFunc(XMSGHand2(DirHandle[DI]),MoveEMB);
    Move(Mem[DirSel2[DI]:0],DirVec[DI],SizeOf(DirRec));
  End
  Else
  Move(Mem[DirSel3[DI]:Index*SizeOf(DirRec)],DirVec[DI],SizeOf(DirRec));

End;




Procedure PageDir(Var DI: Hand);
Var
  Byte0 : Byte;

Begin

  GetPacked('7WCOPY',BT);
  For Byte0:=000 to 063 Do
  If IndexPage*064+Byte0<=DirEA[DI] Then
  Begin
    WriteF3(DI,Byte0);
    Shadow(HelpGetX(Byte0)+001,HelpGetX(Byte0)+018,
    HelpGetY(Byte0)+001,HelpGetY(Byte0)+001);
  End;

End;




Procedure PutFileChoo(Var DI: Hand;FName: ST12);
Var
  FNam2 : ST13;
  Long0 : IntL;

Begin

  BooleanErr:=BT;
  For Long0:=000 To DirEA[DI] Do
  Begin
    GetFileName(DI,Long0,FNam2);
    If FName=FNam2 Then
    Begin
      MoveXMSToDVec(DI,Long0);
      With DirVec[DI] Do
      DReserv:=DReserv And 65534 Or 001;
      MoveDVecToXMS(DI,Long0);
      BooleanErr:=BF;
      Exit;
    End;
  End;

End;




Procedure ReadIn(Var DI: Hand;SStr: STFF;
          SAttr: Byte;BDots,BSort: Bool);
Label READ2,
      READ3;
Var
  DStr  : ST67;
  EStr  : ST04;
  FName : ST13;
  NStr  : ST09;
  RPos  : Byte;
  SRec0 : SRec;

Begin

  If DI=255 Then
  Begin
    GetFreeDirHandle(DI);
    DirPath[DI]:=DStr;
    ReadIn2(DI,SStr,SAttr,BDots);
    If Not BooleanErr Then
    If BSort Then SortDir(DI);
  End
  Else
  BooleanErr:=BT;

End;




Procedure Readin2(Var DI: Hand;SStr: STFF;SAttr: Byte;BDots: Bool);
Var
  Byte0 : Byte;
  Cntr  : IntL;
  DStr  : ST67;
  EStr  : ST04;
  EStr2 : ST04;
  HandF : Hand;
  Long1 : IntL;
  NStr  : ST09;
  Word0 : Word;
  Word1 : Word;

Procedure ReadIn3(Index: IntL);
Var
  DStr  : ST67;
  EStr  : ST04;
  HandT : Hand;
  NStr  : ST09;
Function  Help1: Bool;
Var
  Byte0 : Byte;
  Stri0 : ST80;
Begin
  Help1:=BF;
  For Byte0:=000 To MaxHandlesF Do
  If ArrFHndF[Byte0] And 65280=000 Then
  With FileRec(ArrFVarF[Byte0]) Do
  Begin
    Stri0[000]:=#080;
    Move(Name,Stri0[001],080);
    Stri0[000]:=Chr(Pos(#000,Stri0)-001);
    If Stri0=DStr+NStr Then
    Begin
      Help1:=BT;
      Exit;
    End;
  End;
  For Byte0:=000 To MaxHandlesT Do
  If ArrFHndT[Byte0] And 65280=000 Then
  With FileRec(ArrFVarT[Byte0]) Do
  Begin
    Stri0[000]:=#080;
    Move(Name,Stri0[001],080);
    Stri0[000]:=Chr(Pos(#000,Stri0)-001);
    If Stri0=DStr+NStr Then
    Begin
      Help1:=BT;
      Exit;
    End;
  End;
End;
Begin
  With DirInfo Do
  Begin
    With DirVec[DI] Do
    Begin
      DName:=Name;
      DAttr:=Attr;
      DTime:=Time;
      DSize:=Size;
      DReserv:=000;
      MoveDVecToXMS(DI,Index);
    End;
  End;
End;

Begin

  GetCountFiles(DI,SStr,SAttr,BDots);
  If Not BooleanErr Then
  Begin
    If BoolMainRoot Then BDots:=BF;
    Long1:=Count+001;
    Long1:=Long1*SizeOf(DirRec);
    If Long1>65000 Then
    Begin
      DirHandle[DI]:=XMSGetHandle('DIR'+Chr(DI),Long1);
      DirSel2[DI]:=GetBuf(SizeOf(DirRec),Word0,Word1);
      MemErrorOut('ReadIn2',Word0,000);
      DirSeg2[DI]:=ACTUALSEG;
    End
    Else
    Begin
      DirSel3[DI]:=GetBuf(Long1,Word0,Word1);
      MemErrorOut('ReadIn2',Word0,000);
    End;
    FSplit(SStr,DStr,NStr,EStr);
    DirEA[DI]:=Count-001;
    Cntr:=000;
    Begin
      Repeat
        Byte0:=Pos(',',EStr);
        If Byte0>000 Then
        Begin
          EStr2:=Copy(EStr,001,Byte0-001);
          Delete(EStr,001,Byte0-001);
          EStr[001]:='.';
        End
        Else
        EStr2:=EStr;
        SStr:=DStr+NStr+EStr2;
        With DirInfo Do
        Begin
          With DirVec[DI] Do
          Begin
            If BDots Then
            Begin
              BDots:=BF;
              FindFirst(SStr,SAttr,DirInfo);
              If Name<>'.' Then
              Begin
                If Name='..' Then
                Begin
                  ReadIn3(Cntr);
                  Inc(Cntr);
                End
                Else
                Begin
                  DName:='..';
                  DAttr:=016;
                  DTime:=000;
                  DSize:=000;
                  DReserv:=000;
                  MoveDVecToXMS(DI,Cntr);
                  Inc(Cntr);
                  ReadIn3(Cntr);
                  Inc(Cntr);
                End;
              End
              Else
              Begin
                FindNext(DirInfo);
                ReadIn3(Cntr);
                Inc(Cntr);
              End;
            End
            Else
            Begin
              FindFirst(SStr,SAttr,DirInfo);
              If Name='.' Then FindNext(DirInfo)
              Else
              If Name<>'..' Then
              Begin
                ReadIn3(Cntr);
                Inc(Cntr);
              End;
            End;
            While (DosError=000) And (Cntr<Count) Do
            Begin
              FindNext(DirInfo);
              If DosError=000 Then
              Begin
                ReadIn3(Cntr);
                Inc(Cntr);
              End;
            End;
          End;
        End;
      Until Byte0=000;
    End;
  End
  Else
  DI:=255;

End;




Procedure SetWin1(Var DI: Hand);
Var
  IndexWin      : Byte;

Begin

  IndexWin:=IndexLine-IndexPage*064;
  WriteF32(DI,IndexWin);

End;




Procedure SetWin2(Var DI: Hand);
Var
  IndexWin      : Byte;

Begin

  IndexWin:=IndexLine-IndexPage*064;
  WriteF3(DI,IndexWin);

End;




Procedure SortDir(Var DI: Hand);
Var
  Attr1      : Byte;
  Attr2      : Byte;
  BEvent     : Bool;
  BoolBefore : Bool;
  Byte0      : Byte;
  Byte1      : Byte;
  Byte2      : Byte;
  Count      : IntL;
  DirHandle2 : Hand;
  DSegSort   : Word;
  DurchGang  : IntL;
  FileIndex  : IntL;
  Index      : IntL;
  Laenge1    : IntL;
  LaengeL    : IntL;
  LaengeR    : IntL;
  LastD      : IntL;
  Long0      : IntL;
  Long1      : IntL;
  Name1      : ST13;
  Name2      : ST13;
  PointerL   : IntL;
  PointerR   : IntL;
  Reserv1    : Word;
  Reserv2    : Word;
  Size1      : IntL;
  Size2      : IntL;
  SortVec2   : DirRec;
  Time1      : IntL;
  Time2      : IntL;
  SHWB0      : Bool;
  SHWB1      : Bool;
  SHWH0      : Hand;
  SHWH1      : Hand;
  Word0      : Word;
  Word1      : Word;

Procedure MoveDXMSToSXMS(IndexS,IndexT: IntL);
Begin
  If DirSel3[DI]=000 Then
  Begin
    With XMSMOVSTRUC Do
    Begin
      XMSLen:=SizeOf(DirRec);
      HandleS:=XMSHANDLE;
      OffsS:=XMSOFFSETS[XMSGHand2(DirHandle[DI])]+IndexS*SizeOf(DirRec);
      HandleT:=XMSHANDLE;
      OffsT:=XMSOFFSETS[XMSGHand2(DirHandle2)]+IndexT*SizeOf(DirRec);
    End;
    XMSCallFunc(XMSGHand2(DirHandle[DI]),MoveEMB);
  End
  Else
  Begin
    Move(Mem[DirSel3[DI]:IndexS*SizeOf(DirRec)],
    Mem[DSegSort:IndexT*SizeOf(DirRec)],SizeOf(DirRec));
  End;
End;

Procedure MoveSXMSToDXMS;
Begin
  If DirSel3[DI]=000 Then
  Begin
    With XMSMOVSTRUC Do
    Begin
      HandleS:=XMSHANDLE;
      HandleT:=XMSHANDLE;
      XMSLen:=(Count+001)*SizeOf(DirRec);
      OffsS:=XMSOFFSETS[XMSGHand2(DirHandle2)];
      OffsT:=XMSOFFSETS[XMSGHand2(DirHandle[DI])];
    End;
    XMSCallFunc(XMSGHand2(DirHandle[DI]),MoveEMB);
  End
  Else
  Begin
    Move(Mem[DSegSort:000],Mem[DirSel3[DI]:000],(Count+001)*SizeOf(DirRec));
  End;
End;

Procedure TempI;
Begin
  If DirEA[DI]>048 Then
  SWCSubPr.TempI;
End;

Procedure TempO;
Begin
  If DirEA[DI]>048 Then
  SWCSubPr.TempO;
End;

Begin

  If DirEA[DI]>=001 Then
  Begin
    TempI;
    SHWB0:=BT;
    Long1:=(DirEA[DI]+001)*SizeOf(DirRec);
    If DirSel3[DI]=000 Then
    DirHandle2:=XMSGetHandle('DSORT'+Chr(DI),Long1)
    Else
    Begin
      DSegSort:=GetBuf((DirEA[DI]+001)*SizeOf(DirRec),Word0,Word1);
      MemErrorOut('SortDir',Word0,000);
    End;
    FileIndex:=000;
    Count:=DirEA[DI];
    LastD:=000;
    Long0:=Count;
    If Long0>001 Then
    Repeat
      Long0:=Long0 ShR 001;
      Inc(LastD);
    Until Long0=001;
    With DirVec[DI] Do
    Repeat
      Inc(FileIndex);
      If DirEA[DI]>048 Then
      ShowP('Please wait',SHWB0,SHWH0,020,030,007,FileIndex-001,LastD,BF);
      Laenge1:=001 ShL (FileIndex-001);
      LaengeL:=Laenge1;
      LaengeR:=Laenge1;
      PointerL:=000;
      PointerR:=PointerL+Laenge1;
      If PointerR+LaengeR>Count Then LaengeR:=Count-Laenge1+001;
      DurchGang:=000;
      Index:=000;
      SHWB1:=BT;
      Repeat
        While (LaengeL>000) And (LaengeR>000) Do
        Begin
          If DirEA[DI]>048 Then
          ShowP('Sorting',SHWB1,SHWH1,030,025,016,Index,Count,BF);
          BEvent:=BF;
          Byte0:=000;
          MoveXMSToDVec(DI,PointerL);
          Name1:=DName;
          Attr1:=DAttr;
          Time1:=DTime;
          Size1:=DSize;
          Reserv1:=DReserv;
          MoveXMSToDVec(DI,PointerR);
          Name2:=DName;
          Attr2:=DAttr;
          Time2:=DTime;
          Size2:=DSize;
          Reserv2:=DReserv;
          Repeat
            If  (Attr1 And 016=016)
            And (Attr2 And 016<>016) Then
            Begin
              BEvent:=BT;
              BoolBefore:=BT;
            End
            Else
            If  (Attr1 And 016<>016)
            And (Attr2 And 016=016) Then
            Begin
              BEvent:=BT;
              BoolBefore:=BF;
            End
            Else
            If  (Byte0<=Length(Name1))
            And (Byte0<=Length(Name2))
            And (Name1[001+Byte0]>Name2[001+Byte0]) Then
            Begin
              BEvent:=BT;
              BoolBefore:=BF;
            End
            Else
            If  (Byte0<=Length(Name1))
            And (Byte0<=Length(Name2))
            And (Name1[001+Byte0]<Name2[001+Byte0]) Then
            Begin
              BEvent:=BT;
              BoolBefore:=BT;
            End
            Else
            If ((Length(Name1)<Length(Name2)) And (Byte0>Length(Name1)))
            Or ((Length(Name2)<Length(Name1)) And (Byte0>Length(Name2))) Then
            If Byte0>Length(Name1) Then
            Begin
              BEvent:=BT;
              BoolBefore:=BT;
            End
            Else
            Begin
              BEvent:=BT;
              BoolBefore:=BF;
            End;
            Inc(Byte0);
          Until (Byte0>012) Or BEvent;
          If Not BoolBefore Then
          Begin
            MoveDXMSToSXMS(PointerR,Index);
            Inc(PointerR);
            Dec(LaengeR);
          End
          Else
          Begin
            MoveDXMSToSXMS(PointerL,Index);
            Inc(PointerL);
            Dec(LaengeL);
          End;
          Inc(Index);
        End;
        If LaengeR>000 Then
        For Long0:=LaengeR-001 DownTo 000 Do
        Begin
          If DirEA[DI]>048 Then
          ShowP('Sorting',SHWB1,SHWH1,030,025,016,Index,Count,BF);
          MoveDXMSToSXMS(PointerR,Index);
          Inc(PointerR);
          Inc(Index);
        End;
        If LaengeL>000 Then
        For Long0:=LaengeL-001 DownTo 000 Do
        Begin
          If DirEA[DI]>048 Then
          ShowP('Sorting',SHWB1,SHWH1,030,025,016,Index,Count,BF);
          MoveDXMSToSXMS(PointerL,Index);
          Inc(PointerL);
          Inc(Index);
        End;
        Inc(DurchGang);
        PointerL:=DurchGang*(1 ShL FileIndex);
        PointerR:=PointerL+Laenge1;
        LaengeL:=Laenge1;
        LaengeR:=Laenge1;
        If PointerR+LaengeR>Count Then LaengeR:=Count-PointerR+001;
      Until PointerR>Count;
      If PointerL<=Count Then
      For Long0:=PointerL To Count Do
      Begin
        If DirEA[DI]>048 Then
        ShowP('Sorting',SHWB1,SHWH1,030,025,016,Long0,Count,BF);
        MoveDXMSToSXMS(Long0,Index);
        Inc(Index);
      End;
      MoveSXMSToDXMS;
    Until Count-(001 ShL FileIndex)<000;
    If DirSel3[DI]=000 Then
    XMSFree('DSORT'+Chr(DI))
    Else
    Begin
      FreeBuf(DSegSort,Word0);
      MemErrorOut('SortDir',Word0,000);
    End;
    BooleanErr:=BF;
    TempO;
  End;

End;




Procedure WriteF3(Var DI: Hand;IndexWin: Byte);
Const
  Stri0   : ST16=('0123456789012345');

Var
  Attr    : Byte;
  DStr    : ST67;
  EStr    : ST04;
  NStr    : ST09;
  PStr    : ST79;
  Reserv  : Word;

Begin

  FillChar(Stri0[001],016,032);
  MoveXMSToDVec(DI,IndexPage*064+IndexWin);
  With DirVec[DI] Do
  Begin
    PStr:=DName;
    Attr:=DAttr;
    Reserv:=DReserv;
  End;
  FSplit(PStr,DStr,NStr,EStr);
  StringInString(NStr,Stri0,001);
  If EStr<>'..' Then
  StringInString(EStr,Stri0,010)
  Else
  StringInString(EStr,Stri0,001);
  If Reserv And 001=001 Then StringInString('+',Stri0,014);
  WriteInRAM(Stri0+'  ',HelpGetX(IndexWin),HelpGetY(IndexWin),030,030);
  If Attr And 016=016 Then
  WriteInRAM('<DIR',HelpGetX(IndexWin)+014,HelpGetY(IndexWin),030,030);

End;




Procedure WriteF32(Var DI: Hand;IndexWin: Byte);
Var
  Attr   : Byte;
  AttriS : ST06;
  DT     : DTim;
  DStr   : ST67;
  EStr   : ST04;
  NStr   : ST09;
  PStr   : ST79;
  Reserv : Word;
  Size   : IntL;
  Stri0  : ST80;
  Stri1  : ST80;
  Stri2  : ST80;
  Time   : IntL;

Begin

  MoveXMSToDVec(DI,IndexLine);
  With DirVec[DI] Do
  Begin
    PStr:=DName;
    Attr:=DAttr;
    Time:=DTime;
    Size:=DSize;
    Reserv:=DReserv;
  End;
  Str(Size:011,Stri0);
  Stri0:=Stri0+' Bytes';
  UnpackTime(Time,DT);
  With DT Do
  Begin
    Stri0:=Stri0+'  ';
    Str(day:002,Stri2);
    Stri1:=Stri2+'.';
    Str(Month:002,Stri2);
    Stri1:=Stri1+Stri2+'.';
    Str(Year:004,Stri2);
    Stri1:=Stri1+Stri2;
    Stri1:=FillString(Stri1,#032,#048);
    Stri0:=Stri0+Stri1+'  ';
    Str(Hour:002,Stri2);
    Stri1:=Stri2+':';
    Str(Min:002,Stri2);
    Stri1:=Stri1+Stri2+':';
    Str(Sec:002,Stri2);
    Stri1:=Stri1+Stri2;
    Stri1:=FillString(Stri1,#032,#048);
    Stri0:=Stri0+Stri1+'  ';
  End;
  AttriS:='------';
  If Attr And 001=001 Then AttriS[001]:='R';
  If Attr And 002=002 Then AttriS[002]:='H';
  If Attr And 004=004 Then AttriS[003]:='S';
  If Attr And 008=008 Then AttriS[004]:='V';
  If Attr And 016=016 Then AttriS[005]:='D';
  If Attr And 032=032 Then AttriS[006]:='A';
  Stri0:=Stri0+'Attribute:';
  Stri0:=Stri0+AttriS;
  WriteVR(Stri0,008,021);
  Stri0[000]:=#016;
  FillChar(Stri0[001],016,032);
  FSplit(PStr,DStr,NStr,EStr);
  StringInString(NStr,Stri0,001);
  If EStr<>'..' Then
  StringInString(EStr,Stri0,010)
  Else
  StringInString(EStr,Stri0,001);
  If Reserv And 001=001 Then StringInString('+',Stri0,014);
  WriteInRAM(Stri0+'  ',HelpGetX(IndexWin),HelpGetY(IndexWin),078,078);
  If Attr And 016=016 Then
  WriteInRAM('<DIR',HelpGetX(IndexWin)+014,HelpGetY(IndexWin),078,078);

End;




END.
