Unit SWCSubE;

{$F+}

Interface


Uses CRT,
     DOS,
     SWCFNB,
     SWCVaria;


Procedure EBlock(OStr: STFF;Name: ST08;
          TextX,TextY,XPos,YPos: Byte;BShadow: Bool);
Procedure EBlockRead2F(HNum: Hand;Var VR;CntrR: Word;Var CntrHR: Word);
Procedure EBlockRead2T(HNum: Hand;Var VR;CntrR: Word;Var CntrHR: Word);
Procedure EBlockWrite2F(HNum: Hand;Var VW;CntrW: Word;Var CntrHW: Word);
Function  EChkStrInBetween(StrFrom,StrChk,StrUpto: STFF): Bool;
Procedure ECommitFile(VTyp: VTyps;HNum: Hand);
Function  EEOF2F(HNum: Hand): Bool;
Procedure EErrHandIO2(Error: Word;PIONam: ProcsIO;HNum: Hand);
Function  EFilePos2F(HNum: Hand): IntL;
Function  EFilePos2T(HNum: Hand): IntL;
Function  EFileSize2F(HNum: Hand): IntL;
Function  EFileSize2T(HNum: Hand): IntL;
Function  EGetDOSError(ECode: IntM): ST80;
Function  EGetExtendedError(regax: Word;regbh,regbl,regch: Byte): STFF;
Function  EGetHandleFromPath(GPath: ST79): Hand;
Procedure EOFile(VTyp: VTyps;Var HNum: Hand;
          FPath: ST79;OMod: OMods;RSize: Word);
Procedure EOFile2(VTyp: VTyps;Var HNum: Hand;
          FPath: ST79;OMod: OMods;RSize: Word);
Procedure EScreenParams(BSave: Bool);
Procedure ESeek2F(HNum: Hand;SIntL: IntL);
Procedure ESeek2T(HNum: Hand;SIntL: IntL);
Procedure ESetFTime(VTyp: VTyps;HNum: Hand;Time: IntL);
Procedure ESetUnUsed(HNum: Hand);
Procedure ETruncate2F(HNum: Hand);



Implementation



Uses SWCMask,
     SWCPGX,
     SWCUtil,
     SWCSubPr;




Procedure EBlock(OStr: STFF;Name: ST08;
          TextX,TextY,XPos,YPos: Byte;BShadow: Bool);
Label WARSCHON;

Const
  diffx      : Byte=000;
  diffy      : Byte=000;
  lastnam    : ST08='';

Var
  bbuf       : array[000..079] Of Byte;
  HandF      : Hand;
  loop1      : Word;
  loop2      : Word;
  mskofs     : Word;
  mskseg     : Word;
  msksiz     : Word;
  UmBruchC   : Byte;
  UmBruchD   : Byte;
  UmBruchH   : Byte;
  UmBruchV   : Byte;
  Word0      : Word;
  Word1      : Word;
  Word2      : Word;

Begin

  CrsrOff;
  If LastNam=Name Then Goto WARSCHON;
  If Name<>'' Then
  Begin
    OFileF(HandF,PRGPATH+'\'+Name+'.BPN',FRead,001);
    If IOResult2=000 Then
    Begin
      BLKPAKSEG:=GetBuf(4000,Word0,Word1);
      MemErrorOut('Block',Word0,000);
      BlockRead(HandF,Mem[BLKPAKSEG:0],FileSize(HandF),CntrHROW0);
      OFileF(HandF,'',FClose,001);
      Move(Mem[BLKPAKSEG:000],MskSiz,002);
      Move(Mem[BLKPAKSEG:002],ArrayPoint[000],004);
      Move(Mem[BLKPAKSEG:006],Mem[BLKPAKSEG:0],MskSiz-004);
      DiffX:=ArrayPoint[002]-ArrayPoint[000];
      DiffY:=ArrayPoint[003]-ArrayPoint[001];
      UnPackBlk((DiffX+001)*(DiffY+001));
      FreeBuf(BLKPAKSEG,Word0);
      MemErrorOut('Block',Word0,000);
    End
    Else
    Exit;
  End;
  LastNam:=Name;
  WARSCHON:
  UmBruchC:=000;
  UmBruchH:=000;
  UmBruchV:=000;
  If OStr<>'' Then
  For loop1:=001 to length(OStr) do
  Begin
    bbuf[loop1-001]:=Mem[ARRAYBL:texty*(diffx+001)+textx+(loop1-001)];
    If OStr[Loop1]=#013 Then
    If OStr[Loop1+001]=#010 Then
    Begin
      UmBruchD:=UmBruchC;
      Inc(UmBruchH,002);
      Inc(UmBruchV);
      UmBruchC:=000;
    End;
    If Loop1+UmBruchH<=Length(OStr) Then
    Mem[ARRAYBL:(UmBruchV+texty)*(diffx+001)+
    textx+(loop1-001)-(UmBruchD*UmBruchV)]:=Ord(OStr[loop1+UmBruchH]);
    Inc(UmBruchC);
  End;
  Word0:=000;
  For loop1:=000 to diffy do
  For loop2:=000 to diffx do
  Begin
    Mem[SegB800:ypos*160+xpos*002+loop1*160+loop2*002]:=Mem[ARRAYBL:Word0];
    Inc(Word0);
  End;
  For loop1:=000 to diffy do
  For loop2:=000 to diffx do
  Begin
    Mem[SegB800:ypos*160+xpos*002+loop1*160+loop2*002+001]:=Mem[ARRAYBL:Word0];
    Inc(Word0);
  End;
  If BShadow Then
  Begin
    For loop1:=001 to diffy do
    For loop2:=diffx+001 to diffx+002 do
    Mem[SegB800:ypos*160+xpos*002+loop1*160+loop2*002+001]:=008;
    For loop1:=000 to diffx do
    Mem[SegB800:ypos*160+xpos*002+(diffy+001)*160+004+loop1*002+001]:=008;
  End;
  If OStr<>'' Then
  For loop1:=000 to length(OStr)-001 do
  Mem[ARRAYBL:texty*(diffx+001)+textx+loop1]:=bbuf[loop1];

End;




Procedure EBlockRead2F(HNum: Hand;Var VR;CntrR: Word;Var CntrHR: Word);
Begin

  {$I-} System.BlockRead(ArrFVarF[HNum],VR,CntrR,CntrHR); {$I+}
  IOResult2:=IOResult;

End;




Procedure EBlockRead2T(HNum: Hand;Var VR;CntrR: Word;Var CntrHR: Word);
Begin

  {$I-} System.BlockRead(ArrFVarT[HNum],VR,CntrR,CntrHR); {$I+}
  IOResult2:=IOResult;

End;




Procedure EBlockWrite2F(HNum: Hand;Var VW;CntrW: Word;Var CntrHW: Word);
Var
  Stri0 : ST12;

Begin

  With FileRec(ArrFVarF[HNum]) Do
  Begin
    {$I-} System.BlockWrite(ArrFVarF[HNum],VW,CntrW,CntrHW); {$I+}
    IOResult2:=IOResult;
    UserData[015]:=UserData[015] Or 001;
  End;

End;




Function  ECheckChanged(HNum: Hand): Bool;
Begin

  ECheckChanged:=BF;
  With FileRec(ArrFVarF[HNum]) Do
  If UserData[015] And 001=001 Then
  ECheckChanged:=BT;

End;




Function  EChkStrInBetween(StrFrom,StrChk,StrUpto: STFF): Bool;
Type
  SizeRelation = (FromGleich,FromGroesser,FromKleiner,
                  UpToGleich,UpToGroesser,UpToKleiner);
  Signals      = (StopErrNo,StopErrJa,Weiter);

Var
  ArrSizeFrom : Array[001..256] Of SizeRelation;
  ArrSizeUpTo : Array[001..256] Of SizeRelation;
  BoolFromAkt : Bool;
  BoolUpToAkt : Bool;
  Byte0       : Byte;
  Byte1       : Byte;
  Schalter    : Signals;

Begin

  Byte0:=Length(StrChk);
  For Byte1:=001 To Byte0 Do
  Begin
    If StrChk[Byte1]='?' Then
    Begin
      ArrSizeFrom[Byte1]:=FromGleich;
      ArrSizeUpTo[Byte1]:=UpToGleich;
    End
    Else
    Begin
      If StrChk[Byte1]=StrFrom[Byte1] Then ArrSizeFrom[Byte1]:=FromGleich;
      If StrChk[Byte1]=StrUpTo[Byte1] Then ArrSizeUpTo[Byte1]:=UpToGleich;
      If StrChk[Byte1]>StrFrom[Byte1] Then ArrSizeFrom[Byte1]:=FromGroesser;
      If StrChk[Byte1]>StrUpTo[Byte1] Then ArrSizeUpTo[Byte1]:=UpToGroesser;
      If StrChk[Byte1]<StrFrom[Byte1] Then ArrSizeFrom[Byte1]:=FromKleiner;
      If StrChk[Byte1]<StrUpTo[Byte1] Then ArrSizeUpTo[Byte1]:=UpToKleiner;
    End;
  End;
  Byte1:=001;
  BoolFromAkt:=BT;
  BoolUptoAkt:=BT;
  Schalter:=Weiter;
  Repeat
    If  ArrSizeFrom[Byte1]=FromGroesser   Then BoolFromAkt:=BF;
    If  ArrSizeUpTo[Byte1]=UpToKleiner    Then BoolUpToAkt:=BF;
    If  BoolFromAkt Then
    If  (ArrSizeFrom[Byte1]=FromGleich)   Then Schalter:=Weiter;
    If  BoolFromAkt Then
    If  (ArrSizeFrom[Byte1]=FromGroesser)
    And (ArrSizeUpTo[Byte1]=UpToKleiner)  Then Schalter:=StopErrNo;
    If  BoolFromAkt Then
    If  ArrSizeFrom[Byte1]=FromKleiner    Then Schalter:=StopErrJa;
    If  ArrSizeUpTo[Byte1]=UpToGroesser   Then Schalter:=StopErrJa;
    If  Not BoolFromAkt Then
    If  ArrSizeUpTo[Byte1]=UpToKleiner    Then Schalter:=StopErrNo;
    If  Not BoolUpToAkt Then
    If  ArrSizeFrom[Byte1]=FromGroesser   Then Schalter:=StopErrNo;
    If  Not BoolUpToAkt Then
    If  ArrSizeFrom[Byte1]=FromGleich     Then Schalter:=Weiter;
    If  Schalter=Weiter Then Inc(Byte1);
  Until (Schalter=StopErrJa)
  Or    (Schalter=StopErrNo)
  Or    (Byte1>Byte0);
  Case Schalter Of
  Weiter      : EChkStrInBetween:=BT;
  StopErrJa   : EChkStrInBetween:=BF;
  StopErrNo   : EChkStrInBetween:=BT;
  End;

End;




Procedure ECommitFile(VTyp: VTyps;HNum: Hand);
Var
  Regs0 : Regi;

Begin

  With Regs0 Do
  Begin
    If VTyp=FVarF Then
    With FileRec(ArrFVarF[HNum]) Do BX:=Handle
    Else
    If VTyp=FVarT Then
    With FileRec(ArrFVarT[HNum]) Do BX:=Handle;
    AH:=$68;
    Intr($21,Regs0);
    If Flags And FCarry>000 Then
    ErrorOut('ECommitFile:'+GetDosError(AX),001,'',#000);
  End;

End;




Function  EEOF2F(HNum: Hand): Bool;
Begin

  {$I-} EEOF2F:=System.EOF(ArrFVarF[HNum]); {$I+}
  IOResult2:=IOResult;

End;




Procedure EErrHandIO2(Error: Word;PIONam: ProcsIO;HNum: Hand);
Var
  EKey    : STFF;
  EMsg    : STFF;
  ExtendC : Char;
  ExtendS : ST30;
  FVarTyp : VTyps;
  FVarTyS : ST10;
  ODF2    : ST79;
  ProcNam : ST20;

Begin

  If Error>000 Then
  Begin
    Case PIONam Of
    PNBlockRead :  Begin
                     FVarTyp:=FVarF;
                     ProcNam:='BlockRead';
                   End;
    PNBlockWrite : Begin
                     FVarTyp:=FVarF;
                     ProcNam:='BlockWrite';
                   End;
    PNEOF_F :      Begin
                     FVarTyp:=FVarF;
                     ProcNam:='EOF_F';
                   End;
    PNEOF_T :      Begin
                     FVarTyp:=FVarT;
                     ProcNam:='EOF_T';
                   End;
    PNFilePos :    Begin
                     FVarTyp:=FVarF;
                     ProcNam:='FilePos';
                   End;
    PNFileSize :   Begin
                     FVarTyp:=FVarF;
                     ProcNam:='FileSize';
                   End;
    PNRead :       Begin
                     FVarTyp:=FVarT;
                     ProcNam:='Read';
                   End;
    PNReadLn :     Begin
                     FVarTyp:=FVarT;
                     ProcNam:='ReadLn';
                   End;
    PNReadLnB :    Begin
                     FVarTyp:=FVarT;
                     ProcNam:='ReadLnB';
                   End;
    PNReadLnS :    Begin
                     FVarTyp:=FVarT;
                     ProcNam:='ReadLnS';
                   End;
    PNReadLnW :    Begin
                     FVarTyp:=FVarT;
                     ProcNam:='ReadLnW';
                   End;
    PNSeek :       Begin
                     FVarTyp:=FVarT;
                     ProcNam:='Seek';
                   End;
    PNTruncate :   Begin
                     FVarTyp:=FVarF;
                     ProcNam:='Truncate';
                   End;
    PNWrite :      Begin
                     FVarTyp:=FVarT;
                     ProcNam:='Write';
                   End;
    PNWriteLn :    Begin
                     FVarTyp:=FVarT;
                     ProcNam:='WriteLn';
                   End;
    PNWriteS :     Begin
                     FVarTyp:=FVarT;
                     ProcNam:='WriteS';
                   End;
    Else
    ErrorOut('ErrHandIO: Invalid procedure name',001,'',#000);
    End;
    Case FVarTyp Of
    FVarF :  FVarTyS:='FVarF';
    FVarT :  FVarTyS:='FVarT';
    Else
    ErrorOut('ErrHandIO: Invalid filevariables typ',001,'',#000);
    End;
    Repeat
      Begin
        EMsg:=ProcNam+': '+FVarTyS+': '+GetDosError(Error)+
        ' - PLease choose your favourite option: ';
        EKey:='~Programend~try once more'+
        'E~xit';
      End;
      ErrorOut(EMsg,000,EKey,ExtendC);
      Case Char0 Of
      'T' : Begin
              WaitClr;
              Exit;
            End;
      'P' : System.Halt(002);
      'X' : Begin
              BooleanEx:=BT;
              Exit;
            End;
      End;
    Until BooleanEx And Not BooleanEx;
  End;

End;




Function  EFilePos2F(HNum: Hand): IntL;
Begin

  {$I-} EFilePos2F:=System.FilePos(ArrFVarF[HNum]); {$I+}
  IOResult2:=IOResult;

End;




Function  EFilePos2T(HNum: Hand): IntL;
Begin

  {$I-} EFilePos2T:=System.FilePos(ArrFVarT[HNum]); {$I+}
  IOResult2:=IOResult;

End;




Function  EFileSize2F(HNum: Hand): IntL;
Begin

  {$I-} EFileSize2F:=System.FileSize(ArrFVarF[HNum]); {$I+}
  IOResult2:=IOResult;

End;




Function  EFileSize2T(HNum: Hand): IntL;
Begin

  {$I-} EFileSize2T:=System.FileSize(ArrFVarT[HNum]); {$I+}
  IOResult2:=IOResult;

End;




Function  EGetDOSError(ECode: IntM): ST80;
Var
  Stri0 : STFF;

Begin

  Case ECode Of
  000 : Stri0:='No error';
  001 : Stri0:='Invalid function number';
  002 : Stri0:='File not found';
  003 : Stri0:='Path not found';
  004 : Stri0:='Too many open files';
  005 : Stri0:='File access denied';
  006 : Stri0:='Invalid file handle';
  007 : Stri0:='Memory Control Block destroyed';
  008 : Stri0:='Not enough memory';
  009 : Stri0:='Unknown segment adress';
  010 : Stri0:='Invalid environment table';
  011 : Stri0:='Invalid parameter block';
  012 : Stri0:='Invalid file access code';
  015 : Stri0:='Invalid drive number';
  016 : Stri0:='Cannot remove current directory';
  017 : Stri0:='Cannot rename across drives';
  018 : Stri0:='No more entries';
  100 : Stri0:='Disk read error';
  101 : Stri0:='Disk write error';
  102 : Stri0:='File not assigned';
  103 : Stri0:='File not open';
  104 : Stri0:='File not open for input';
  105 : Stri0:='File not open for output';
  106 : Stri0:='Invalid numeric format';
  150 : Stri0:='Disk is write-protected';
  151 : Stri0:='Bad drive request struct length (655)';
  152 : Stri0:='Drive not ready';
  154 : Stri0:='CRC error in data';
  156 : Stri0:='Disk seek error';
  157 : Stri0:='Unknown media type';
  158 : Stri0:='Sector Not Found';
  159 : Stri0:='Printer out of paper';
  160 : Stri0:='Device write fault';
  161 : Stri0:='Device read fault';
  162 : Stri0:='Hardware failure';
  200 : Stri0:='Division by zero';
  201 : Stri0:='Range check error';
  202 : Stri0:='Stack overflow error';
  203 : Stri0:='Heap overflow error';
  204 : Stri0:='Invalid pointer operation';
  205 : Stri0:='Floating point overflow';
  206 : Stri0:='Floating point underflow';
  207 : Stri0:='Invalid floating point operation';
  208 : Stri0:='Overlay manager not installed';
  209 : Stri0:='Overlay file read error';
  210 : Stri0:='Object not initialized';
  211 : Stri0:='Call to abstract method';
  212 : Stri0:='Stream registration error';
  213 : Stri0:='Collection index out of range';
  214 : Stri0:='Collection overflow error';
  Else
  Begin
    Str(ECode,Stri0);
    Stri0:='Unknown Error ('+Stri0+')';
  End;
  End;
  EGetDosError:=Stri0;

End;




Function  EGetExtendedError(regax: Word;regbh,regbl,regch: Byte): STFF;
Var
  Stri0 : STFF;
  Stri1 : STFF;
  Stri2 : STFF;
  Stri3 : STFF;

Begin

  Case regax Of
  $0001 : Stri0:='Subfunktion nicht untersttzt';
  $0002 : Stri0:='Datei nicht gefunden';
  $0003 : Stri0:='Suchweg nicht gefunden';
  $0004 : Stri0:='Zuviele offene Dateien';
  $0005 : Stri0:='Zugriff abgewiesen';
  $0006 : Stri0:='Handle nicht definiert';
  $0007 : Stri0:='Speicherkontrollblocks zerstrt';
  $0008 : Stri0:='Nicht genug Speicher';
  $0009 : Stri0:='Ungltige Block-Segmentadresse';
  $000A : Stri0:='Ungltige Environment-Tabelle';
  $000B : Stri0:='Ungltiger Parameter-Block';
  $000C : Stri0:='Ungltiger Datei-Zugriffsmodus';
  $000D : Stri0:='Ungltige Daten';
  $000E : Stri0:='Reserviert';
  $000F : Stri0:='Ungltige Laufwerksbezeichnung';
  $0010 : Stri0:='Kann Verzeichnis nicht entfernen';
  $0011 : Stri0:='Kann mit Rename nicht kopieren';
  $0012 : Stri0:='Keine weiteren Eintrge';
  $0013 : Stri0:='Medium ist schreibgeschtzt';
  $0014 : Stri0:='Gert nicht definiert';
  $0015 : Stri0:='Gert nicht bereit';
  $0016 : Stri0:='Unbekannter Befehl';
  $0017 : Stri0:='Prfsumme unkorrekt';
  $0018 : Stri0:='Falsche Sektorlnge';
  $0019 : Stri0:='Spur nicht gefunden';
  $001A : Stri0:='Unbekannte Media-ID';
  $001B : Stri0:='Sektor nicht gefunden';
  $001C : Stri0:='Kein Papier im Drucker';
  $001D : Stri0:='Schreibfehler';
  $001E : Stri0:='Lesefehler';
  $001F : Stri0:='Allgemeiner Fehler';
  $0020 : Stri0:='Datei ist gesperrt';
  $0021 : Stri0:='Dateibereich gesperrt';
  $0022 : Stri0:='Datentrger unerlaubt gewechselt';
  $0023 : Stri0:='FCB-Speicherplatz erschpft';
  $0024 : Stri0:='Share-Speicherplatz erschpft';
  $0025 : Stri0:='Codeseite nicht geladen/verfgbar';
  $0026 : Stri0:='Dateiende erreicht';
  $0027 : Stri0:='Speichermedium voll';
  $0032 : Stri0:='Funktion durch Gert nicht untersttzt';
  $0033 : Stri0:='Ende der Redirektionsliste';
  $0034 : Stri0:='Name existiert bereits';
  $0035 : Stri0:='Netz-Name existiert nicht';
  $0036 : Stri0:='Server beschftigt';
  $0037 : Stri0:='Gert existiert nicht';
  $0038 : Stri0:='berzhlige Argumente';
  $0039 : Stri0:='Netz-Hardware-Fehler';
  $003A : Stri0:='Netz-bertragungsfehler';
  $003B : Stri0:='Genereller Netzfehler';
  $003C : Stri0:='Fehler antwortende Netz-Schnittstelle';
  $003D : Stri0:='PRINT.EXE: Drucker-Warteschlange voll';
  $003E : Stri0:='PRINT.EXE: Nicht genug Speicher';
  $003F : Stri0:='PRINT.EXE: Druck abgebrochen';
  $0040 : Stri0:='Eintrag Redirektionsliste unbesetzt';
  $0041 : Stri0:='Netz-Zugriff abgewiesen';
  $0042 : Stri0:='Gertetyp fr Funktion nicht verwendbar';
  $0043 : Stri0:='Netz-Name ungltig';
  $0044 : Stri0:='Netz-Name zuviele Komponenten';
  $0045 : Stri0:='Switcher: Session-Liste voll';
  $0046 : Stri0:='SHARE.EXE: momentan keine gemeinsamen Zugriffe mgl.';
  $0047 : Stri0:='Anforderung nicht akzeptiert';
  $0048 : Stri0:='Gerte-Umleitung momentan unterdrckt';
  $0050 : Stri0:='Datei existiert bereits';
  $0051 : Stri0:='FCB existiert mehrfach';
  $0052 : Stri0:='Verzeichnis existiert bereits';
  $0053 : Stri0:='Abbruch nach Interrupt 24h';
  $0054 : Stri0:='Interner Speicher voll';
  $0055 : Stri0:='Laufwerk bereits zugeordnet';
  $0056 : Stri0:='Pawort ungltig';
  $0057 : Stri0:='Parameter ungltig';
  $0058 : Stri0:='Netz-Schreibfehler';
  $005A : Stri0:='ERROR_SYS_COMP_NOT_LOADED';
  Else Stri0:='Unknown Error';
  End;

  Case regbh Of
  $01 : Stri1:='Fehlende Ressorcen';
  $02 : Stri1:='Temporres Problem';
  $03 : Stri1:='Nicht autorisierter Zugriff';
  $04 : Stri1:='Betriebssystemfehler 1';
  $05 : Stri1:='Hardware-Problem';
  $06 : Stri1:='Betriebssystemfehler 2';
  $07 : Stri1:='Fehler der Anwendung';
  $08 : Stri1:='Objekt nicht gefunden';
  $09 : Stri1:='Objekt in unbekanntem Format';
  $0A : Stri1:='Objekt gesperrt';
  $0B : Stri1:='Unbekanntes Speichermedium';
  $0C : Stri1:='Objekt existiert bereits';
  $0D : Stri1:='Nicht weiter definierbare Fehlerklasse';
  $0E : Stri1:='Operation lt sich nicht ausfhren';
  $0F : Stri1:='Zeitberschreitung';
  Else Stri1:='Unbekannte Fehlerklasse';
  End;

  Case regbl Of
  $01 : Stri2:='Operation sofort wiederholen';
  $02 : Stri2:='Operation nach Pause wiederholen';
  $03 : Stri2:='Neueingabe';
  $04 : Stri2:='Programm nach Abschluprozeduren beenden';
  $05 : Stri2:='Programm sofort beenden';
  $06 : Stri2:='Fehler ignorieren';
  $07 : Stri2:='Problem beseitigen';
  Else Stri2:='Unbekannter Aktionsvorschlag';
  End;

  Case regch Of
  $01 : Stri3:='Nicht weiter definierter Fehlerort';
  $02 : Stri3:='Blockorientiertes Speichermedium';
  $03 : Stri3:='Netzwerkproblem';
  $04 : Stri3:='Speicher';
  $05 : Stri3:='Zeichenorientiertes Gert';
  Else Stri3:='Unbekannter Fehlerort';
  End;
  Stri0:='FEHLER: '+Stri0+' - KLASSE: '+Stri1+
  ' - ORT: '+Stri3+' - AKTIONSVORSCHLAG: '+Stri2;
  EGetExtendedError:=Stri0;

End;




Function  EGetHandleFromPath(GPath: ST79): Hand;
Begin

  EGetHandleFromPath:=255;

End;




Function  EGetPRGVersion(Path: ST79): ST14;
Var
  DTim0 : DTim;
  File0 : File;
  FMode : IntM;
  Long0 : IntL;
  Stri0 : St04;
  Stri1 : St14;

Begin

  FMode:=FileMode;
  FileMode:=$42;
  Assign(File0,Path);
  {$I-} Reset(File0); {$I+}
  If IOResult=000 Then
  Begin
    DOS.GetFTime(File0,Long0);
    {$I-} Close(File0); {$I+}
    IOResult2:=IOResult;
    UnPackTime(Long0,DTim0);
    With DTim0 Do
    Begin
      Str(Year,Stri1);
      Str(Month:002,Stri0);
      Stri0:=FillString(Stri0,#032,#048);
      Stri1:=Stri1+Stri0;
      Str(Day:002,Stri0);
      Stri0:=FillString(Stri0,#032,#048);
      Stri1:=Stri1+Stri0;
      Str(Hour:002,Stri0);
      Stri0:=FillString(Stri0,#032,#048);
      Stri1:=Stri1+Stri0;
      Str(Min:002,Stri0);
      Stri0:=FillString(Stri0,#032,#048);
      Stri1:=Stri1+Stri0;
      Str(Sec:002,Stri0);
      Stri0:=FillString(Stri0,#032,#048);
      Stri1:=Stri1+Stri0;
      EGetPRGVersion:=Stri1;
    End;
  End;
  FileMode:=FMode;

End;




Procedure EOFile(VTyp: VTyps;Var HNum: Hand;
          FPath: ST79;OMod: OMods;RSize: Word);
Begin

  EOFile2(VTyp,HNum,FPath,OMod,RSize);
  If OMod=FReName Then EOFile2(VTyp,HNum,'',FDeAssign,RSize);

End;




Procedure EOFile2(VTyp: VTyps;Var HNum: Hand;
          FPath: ST79;OMod: OMods;RSize: Word);
Const
  BODF       : Bool=BF;

Var
  Bool0      : Bool;
  Byte0      : Byte;
  Char1      : Char;
  DH0        : Hand;
  DStr       : ST67;
  DStr0      : ST67;
  DStr1      : ST67;
  EStr       : ST04;
  EStr0      : ST04;
  EStr1      : ST04;
  Extended   : ST80;
  FName      : ST13;
  HandF      : Hand;
  HandT      : Hand;
  IOResult3  : IntM;
  Long0      : IntL;
  ModeStr    : ST10;
  NStr       : ST08;
  NStr0      : ST08;
  NStr1      : ST08;
  ODFT       : ST80;
  SPath      : ST79;
  Stri0      : STFF;
  Stri1      : ST12;
  Trys       : IntL;
  UName      : ST80;
  VTypStr    : ST05;
  Word0      : Word;
  Word1      : Word;
  Word2      : Word;

Procedure FFileHelp;
Begin
  If VTyp=FVarF Then
  Begin
    ArrFHndF[HNum]:=32768;
  End
  Else
  If VTyp=FVarT Then
  Begin
    ArrFHndT[HNum]:=32768;
    If OMod<>FDeAssign Then
    Begin
      FreeBuf(ArrFVarTSeg[HNum],Word0);
      MemErrorOut('FFileHelp',Word0,000);
    End;
    ArrFVarTSeg[HNum]:=000;
  End;
End;

Procedure NetReset(Var Datei);
Var
  DName : STFF;
  Regs  : Regi;

Begin

  DName:=FPath+#000;
  With Regs Do
  Begin
    DS:=Seg(DName[001]);
    DX:=Ofs(DName[001]);
    AH:=$3D;
    AL:=FileMode;
    MsDos(Regs);
    If Flags And FCarry=000 Then
    Begin
      IOResult3:=000;
      With FileRec(Datei) Do
      Begin
        Move(DName[001],Name,Length(DName));
        Handle:=AX;
        RecSize:=RSize;
        Case FileMode And 007 Of
        000 : Mode:=FMINOUT;
        001 : Mode:=FMINOUT;
        002 : Mode:=FMINOUT;
        Else ErrorOut('Ungltiger FileMode-Wert',001,'',#000);
        End;
      End;
    End
    Else
    Begin
      IOResult3:=AX;
      With FileRec(Datei) Do Mode:=FMCLOSED;
    End;
  End;

End;

Procedure NetRewrite(Var Datei);
Var
  DName2 : STFF;
  Regs   : Regi;

Begin

  DName2:=FPath+#000;
  With Regs Do
  Begin
    DS:=Seg(DName2[001]);
    DX:=Ofs(DName2[001]);
    AH:=$3C;
    CX:=$00;
    MsDos(Regs);
    If Flags And FCarry=000 Then
    Begin
      BX:=AX;
      AH:=$3E;
      MsDos(Regs);
      If Flags And FCarry=000 Then NetReset(Datei) Else IOResult3:=AX;
    End
    Else IOResult3:=AX;
  End;

End;

Procedure OFileHelp;
Begin
  If VTyp=FVarF Then
  Begin
    With FileRec(ArrFVarF[HNum]) Do
    Begin
      ArrFHndF[HNum]:=ArrFHndF[HNum] And 000 Or HNum;
      UserData[014]:=Ord(OMod);
      UserData[013]:=HNum;
      UserData[015]:=000;
    End;
  End
  Else
  If VTyp=FVarT Then
  Begin
    With FileRec(ArrFVarT[HNum]) Do
    Begin
      ArrFHndT[HNum]:=ArrFHndT[HNum] And 8192 Or HNum;
      UserData[013]:=HNum;
    End;
  End;
End;

Begin

  Trys:=500;
  BooleanErr:=BF;
  IOResult2:=000;
  IOResult3:=000;
  FSplit(FPath,DStr,NStr,EStr);
  FSplit(FPath,DStr1,NStr1,EStr1);
  Case OMod Of
  FAppend    : ModeStr:='Append';
  FAssign    : ModeStr:='Assign';
  FChkT      : ModeStr:='TChecken';
  FClose     : ModeStr:='Close';
  FDeAssign  : ModeStr:='DeAssign';
  FErase     : ModeStr:='Erase';
  FNew       : ModeStr:='New';
  FRead      : ModeStr:='Read';
  FReadWrite : ModeStr:='ReadWrite';
  FReadWrite2: ModeStr:='ReadWrite2';
  FReName    : ModeStr:='ReName';
  End;
  Case VTyp Of
  FVarF      : VTypStr:='FVarF';
  FVarT      : VTypStr:='FVarT';
  End;
  If OMod=FDeAssign Then
  Begin
    FFileHelp;
    Exit;
  End;
  Repeat
    If FPath<>'' Then
    If  (OMod<>FClose)
    And (OMod<>FReName) Then
    Begin
      AllocateFVarHandle(VTyp,HNum);
      If VTyp=FVarF Then
      Assign(ArrFVarF[HNum],FPath)
      Else
      If VTyp=FVarT Then
      Assign(ArrFVarT[HNum],FPath);
      If OMod=FAssign Then
      Begin
        Exit;
      End;
    End;
    If FPath='' Then
    If OMod=FClose Then
    GetPathFromFVar(VTyp,HNum,FPath)
    Else
    If OMod=FErase Then
    Begin
      GetPathFromFVar(VTyp,HNum,FPath);
      If VTyp=FVarF Then Assign(ArrFVarF[HNum],FPath)
      Else
      If VTyp=FVarT Then
      Begin
        Assign(ArrFVarT[HNum],FPath);
        ArrFVarTSeg[HNum]:=GetBuf(TSSize+016,Word0,Word1);
        MemErrorOut('OFile FVarT TSeg',Word0,000);
      End;
    End;
    If VTyp=FVarT Then
    If OMod=FChkT Then
    If IOResult2<>000 Then
    IOResult3:=IOResult2;
    If Trys>000 Then
    If IOResult3<>000 Then
    If Not MyKeyPressed Then
    Begin
      Dec(Trys);
      Delay(500);
      Str(Trys,Stri0);
      Block('User: '+UName,'ONLYLINE',002,001,000,000,BT);
      Block('Datei: '+NStr+EStr,'ONLYLINE',002,001,000,003,BT);
      Block('Dateikonflikt - '+Stri0,'ONLYLINE',002,001,000,006,BT);
    End
    Else
    Begin
      Wait;
      OptionsR(000,000,
      'Attemptions file opening end ?','~Yes~No','N',BT);
      If Char0='J' Then Trys:=000;
    End;
    If VTyp=FVarF Then
    Begin
      Case OMod Of
      FClose     : Begin
                     With FileRec(ArrFVarF[HNum]) Do
                     If (UserData[014]=Ord(FNew))
                     Or (UserData[014]=Ord(FReadWrite))
                     Or (UserData[014]=Ord(FReadWrite2)) Then
                     Begin
                       {$I-} DOS.SetFTime(ArrFVarF[HNum],
                             ArrFVarFTime[HNum]);   {$I+}
                       IOResult3:=IOResult;
                     End;
                     ECheckChanged(HNum);
                     {$I-} Close(ArrFVarF[HNum]); {$I+}
                     IOResult3:=IOResult;
                     If IOResult3=000 Then
                     Begin
                       FreeFVarHandle(VTyp,HNum);
                     End;
                   End;
      FErase     : Begin
                     If ArrFHndF[HNum]>255 Then
                     Begin
                       {$I-} Erase(ArrFVarF[HNum]); {$I+}
                       IOResult3:=IOResult;
                       OFileHelp;
                       FreeFVarHandle(VTyp,HNum);
                     End
                     Else
                     ErrorOut('File '+FPath+' is not close',001,'',#000);
                   End;
      FNew       : Begin
                     OFileF(HandF,FPath,FRead,RSize);
                     If IOResult2=000 Then
                     Begin
                       GetFTime(FVarF,HandF,ArrFVarFTime[HNum]);
                       OFileF(HandF,'',FClose,RSize);
                       Bool0:=BF;
                     End
                     Else
                     Bool0:=BT;
                     SetFileMode($42);
                     NetReWrite(ArrFVarF[HNum]);
                     If IOResult3=000 Then
                     Begin
                       OFileHelp;
                       If Bool0 Then
                       GetFTime(FVarF,HNum,ArrFVarFTime[HNum]);
                     End
                     Else
                     FFileHelp;
                   End;
      FRead      : Begin
                     SetFileMode($40);
                     NetReset(ArrFVarF[HNum]);
                     If IOResult3=000 Then
                     Begin
                       OFileHelp;
                       GetFTime(FVarF,HNum,ArrFVarFTime[HNum]);
                     End
                     Else
                     FFileHelp;
                   End;
      FReadWrite : Begin
                     SetFileMode($42);
                     NetReset(ArrFVarF[HNum]);
                     If IOResult3=000 Then
                     Begin
                       OFileHelp;
                       GetFTime(FVarF,HNum,ArrFVarFTime[HNum]);
                     End;
                     If IOResult3>000 Then FFileHelp;
                   End;
      FReadWrite2: Begin
                     SetFileMode($42);
                     NetReset(ArrFVarF[HNum]);
                     If IOResult3=000 Then
                     Begin
                       OFileHelp;
                       GetFTime(FVarF,HNum,ArrFVarFTime[HNum]);
                     End;
                     If IOResult3>000 Then FFileHelp;
                   End;
      FReName    : Begin
                     If ArrFHndF[HNum]>255 Then
                     {$I-} ReName(ArrFVarF[HNum],FPath) {$I+}
                     Else
                     ErrorOut('File '+FPath+' is not close',001,'',#000);
                     IOResult3:=IOResult;
                     If IOResult3=000 Then
                     Begin
                       OFileHelp;
                       FreeFVarHandle(VTyp,HNum);
                     End;
                   End;
      Else
      ErrorOut('OFile: Invalid OMod value: '+ModeStr,001,'',#000);
      End;
    End
    Else
    If VTyp=FVarT Then
    Begin
      Case OMod Of
      FAppend    : Begin
                     SetFileMode($41);
                     NetReset(ArrFVarT[HNum]);
                     If IOResult3=000 Then
                     System.Seek(ArrFVarT[HNum],
                     System.FileSize(ArrFVarT[HNum]));
                     If IOResult3=000 Then
                     Begin
                       OFileHelp;
                       GetFTime(FVarT,HNum,ArrFVarTTime[HNum]);
                     End
                     Else
                     FFileHelp;
                   End;
      FClose     : Begin
                     {$I-} Close(ArrFVarT[HNum]); {$I+}
                     IOResult3:=IOResult;
                     If IOResult3=000 Then
                     Begin
                       FreeFVarHandle(VTyp,HNum);
                     End;
                   End;
      FErase     : Begin
                     If ArrFHndT[HNum]>255 Then
                     Begin
                       {$I-} Erase(ArrFVarT[HNum And 255]); {$I+}
                       IOResult3:=IOResult;
                       OFileHelp;
                       FreeFVarHandle(VTyp,HNum And 255);
                     End
                     Else
                     ErrorOut('EOFile: ('+ModeStr+
                     '): File '+FPath+' is not close',001,'',#000);
                   End;
      FNew       : Begin
                     SetFileMode($41);
                     NetRewrite(ArrFVarT[HNum]);
                     If IOResult3=000 Then
                     Begin
                       OFileHelp;
                     End
                     Else
                     FFileHelp;
                   End;
      FRead,
      FChkT      : Begin
                     SetFileMode($40);
                     NetReset(ArrFVarT[HNum]);
                     ArrFHndT[HNum]:=ArrFHndT[HNum] Or 8192;
                     If IOResult3=000 Then
                     Begin
                       OFileHelp;
                       GetFTime(FVarT,HNum,ArrFVarTTime[HNum]);
                     End
                     Else
                     FFileHelp;
                   End;
      FReName    : Begin
                     If ArrFHndT[HNum]>255 Then
                     {$I-} ReName(ArrFVarT[HNum],FPath) {$I+}
                     Else
                     ErrorOut('File '+FPath+' is not close',001,'',#000);
                     IOResult3:=IOResult;
                     If IOResult3=000 Then
                     Begin
                       OFileHelp;
                       FreeFVarHandle(VTyp,HNum);
                     End;
                   End;
      Else
      ErrorOut('OFile: Invalid OMod value: '+ModeStr,001,'',#000);
      End;
    End;
    Case IOResult3 Of
    001,
    003..004,
    006..160,
    164..255 : Begin
                 If IOResult3=103 Then
                 Begin
                   If OMod=FClose Then
                   IOResult3:=000;
                 End
                 Else
                 Begin
                   ErrorOut('OpenFile '+ModeStr+': '+VTypStr+': '+
                   FPath+':'+GetDosError(IOResult3)+' --- Continue ?',
                   000,'~Yes~No','J');
                   If Char0='N' Then Halt(001);
                   If Char0='Y' Then IOResult3:=000;
                 End;
               End;
    005,
    161..163 : If Trys>000 Then
               Begin
                 UName:='';
               End
               Else
               If Trys=000 Then
               Begin
                 Stri0:=GetDOSError(IOResult3);
                 Ok('OpenFile '+VTypStr+': '+ModeStr+
                 ': Beim Zugriff auf Datei '+CutString(FPath,039)+
                 ' enstand IO-Error '+Stri0+'. Drcken Sie <EN'+
                 'TER> und whlen Sie aus dem folgenden Men aus.');
                 Repeat
                   OptionsR(025,005,
                   'OptionenDatei-Zugriffskonflikt',
                   'Versuchen bis Datei ~frei'+
                   '~Nochmal versuchen'+
                   'Programm~abbruch'+
                   'E~xit = Dennoch weiter',
                   'F',BT);
                   Char1:=Char0;
                   Case Char0 Of
                   'F' : Trys:=500;
                   'A' : Begin
                           SetScreenMode(000,112);
                           System.Halt(001);
                         End;
                   'X' : Begin
                           IOResult2:=
                           IOResult3;
                           Exit;
                         End;
                   End;
                   BooleanErr:=True;
                 Until Char1<>'W';
               End;
    End;
  Until (IOResult3=000) Or (IOResult3=002);
  IOResult2:=IOResult3;

End;




Procedure EScreenParams(BSave: Bool);
Var
  BiosS : Word;
  Bool0 : Bool;
  Byte0 : Byte;
  DH0   : Hand;
  FName : ST13;
  GrSeg : Word;
  HandF : Hand;
  HandT : Hand;
  Intx1 : IntM;
  Intx2 : IntM;
  Inty1 : IntM;
  Inty2 : IntM;
  Intyt : IntM;
  Regs0 : Regi;
  Stri0 : STFF;
  Word0 : Word;
  Word1 : Word;
  Word2 : Word;
  Word3 : Word;

  EndFlag : Bool;
  LineJmp : Bool;

Const
  BoolG  : Array[000..009] Of Bool=(BF,BF,BF,BF,BF,BF,BF,BF,BF,BF);
  CPosX  : Array[000..009] Of Byte=(0,0,0,0,0,0,0,0,0,0);
  CPosY  : Array[000..009] Of Byte=(0,0,0,0,0,0,0,0,0,0);
  Index  : Byte=(000);
  Color  : Array[000..009] Of Byte=(0,0,0,0,0,0,0,0,0,0);
  GrDrv  : Array[000..009] Of IntM=(0,0,0,0,0,0,0,0,0,0);
  GrMod  : Array[000..009] Of IntM=(0,0,0,0,0,0,0,0,0,0);
  LnArt  : Array[000..009] Of Word=(0,0,0,0,0,0,0,0,0,0);
  LnPat  : Array[000..009] Of Word=(0,0,0,0,0,0,0,0,0,0);
  LnThi  : Array[000..009] Of Word=(0,0,0,0,0,0,0,0,0,0);
  TMode  : Array[000..009] Of Byte=(0,0,0,0,0,0,0,0,0,0);
  WinX1  : Array[000..009] Of Byte=(0,0,0,0,0,0,0,0,0,0);
  WinX2  : Array[000..009] Of Byte=(0,0,0,0,0,0,0,0,0,0);
  WinY1  : Array[000..009] Of Byte=(0,0,0,0,0,0,0,0,0,0);
  WinY2  : Array[000..009] Of Byte=(0,0,0,0,0,0,0,0,0,0);
  WrMod  : Array[000..009] Of IntM=(0,0,0,0,0,0,0,0,0,0);

Begin

  DH0:=255;
  Bool0:=BooleanErr;
  If BSave Then
  Begin
    If Index<010 Then
    Begin
      Begin
        TempI;
        cposx[index]:=Wherex;
        cposy[index]:=Wherey;
        If FNBNAME<>'' Then
        Begin
          FNBNm[Index]:=FNBNAME;
          FNBSWITCH8ON2[Index]:=FNBSWITCH8ON;
        End;
        color[index]:=TextAttr;
        winx1[index]:=Lo(windmin);
        winy1[index]:=Hi(windmin);
        winx2[index]:=Lo(windmax);
        winy2[index]:=Hi(windmax);
        If IsCrsrOff Then cposx[index]:=111;
        BiosS:=GetBuf(064,Word0,Word1);
        MemErrorOut('EScreenParams',Word0,000);
        With Regs0 Do
        Begin
          AX:=$1B00;
          ES:=BiosS;
          DI:=$0000;
          BX:=$0000;
          Intr($10,Regs0);
          Byte0:=AX;
        End;
        If Byte0<>027 Then
        ErrorOut('No VGA video card installed',001,'',#000);
        FreeBuf(BiosS,Word0);
        MemErrorOut('EScreenParams',Word0,000);
        TMode[Index]:=Ord(Is50);
      End;
      Inc(Index);
    End;
  End
  Else
  Begin
    If Index>000 Then
    Begin
      Dec(Index);
      Begin
        If tmode[index]=001 Then
        Begin
          If Not Is50
          Or (FNBNAME<>FNB50NAME) Then
          SetScreenMode(001,000);
        End
        Else
        If Is50
        Or (FNBNAME<>FNB25NAME) Then
        SetScreenMode(000,000);
        If FNBNm[Index]<>FNBNAME Then
        Begin
          FNBSWITCH8ON:=FNBSWITCH8ON2[Index];
          ActivateFNB(FNBNm[Index],FNBSWITCH8ON);
        End;
        If cposx[index]<>111 Then
        Begin
          TextAttr:=color[index];
          Window(winx1[index]+001,
          winy1[index]+001,
          winx2[index]+001,
          winy2[index]+001);
          GotoXY(cposx[index],cposy[index]);
        End
        Else CrsrOff;
        TempO;
      End;
    End;
  End;
  BooleanErr:=Bool0;

End;




Procedure ESeek2F(HNum: Hand;SIntL: IntL);
Begin

  {$I-} System.Seek(ArrFVarF[HNum],SIntL); {$I+}
  IOResult2:=IOResult;

End;




Procedure ESeek2T(HNum: Hand;SIntL: IntL);
Begin

  {$I-} System.Seek(ArrFVarT[HNum],SIntL); {$I+}
  IOResult2:=IOResult;

End;




Procedure ESetFTime(VTyp: VTyps;HNum: Hand;Time: IntL);
Begin

  Case VTyp Of
  FVarF : If ArrFHndF[HNum]=HNum Then
          Dos.SetFTime(ArrFVarF[HNum],Time)
          Else
          ErrorOut('SetFTime: Handle for FVarF not defined',001,'',#000);
  FVarT : If ArrFHndT[HNum] And 255=HNum Then
          Dos.SetFTime(ArrFVarT[HNum],Time)
          Else
          ErrorOut('SetFTime: Handle for FVarT not defined',001,'',#000);
  End;

End;




Procedure ESetUnUsed(HNum: Hand);
Begin

  With FileRec(ArrFVarF[HNum]) Do
  Begin
    UserData[015]:=UserData[015] And 254;
  End;

End;




Procedure ETruncate2F(HNum: Hand);
Begin

  With FileRec(ArrFVarF[HNum]) Do
  Begin
    {$I-} System.Truncate(ArrFVarF[HNum]); {$I+}
    IOResult2:=IOResult;
    UserData[015]:=UserData[015] Or 001;
  End;

End;




END.
