Unit SWCSubPr;

{$F+}

Interface


Uses CRT,
     DOS,
     SWCVaria;



Procedure TestInt(AX,BX,CX,DX,SI,DI,DS,ES,BP: Word); Interrupt;
Procedure Block(OStr: STFF;Name: ST08;
          TextX,TextY,XPos,YPos: Byte;BShadow: Bool);
Function  BuendigB(Width: Byte;BStr: STFF): STFF;
Function  BuendigBH(BStr: STFF): STFF;
Function  BuendigL2(Width: Byte;FStr: STFF): STFF;
Function  BuendigLR(BStr: STFF): STFF;
Function  BuendigR(Name: ST08;Index: Word;FStr: STFF): STFF;
Function  BuendigR2(Width: Byte;FString: STFF): STFF;
Function  BuendigR3(Width: Byte;FString: STFF): STFF;
Function  BuendigRSpecial(BStr: STFF): STFF;
Function  BuendigZ2(Width: Byte;FStr: STFF): STFF;
Function  CheckBefore(Str1,Str2: STFF): Bool; {Kommt Str1 vor Str2 ?}
Function  CheckNum(ChkStr: ST80): Byte;
Function  ChkDisketteOk(LWB: Byte;Var DTyp0: DTyp;Var BStop: Bool): Bool;
Function  ChkDrvOk(Drive: ST01): Bool;
Function  ChkPath(ChkP: ST79): Bool;
Function  ChkStrInBetween(StrFrom,StrChk,StrUpto: STFF): Bool;
Function  Clean(clnstr: STFF;boolcln: Bool) : STFF;
Procedure Cli;
Procedure Click;
Procedure ClrScr(color: Byte);
Procedure ClrKeyBuf;
Procedure Convert(CNVMode: Byte;Var NumFrom,NumUpTo: Real;CNVStr: ST80);
Procedure CrsrOff;
Procedure CrsrOn;
Procedure CrsrThick;
Procedure CrsrThin;
Function  CutString(CStr: STFF;CLength: Byte): STFF;
Function  Date: ST80;
Function  DateAll1: ST80;
Procedure EOut2(EStr: STFF;HFlag: Byte);
Procedure ErrorOut(ErrStr: STFF;HFlag: Byte;KStr: STFF;KChar: Char);
Procedure Execute; Interrupt;
Function  FillString(FStr: STFF;ExChng: Char;FChar: Char): STFF;
Procedure FreeBuf(FreeSeg: Word;Var Error: Word);
Procedure FSplit(SStr: STFF;Var DStr: ST79;Var NStr: ST08;Var EStr: ST80);
Function  GetBuf(Size: IntL;Var Error,MaxSize: Word): Word;
Procedure GetCrsrPos(Var Line,Tab: Byte);
Function  GetDosError(ECode: IntM): ST80;
Function  GetFreeMem: Word;
Function  GetHexToStr(HexByte: Byte): ST02;
Procedure GetPacked(Name: ST08;BTop: Bool);
Function  GetProgName: ST12;
Function  GetProgPath: ST67;
Function  GetStrToHex(HexStr: ST02): Byte;
Function  Is50: Bool;
Function  IsCrsrOff: Bool;
Function  IsHex(HStr: ST02): Bool;
Function  KeyPressed: Bool;
Procedure MakePath(Path: ST79);
Function  MakeTime(TStr: ST80): ST80;
Procedure MemErrorOut(ProcNam: ST80;ErrNum: Word;ErrNot: Word);
Procedure MoveMemToVec(IndexT: Byte;IndexField: Word);
Procedure MoveVecToMem(IndexT: Byte;IndexField: Word);
Procedure MyExit;
Function  MyKeyPressed: Bool;
Procedure Ok(OkStr: STFF);
Procedure OptionsR(xp,yp: Byte;txtstr,keystr: STFF;
          DefaultKey: char;boolselfxy: Bool);
Function  Pos(substr,s: STFF): Byte;
Procedure PressKey(Code1,Code2: Byte);
Procedure ScreenOff;
Procedure ScreenOn;
Procedure ScreenParams(BSave: Bool);
Procedure SegOfsDec(Var ISeg,IOfs: Word;DecVal: Word);
Procedure SegOfsInc(Var ISeg,IOfs: Word;IncVal: Word);
Procedure SetCrsrPos(Line,Tab: Byte);
Procedure SetFileMode(accessmode: Byte);
Procedure SetScreenMode(Mode,Color: Byte);
Procedure Shadow(X1,X2,Y1,Y2: Byte);
Procedure ShowP(SPTxt: ST80;Var ShwBool: Bool;
          Var ShwHandle: Byte;Width,PX,PY: Byte;PNow,PEnd: IntL;BNew: Bool);
Procedure ShowPClr(ShwHandle: Byte);
Procedure Sound(Frequence,Delay: Word);
Procedure SoundDn;
Procedure SoundError;
Procedure SoundHallo;
Procedure SoundUp;
Procedure Sti;
Function  StopTime(Var STPH: Hand;Var MilliS: IntL): Bool;
Procedure StopTimeFree(Var STPH: Hand);
Procedure StringInString(Str1: STFF;Var Str2: STFF;Index: Byte);
Function  StrTurnAround(TAStr: STFF): STFF;
Procedure TempI;
Procedure TempO;
Procedure Test(TStr: STFF;BWait: Bool;Line: Byte);
Function  Time: ST80;
Procedure UnPackBlk(size: Word);
Procedure UnPackPGX(PSeg,POfs: Word;PGXx: Byte;Size: Word);
Function  UpCase(UChar: Char): Char;
Function  UpCaseStr(UStr: STFF): STFF;
Function  V24Avail: Boolean;
Procedure Wait;
Procedure WaitClr;
Procedure WaitForVerticalRetrace;
Procedure WhereIsCrsr(Var XPos,YPos: Byte);
Procedure Write7(Count: Byte);
Procedure WriteInRAM(VStr: STFF;X,Y,Col1,Col2: Byte);
Procedure WriteVR(VStr: STFF;X,Y: Byte);
Procedure WriteVRN(VStr: STFF;X,Y: Byte;Width,Depth,MLen: Byte);
Procedure ZCopy(SPath,TPath: ST79;BShow: Bool);

Procedure AllocateFVarHandle(VTyp: VTyps;Var FVHandle: Hand);
Procedure BlockRead(HNum: Hand;Var VR;CntrR: Word;Var CntrHR: Word);
Procedure BlockRead2F(HNum: Hand;Var VR;CntrR: Word;Var CntrHR: Word);
Procedure BlockRead2T(HNum: Hand;Var VR;CntrR: Word;Var CntrHR: Word);
Procedure BlockWrite(HNum: Hand;Var VW;CntrW: Word;Var CntrHW: Word);
Procedure BlockWrite2F(HNum: Hand;Var VW;CntrW: Word;Var CntrHW: Word);
Procedure CommitFile(VTyp: VTyps;HNum: Hand);
Function  EOF(VTyp: VTyps;HNum: Hand): Bool;
Function  EOF2F(HNum: Hand): Bool;
Procedure ErrHandIO(Error: Word;PIONam: ProcsIO;HNum: Hand);
Procedure ErrHandIO2(Error: Word;PIONam: ProcsIO;HNum: Hand);
Function  FilePos(HNum: Hand): IntL;
Function  FilePos2F(HNum: Hand): IntL;
Function  FilePos2T(HNum: Hand): IntL;
Function  FileSize(HNum: Hand): IntL;
Function  FileSize2F(HNum: Hand): IntL;
Function  FileSize2T(HNum: Hand): IntL;
Procedure FreeFVarHandle(VTyp: VTyps;FVHandle: Hand);
Procedure GetFAttr(VTyp: VTyps;HNum: Hand;Var Attr: Word);
Function  GetFreeFVars: Word;
Procedure GetFTime(VTyp: VTyps;HNum: Hand;Var Time: IntL);
Procedure GetPathFromFVar(VTyp: VTyps;HNum: Hand;Var GPath: ST79);
Procedure IniFVarHandles;
Procedure OFile(VTyp: VTyps;Var HNum: Hand;
          FPath: ST79;OMod: OMods;RSize: Word);
Procedure OFileF(Var HNum: Hand;FPath: ST79;
          OMod: OMods;RSize: Word);
Procedure OFileT(Var HNum: Hand;TPath: ST79;OMod: OMods);
Procedure Read(HNum: Hand;Var RChar: Char);
Procedure ReadLn(HNum: Hand);
Procedure ReadLnS(HNum: Hand;Var RStr: STFF;StrSize: Word);
Procedure Seek(HNum: Hand;SIntL: IntL);
Procedure Seek2F(HNum: Hand;SIntL: IntL);
Procedure Seek2T(HNum: Hand;SIntL: IntL);
Procedure SetFAttr(VTyp: VTyps;HNum: Hand;Attr: Byte);
Procedure SetFTime(VTyp: VTyps;HNum: Hand;Time: IntL);
Procedure SetUnUsed(HNum: Hand);
Procedure Truncate(HNum: Hand);
Procedure Truncate2F(HNum: Hand);
Procedure Write(HNum: Hand;WChar: Char);
Procedure WriteLn(HNum: Hand;WStr: STFF);
Procedure WriteS(HNum: Hand;WStr: STFF);


Implementation


Uses SWCFNB,
     SWCMask,
     SWCMouse,
     SWCMskIF,
     SWCMskPX,
     SWCOpt,
     SWCPGX,
     SWCSubE,
     SWCXMS;




Procedure TestInt(AX,BX,CX,DX,SI,DI,DS,ES,BP: Word);
Begin

  TESTSTR:=GetHexToStr(Hi(AX))+GetHexToStr(Lo(AX));
  Test(TESTSTR,BF,000);
  TESTSTR:=GetHexToStr(Hi(BX))+GetHexToStr(Lo(BX));
  Test(TESTSTR,BF,001);
  TESTSTR:=GetHexToStr(Hi(CX))+GetHexToStr(Lo(CX));
  Test(TESTSTR,BF,002);
  TESTSTR:=GetHexToStr(Hi(DX))+GetHexToStr(Lo(DX));
  Test(TESTSTR,BT,003);

End;




Procedure Block(OStr: STFF;Name: ST08;
          TextX,TextY,XPos,YPos: Byte;BShadow: Bool);
Begin

  EBlock(OStr,Name,TextX,TextY,XPos,YPos,BShadow);

End;




Function  BuendigB(Width: Byte;BStr: STFF): STFF;
Var
  Bool0 : Bool;
  Byte0 : Byte;

Begin

  BStr:=BuendigLR(BStr);
  If Length(BStr)>000 Then
  If Length(BStr)<Width Then
  Begin
    Bool0:=BF;
    Repeat
      Byte0:=001;
      Repeat
        If  (Byte0<Width)
        And (Length(BStr)<Width)
        And (BStr[Byte0]=#032)
        And (BStr[Byte0+001]<>#032) Then
        Begin
          Bool0:=BT;
          Inc(Byte0);
          Insert(#032,BStr,Byte0);
        End;
        Inc(Byte0);
      Until (Byte0>=Length(BStr))
      Or (Length(BStr)=Width);
    Until Not Bool0 Or (Length(BStr)=Width);
  End;
  BuendigB:=BStr;

End;




Function  BuendigBH(BStr: STFF): STFF;
Var
  Byte0 : Byte;

Begin

  If Length(BStr)>000 Then
  Begin
    Byte0:=001;
    Repeat
      If  (BStr[Byte0]=#032)
      And (Length(BStr)>=Byte0+001)
      And (BStr[Byte0+001]=#032) Then
      Delete(BStr,Byte0+001,001)
      Else
      Inc(Byte0);
    Until Byte0>=Length(BStr);
  End;
  BuendigBH:=BStr;

End;




Function  BuendigL2(Width: Byte;FStr: STFF): STFF;
Begin

  FStr:=BuendigLR(FStr);
  BuendigL2:=FStr;
  If Length(FStr)<Width Then
  Begin
    While Length(FStr)<Width Do FStr:=FStr+#032;
    BuendigL2:=FStr;
  End;

End;




Function  BuendigLR(BStr: STFF): STFF;
Var
  Index : Byte;

Begin

  If BStr[000]=#000 Then
  Begin
    BuendigLR:=BStr;
    Exit;
  End;
  While BStr[001]=#032 Do
  Begin
    For Index:=001 To Ord(BStr[000])-001 Do
    BStr[Index]:=BStr[Index+001];
    BStr[Index+001]:=#032;
    Dec(BStr[000]);
    If BStr[000]=#000 Then
    Begin
      BuendigLR:=BStr;
      Exit;
    End;
  End;
  While BStr[Length(BStr)]=#032 Do
  Begin
    Dec(BStr[000]);
    If BStr[000]=#000 Then
    Begin
      BuendigLR:=BStr;
      Exit;
    End;
  End;
  BuendigLR:=BStr;

End;




Function  BuendigR(Name: ST08;Index: Word;FStr: STFF): STFF;
Var
  I : Byte;

Begin

  I:=PGXIGet(Name);
  FStr:=BuendigLR(FStr);
  MoveMemToVec(I,Index);
  With VecRec[I] Do
  Begin
    If Length(FStr)>=LenTab Then
    Begin
      BuendigR:=FStr;
      Exit;
    End;
    Repeat
      Insert(#032,FStr,001);
    Until Length(FStr)=LenTab;
  End;
  BuendigR:=FStr;

End;




Function  BuendigR2(width: Byte;fstring: STFF): STFF;
Begin
  fstring:=BuendigLR(fstring);
  If Length(fstring)>=width then
  Begin
    BuendigR2:=fstring;
    Exit;
  End;
  Repeat
    Insert(#032,fstring,001);
  Until Length(fstring)=width;
  BuendigR2:=fstring;
End;




Function  BuendigR3(width: Byte;fstring: STFF): STFF;
Begin
  fstring:=BuendigLR(fstring);
  If Length(fstring)>=width then
  Begin
    BuendigR3:=fstring;
    Exit;
  End;
  While Ord(fstring[000])<width Do
  Insert(#032,fstring,Length(fstring)+001);
  BuendigR3:=fstring;
End;




Function  BuendigRSpecial(BStr: STFF): STFF;
Var
  Byte0 : Byte;

Begin

  Byte0:=Length(BStr);
  While (BStr[Byte0]=#032) And (Byte0>000) Do Dec(Byte0);
  BStr[000]:=Chr(Byte0);
  BuendigRSpecial:=BStr;

End;




Function  BuendigZ2(Width: Byte;FStr: STFF): STFF;
Const
  BoolL : Bool=BF;

Begin

  While Length(FStr)<Width Do
  Begin
    If BoolL Then
    Begin
      BoolL:=BF;
      FStr:=FStr+#032;
    End
    Else
    Begin
      BoolL:=BT;
      FStr:=#032+FStr;
    End;
  End;
  BoolL:=BF;
  BuendigZ2:=FStr;

End;




Function  CheckBefore(Str1,Str2: STFF): Bool;
Var
  Byte0 : Byte;

Begin

  If  (Length(Str1)=000)
  And (Length(Str2)>000) Then
  Begin
    CheckBefore:=BT;
    Exit;
  End;
  If  (Length(Str1)>000)
  And (Length(Str2)=000) Then
  Begin
    CheckBefore:=BF;
    Exit;
  End;
  If Str1=Str2 Then
  Begin
    CheckBefore:=BF;
    Exit;
  End;
  For Byte0:=001 To Length(Str1) Do
  Begin
    If Byte0>Length(Str2) Then
    Begin
      CheckBefore:=BF;
      Exit;
    End;
    If Ord(Str1[Byte0])<Ord(Str2[Byte0]) Then
    Begin
      CheckBefore:=BT;
      Exit;
    End;
    If Ord(Str1[Byte0])>Ord(Str2[Byte0]) Then
    Begin
      CheckBefore:=BF;
      Exit;
    End;
  End;
  If Length(Str2)>Length(Str1) Then CheckBefore:=BT
  Else CheckBefore:=BF;

End;




Function  CheckNum(ChkStr: ST80): Byte;
{Das zurckgelieferte Ergebnis...}
{ 000 : kein numerisches Format}
{ 001 : Normales Datum}
{ 002 : Datumsformat Jahr/Monat}
{ 003 : Zeitformat Stunde/Minute z.B. 00:30}
{ 004 : normale Zahl, egal ob real oder integer}
{ 005 : Datumsformat Stunde(n)/Minute(n) z.B. 112/44}

Var
  Byte0 : Byte;
  Byte1 : Byte;
  Long0 : IntL;
  Real0 : Real;
  Word0 : Word;
  Word1 : Word;
  Word2 : Word;
  Word3 : Word;

Begin

  CheckNum:=000;
  If ChkStr='' Then Exit;

  Val(ChkStr,Real0,Word0);
  If Word0=000 Then
  Begin
    CheckNum:=004;
    Exit;
  End;

  Val(Copy(ChkStr,001,002),Byte0,Word1);
  Val(Copy(ChkStr,004,002),Byte1,Word2);
  Val(Copy(ChkStr,007,004),Word0,Word3);

  If  (Length(BuendigLR(ChkStr))=010)
  And (Copy(ChkStr,003,001)=#046)
  And (Copy(ChkStr,006,001)=#046)
  And (Byte0>000) And (Byte0<032)
  And (Byte1>000) And (Byte1<013)
  And (Word0>000) Then
  Begin
    CheckNum:=001;
    Exit;
  End;

  Val(Copy(ChkStr,001,002),Word0,Word1);
  Val(Copy(ChkStr,004,004),Byte0,Word2);

  If  (Length(ChkStr)=007)
  And (Copy(ChkStr,005,001)=#047)
  And (Byte0>000) And (Byte0<013)
  And (Word0>000) Then
  Begin
    CheckNum:=002;
    Exit;
  End;

  If  Pos('/',ChkStr)>000 Then
  Begin
    Byte0:=Pos('/',ChkStr);
    Val(Copy(ChkStr,001,Byte0-001),Long0,VALCODE);
    If VALCODE>000 Then Exit;
    Delete(ChkStr,001,Byte0);
    Val(ChkStr,Long0,VALCODE);
    If VALCODE>000 Then Exit;
    If Long0>060 Then Exit;
    CheckNum:=005;
    Exit;
  End;

End;




Function  ChkDisketteOk(LWB: Byte;Var DTyp0: DTyp;Var BStop: Bool): Bool;
Var
  Byte0 : Byte;
  ODDPT : Poin;
  RFL2  : Word;
  Stri0 : ST80;
  Try   : Byte;
  Word0 : Word;
  Word1 : Word;

Procedure HelpSetFormat; ForWard;
Procedure HelpTry;       ForWard;

Procedure HelpGetSetIntVecsOff;
Begin
  SetIntVec($1E,ODDPT);
End;

Procedure HelpGetSetIntVecsOn(DTyp0: DTyp);
Begin
  GetIntVec($1E,ODDPT);
  Case DTyp0 Of
  DT288 : SetIntVec($1E,@DDPT1440);
  DT144 : SetIntVec($1E,@DDPT1440);
  DT12  : SetIntVec($1E,@DDPT1200);
  DT720 : SetIntVec($1E,@DDPT720);
  DT360 : SetIntVec($1E,@DDPT360);
  DT320 : SetIntVec($1E,@DDPT360);
  End;
End;

Function  HelpCheck(Stri0: ST80;Track,Sektor: Byte;DTypX,DTypY: DTyp): Bool;
Var
  Byte0 : Word;
Begin
  HelpCheck:=BF;
  WaitForVerticalRetrace;
  HelpGetSetIntVecsOn(DTypX);
  OptTableau3(023,007,030,003,'',BF);
  WriteVR(Stri0,023+(034-Length(Stri0)) Div 002,010);
  Case DTypY Of
  DT288 : Begin
            RegCH:=079;  {Grte Spurnummer}
            RegCL:=036;  {Grte Sektornummer}
          End;
  DT144 : Begin
            RegCH:=079;  {Grte Spurnummer}
            RegCL:=018;  {Grte Sektornummer}
          End;
  DT720 : Begin
            RegCH:=079;  {Grte Spurnummer}
            RegCL:=009;  {Grte Sektornummer}
          End;
  DT12  : Begin
            RegCH:=079;  {Grte Spurnummer}
            RegCL:=015;  {Grte Sektornummer}
          End;
  DT360 : Begin
            RegCH:=039;  {Grte Spurnummer}
            RegCL:=009;  {Grte Sektornummer}
          End;
  DT320 : Begin
            RegCH:=039;  {Grte Spurnummer}
            RegCL:=008;  {Grte Sektornummer}
          End;
  End;
  RegAH:=$18;     {Diskettenformat festlegen}
  RegDH:=000;     {Diskettenseite}
  RegDL:=LWB-001; {Laufwerksnummer}
  HelpSetFormat;
  HelpGetSetIntVecsOff;
  If RegFL And FCarry=000 Then
  Begin
    RegCL:=Sektor;
    RegCH:=Track;
    RegAL:=001;
    HelpTry;
    If RegFL And FCarry=000 Then
    Begin
      HelpCheck:=BT;
      DTyp0:=DTypY;
    End;
  End;
End;

Procedure HelpReset;
Begin
  RFL2:=RegFL;
  RegDL:=LWB-001;
  ASM
    @LOOP:
    Mov  AH,$00
    Mov  DL,RegDL
    Int  $13
    JC   @LOOP
    PushF
    Pop  RegFL
  End;
  RegFL:=RFL2;
End;

Procedure HelpSetFormat;
Begin
  ASM
    Mov AH,RegAH
    Mov CH,RegCH
    Mov CL,RegCL
    Mov DH,RegDH
    Mov DL,RegDL
    Int $13
    PushF
    Pop RegFL
  End;
  If RegFL And FCarry=001 Then HelpReset;
End;

Procedure HelpTry;
Begin
  Try:=000;
  Repeat
    RegAH:=$02;
    RegDH:=000;
    RegBX:=DataO+$0000;
    RegES:=DataS;
    RegDL:=LWB-001;
    ASM
      Mov AH,RegAH
      Mov AL,RegAL
      Mov BX,RegBX
      Mov CL,RegCL
      Mov CH,RegCH
      Mov DL,RegDL
      Mov DH,RegDH
      Mov ES,RegES
      Int $13
      PushF
      Pop RegFL
    End;
    ChkDisketteOk:=RegFL And FCarry=000;
    If RegFL And FCarry=001 Then
    Begin
      HelpReset;
      Inc(Try);
    End;
  Until (Try>MaxTrys) Or (RegFL And FCarry=000) Or MyKeyPressed;
  If MyKeyPressed Then
  Begin
    Wait;
    OptionsR(000,000,
    'Diskettentyp-Prfung beenden ?',
    'Ja, ~Erfolg simulieren'+
    'Ja, ~kein Erfolg simulieren'+
    '~Nein','K',BT);
    If Char0='E' Then
    Begin
      RegFL:=000;
      ChkDisketteOk:=BT;
    End
    Else
    If Char0='K' Then
    BStop:=BT
    Else
    Begin
      BStop:=BF;
      RegFL:=001;
    End;
  End;
End;

Begin

  TempI;
  BStop:=BF;
  ChkDisketteOk:=BT;
  If DTyp0=DT288 Then
  Begin
    If Not HelpCheck('Prfe 2.88 MB ...',079,036,DT288,DT288) Then
    If Not BStop Then
    If Not HelpCheck('Prfe 1.44 MB ...',079,018,DT288,DT144) Then
    If Not BStop Then
    If Not HelpCheck('Prfe 720 KB ... ',079,009,DT288,DT720) Then BStop:=BT;
  End
  Else
  If DTyp0=DT144 Then
  Begin
    If Not HelpCheck('Prfe 1.44 MB ...',079,018,DT144,DT144) Then
    If Not BStop Then
    If Not HelpCheck('Prfe 720 KB ... ',079,009,DT144,DT720) Then BStop:=BT;
  End
  Else
  If DTyp0=DT720 Then
  Begin
    If Not HelpCheck('Prfe 720 KB ... ',079,009,DT720,DT720) Then BStop:=BT;
  End
  Else
  If DTyp0=DT12 Then
  Begin
    If Not HelpCheck('Prfe 1.2 MB ...',079,015,DT12,DT12) Then
    If Not BStop Then
    If Not HelpCheck('Prfe 360 KB ...',039,009,DT12,DT360) Then
    If Not BStop Then
    If Not HelpCheck('Prfe 320 KB ...',039,008,DT12,DT320) Then BStop:=BT;
  End
  Else
  If DTyp0=DT360 Then
  Begin
    If Not HelpCheck('Prfe 360 KB ...',039,009,DT360,DT360) Then
    If Not BStop Then
    If Not HelpCheck('Prfe 320 KB ...',039,008,DT360,DT320) Then BStop:=BT;
  End
  Else
  If Not HelpCheck('Prfe 320 KB ...',039,008,DT320,DT320) Then BStop:=BT;
  If BStop Then ChkDisketteOk:=BF;
  TempO;

End;




Function  ChkDrvOk(Drive: ST01): Bool;
Begin

  RegDL:=Ord(Drive[001])-064;
  If (RegDL<001) Or (RegDL>026) Then RegDL:=000;
  ASM
    Mov AH,$36
    Mov DL,RegDL
    Int $21
    Cmp AX,$FFFF
    Jz  @ERROR
    Mov RegFL,000
    Jmp @GOON
    @ERROR:
    Mov RegFL,001
    @GOON:
  End;
  ChkDrvOk:=RegFL=000;

End;




Function  ChkPath(ChkP: ST79): Bool;
Var
  TMPPath : ST79;

Begin

  ChkPath:=BF;
  GetDir(000,TMPPath);
  {$I-} ChDir(ChkP); {$I+}
  IOResult2:=IOResult;
  If IOResult2=000 Then ChkPath:=BT;
  ChDir(TMPPath);

End;




Function  ChkStrInBetween(StrFrom,StrChk,StrUpto: STFF): Bool;
Begin

  ChkStrInBetween:=EChkStrInBetween(StrFrom,StrChk,StrUpto);

End;




Function  Clean(clnstr: STFF;boolcln: Bool) : STFF;
Var
  Byte0 : Byte;
Begin

  If boolcln Then
  Begin
    For Byte0:=001 To Length(clnstr) Do
    If (clnstr[Byte0]=#000)
    Or (clnstr[Byte0]=#255) Then clnstr[Byte0]:=#032;
  End
  Else
  For Byte0:=001 To Length(clnstr) Do
  If clnstr[Byte0]=#032 Then clnstr[Byte0]:=#000;
  Clean:=clnstr;
End;




Procedure Cli; Assembler;
Asm

  Cli

End;




Procedure Click;
Begin

  Sound(1000,005);

End;




Procedure ClrKeyBuf;
Begin

  MemW[Seg0040:$001A]:=MemW[Seg0040:$001C];

End;




Procedure ClrScr(Color : Byte);
Var
  Byte0 : Byte;

Begin

  Byte0:=Color Shr 004;
  TextBackground(Byte0);
  TextColor(Color And $8F);
  Crt.ClrScr;

End;




Procedure Convert(CNVMode: Byte;Var NumFrom,NumUpTo: Real;CNVStr: ST80);
Var
  Byte0 : Byte;
  Byte1 : Byte;
  Byte2 : Byte;
  Real0 : Real;
  Stri0 : ST80;
  Stri1 : ST80;
  Word0 : Word;
  Word1 : Word;

Begin

  {Neu hinzugekommen: CNVMode 006 : Zeit z.B. 10:21 in Real 10.21}
  {Neu hinzugekommen: CNVMode 007 : Zeit z.B. 10:21:01 in Real 10.2101}

  Byte0:=Pos(',',CNVStr);
  If Byte0=000 Then
  Begin
    Stri0:=CNVStr;
    Stri1:=CNVStr;
  End
  Else
  Begin
    Stri0:=Copy(CNVStr,001,Byte0-001);
    Stri1:=Copy(CNVStr,Byte0+001,Length(CNVStr)-Byte0);
  End;

  Case CNVMode Of
  001 : Begin
          Stri0:=Copy(Stri0,007,004)+Copy(Stri0,004,002)+Copy(Stri0,001,002);
          Stri1:=Copy(Stri1,007,004)+Copy(Stri1,004,002)+Copy(Stri1,001,002);
        End;
  002 : Begin
          Stri0:=Copy(Stri0,001,004)+Copy(Stri0,006,002);
          Stri1:=Copy(Stri1,001,004)+Copy(Stri1,006,002);
        End;
  003 : Begin
          Stri0:=Copy(Stri0,001,002)+Copy(Stri0,004,002);
          Stri1:=Copy(Stri1,001,002)+Copy(Stri1,004,002);
        End;
  005 : Begin
          Byte0:=Pos('/',CNVStr);
          If Byte0=000 Then Byte0:=Pos('*',CNVStr);
          Stri0:=Copy(CNVStr,001,Byte0-001);
          Delete(CNVStr,001,Byte0);
          Stri1:=CNVStr;
        End;
  006 : Begin
          Stri0:=Copy(Stri0,001,002)+'.'+Copy(Stri0,004,002);
          Stri1:=Copy(Stri1,001,002)+'.'+Copy(Stri1,004,002);
        End;
  007 : Begin
          Stri0:=Copy(Stri0,001,002)+'.'+
          Copy(Stri0,004,002)+Copy(Stri0,007,002);
          Stri1:=Copy(Stri1,001,002)+'.'+
          Copy(Stri1,004,002)+Copy(Stri1,007,002);
        End;
  End;

  BooleanErr:=BF;
  Val(Stri0,NumFrom,Word0);
  If Word0>000 Then BooleanErr:=BT;
  Val(Stri1,NumUpTo,Word0);
  If Word0>000 Then BooleanErr:=BT;

End;




Procedure CrsrOff;
Var
  Regs0 : Regi;

Begin

  With Regs0 Do
  Begin
    BH:=$00;
    DX:=$3200;
    AX:=$0200;
    Intr($10,Regs0);
  End;

End;




Procedure CrsrOn;
Var
  Regs0 : Regi;

Begin

  With Regs0 Do
  Begin
    DX:=$00000000;
    AX:=$00000200;
    Intr($10,Regs0);
  End;

End;




Procedure CrsrThick;
Var
  Regs0 : Regi;

Begin

  With Regs0 Do
  Begin
    CX:=$0000000C;
    AX:=$00000100;
    Intr($10,Regs0);
  End;

End;




Procedure CrsrThin;
Var
  Regs0 : Regi;

Begin

  With Regs0 Do
  Begin
    CX:=$00000B0C;
    AX:=$00000100;
    Intr($10,Regs0);
  End;

End;




Function  CutString(CStr: STFF;CLength: Byte): STFF;
Var
  AddStr : ST03;
  StrBeg : IntM;

Begin

  StrBeg:=Length(CStr)-CLength+001;
  If StrBeg<=001 Then
  Begin
    CLength:=Length(CStr);
    AddStr:=('');
    StrBeg:=001;
  End
  Else
  Begin
    AddStr:=('...');
    CLength:=Length(CStr)-StrBeg-002;
  End;
  CutString:=AddStr+Copy(CStr,StrBeg+Length(AddStr),CLength);

End;




Function  Date: ST80;
Begin

  Date:=Copy(DateAll1,012,010);

End;




Function  DateAll1: ST80;
Var
  Day    :  Word;
  DOW    :  Word;
  Month  :  Word;
  Year   :  Word;
  DayS   :  ST02;
  MonthS :  ST02;
  Stri0  :  ST80;
  YearS  :  ST04;

Begin

  GetDate(Year,Month,Day,DOW);
  Str(Day:002,DayS);
  Str(Month:002,MonthS);
  Str(Year:004,YearS);
  Stri0:=DayS+'.'+MonthS+'.'+YearS;
  Stri0:=FillString(Stri0,#032,#048);
  DateAll1:=DayNams2[DOW]+#032+Stri0;

End;




Procedure EOut2(EStr: STFF;HFlag: Byte);
Var
  BNB   : Bool;
  Stri0 : ST10;
  Word0 : Word;

Begin

  ClrKeyBuf;
  SoundError;
  WriteInRAM(EStr,000,000,007,007);
  Wait;
  If HFlag>000 Then System.Halt(HFlag);

End;




Procedure ErrorOut(ErrStr: STFF;HFlag: Byte;KStr: STFF;KChar: Char);
Var
  Byte0 : Byte;
  Char1 : Char;
  Indx2 : Word;
  Stri0 : STFF;
  Word0 : Word;
  Word1 : Word;
  Word2 : Word;

Function  HelpIsTempIO: Bool;
Var
  Byte0 : Byte;
Begin
  HelpIsTempIO:=BF;
  Byte0:=Pos('TempI',ErrStr);
  If Byte0=000 Then
  Begin
    Byte0:=Pos('TempO',ErrStr);
    If Byte0>000 Then
    HelpIsTempIO:=BT;
  End
  Else
  HelpIsTempIO:=BT;
End;

Begin

  SoundError;
  If Not BOOLBLP Then
  Begin
    TextMode(CO80);
    WriteVRN(ErrStr,000,000,080,025,000);
    If (HFlag=000) Or (HFlag=001) Then
    Wait;
    Char0:=UpCase(Char0);
    BooleanErr:=BT;
    If (HFlag<>000) And (HFlag<>002) Then
    Begin
      TextMode(CO80);
      System.Halt(HFlag);
    End;
  End
  Else
  Begin
    If Not HelpIsTempIO Then ScreenParams(BT);
    If (HFlag=000) Or (HFlag=001) Then
    If KStr='' Then Ok(ErrStr)
    Else
    OptionsR(000,000,ErrStr,KStr,KChar,BT);
    Char1:=Char0;
    If Not HelpIsTempIO Then ScreenParams(BF);
    If (HFlag<>000) And (HFlag<>002) Then
    Begin
      TextMode(CO80);
      System.Halt(HFlag);
    End;
    BooleanErr:=BT;
    Char0:=Char1;
  End;

End;




Procedure Execute;
Var
  Byte0 : Byte;

Begin

  For Byte0:=000 To 019 Do
  If TIMEH[Byte0]=Byte0 Then
  If TIMECNTR[Byte0]>000 Then Dec(TIMECNTR[Byte0]);
  ASM
    PushF
    Call  DS:[OldInt1C]
  End;

End;




Function  FillString(FStr: STFF;ExChng: Char;FChar: Char): STFF;
Var
  Byte0 : Byte;

Begin

  For Byte0:=001 To Length(FStr) Do
  If FStr[Byte0]=ExChng Then FStr[Byte0]:=FChar;
  FillString:=FStr;

End;




Procedure FreeBuf(FreeSeg: Word;Var Error: Word);
Var
  Regs  : Regi;

Begin

  With Regs Do
  Begin
    AH:=$49;
    ES:=FreeSeg;
    Intr($21,Regs);
    If Flags And FCarry=000 Then
    Begin
      Error:=000;
      BooleanErr:=BF;
    End
    Else
    Begin
      Error:=AX;
      BooleanErr:=BT;
    End;
  End;

End;




Procedure FSplit(SStr: STFF;Var DStr: ST79;Var NStr: ST08;Var EStr: ST80);
Var
  Byte0 : Byte;
  Byte1 : Byte;
  Stri0 : ST80;

Begin

  DStr:='';
  NStr:='';
  EStr:='';
  Repeat
    Byte0:=Pos(',',SStr);
    If Byte0=000 Then
    Begin
      If EStr='' Then
      DOS.FSplit(SStr,DStr,NStr,EStr);
    End
    Else
    Begin
      If DStr='' Then
      DOS.FSplit(Copy(SStr,001,Byte0-001),DStr,NStr,EStr);
      Stri0:=Copy(SStr,Byte0,Length(SStr));
      Delete(SStr,Byte0,Length(SStr));
      Byte1:=Pos(',',Copy(Stri0,002,Length(Stri0)));
      If Byte1=000 Then
      Begin
        EStr:=EStr+Stri0;
        Stri0:='';
      End
      Else
      Begin
        EStr:=EStr+Copy(Stri0,001,Byte1);
        Delete(Stri0,001,Byte1);
      End;
      SStr:=SStr+Stri0;
    End;
  Until Byte0=000;

End;




Function  GetBuf(Size: IntL;Var Error,MaxSize: Word): Word;
Begin

  If Size And 015<>000 Then
  Begin
    Size:=Size And $FFFFFFF0;
    Inc(Size,016);
  End;
  Size:=Size Div 016;
  RegBX:=Size;
  ASM
    Mov AX,$4800
    Mov BX,RegBX
    Int $21
    PushF
    Pop RegFL
    Mov RegAX,AX
    Mov RegBX,BX
  End;
  If RegFL And FCarry=000 Then
  Begin
    GetBuf:=RegAX;
    Error:=000;
    ACTUALSEG:=RegAX;
    MaxSize:=Size;
    BooleanErr:=BF;
  End
  Else
  Begin
    GetBuf:=000;
    Error:=RegAX;
    MaxSize:=RegBX;
    BooleanErr:=BT;
  End;

End;




Procedure GetCrsrPos(Var Line,Tab: Byte);
Var
  Regs0 : Regi;

Begin

  With Regs0 Do
  Begin
    AX:=$0300;
    Intr($10,Regs0);
    Line:=DX Div 256;
    Tab :=DX-Line*256;
  End;

End;




Function  GetDosError(ECode: IntM): ST80;
Begin

  GetDosError:=EGetDosError(ECode);

End;




Function  GetFreeMem: Word;
Var
  Regs0 : Regi;

Begin

  With Regs0 Do
  Begin
    AX:=$4800;
    BX:=$FFFF;
    Intr($21,Regs0);
    GetFreeMem:=$0000;
    If Flags And FCarry=FCarry Then
    If AX=$08 Then GetFreeMem:=BX;
  End;

End;




Function  GetHexToStr(HexByte: Byte): ST02;
Var
  Byte0  : Byte;
  Byte1  : Byte;

Begin

  Byte0:=HexByte And 240 ShR 004;
  Byte1:=HexByte And 015;
  Byte0:=HexTab[Byte0];
  Byte1:=HexTab[Byte1];
  GetHexToStr:=Chr(Byte0)+Chr(Byte1);

End;




Procedure GetPacked(Name: ST08;BTop: Bool);
Var
  Bool0  : Bool;
  Bool1  : Bool;
  Byte0  : Byte;
  Byte1  : Byte;
  Byte2  : Byte;
  HandF  : Hand;
  MskSiz : Word;
  ScrSeg : Word;
  Word0  : Word;
  Word1  : Word;

Begin

  CrsrOff;
  OFileF(HandF,PRGPATH+'\'+Name+'.PKN',FRead,001);
  If IOResult2=000 Then
  Begin
    BlockRead(HandF,MskSiz,002,CntrHROW0);
    SCRSeg:=GetBuf(MskSiz,Word0,Word1);
    MemErrorOut('GetPacked',Word0,000);
    BlockRead(HandF,Mem[SCRSeg:0],MskSiz,CntrHROW0);
    OFileF(HandF,'',FClose,001);
    Bool0:=BF;
    Word0:=000;
    For Byte0:=000 To 001 Do
    Begin
      Word1:=000;
      Repeat
        If Not Bool0 Then
        Begin
          If Mem[ScrSeg:Word0] And 128=000 Then
          Begin
            Byte1:=Mem[ScrSeg:Word0];
            Inc(Word0);
            Bool0:=BT;
            Bool1:=BT;
          End
          Else
          Begin
            Byte1:=Mem[ScrSeg:Word0] And 127;
            Inc(Word0);
            Byte2:=Mem[ScrSeg:Word0];
            Inc(Word0);
            Bool0:=BT;
            Bool1:=BF;
          End;
        End
        Else
        Begin
          Case Bool1 Of
          BF : Begin
                 Mem[SegB800:Ord(Not BTop)*4000+Word1*002+Byte0]:=Byte2;
                 Inc(Word1);
                 Dec(Byte1);
                 If Byte1=000 Then Bool0:=BF;
               End;
          BT : Begin
                 Mem[SegB800:Ord(Not BTop)*4000+Word1*002+Byte0]:=Mem[ScrSeg:Word0];
                 Inc(Word0);
                 Inc(Word1);
                 Dec(Byte1);
                 If Byte1=000 Then Bool0:=BF;
               End;
          End;
        End;
      Until Word1=2000;
    End;
    FreeBuf(SCRSeg,Word0);
    MemErrorOut('GetPacked',Word0,000);
  End;

End;




Function  GetProgName: ST12;
Var
  DStr  : ST67;
  EStr  : ST04;
  NStr  : ST08;
  Stri0 : ST79;

Begin

  Stri0:=ParamStr(000);
  FSplit(Stri0,DStr,NStr,EStr);
  GetProgName:=NStr+EStr;

End;




Function  GetProgPath: ST67;
Var
  DStr  : ST67;
  EStr  : ST04;
  NStr  : ST08;
  Stri0 : ST79;

Begin

  Stri0:=ParamStr(000);
  FSplit(Stri0,DStr,NStr,EStr);
  GetProgPath:=Copy(DStr,001,Length(DStr)-001);

End;




Function  GetStrToHex(HexStr: ST02): Byte;
Var
  Byte0 : Byte;
  Byte1 : Byte;

Begin

  If HexStr<>'' Then
  Begin
    Byte0:=Ord(Ord(HexStr[001]) And 064=064)*009+Ord(HexStr[001]) And 015;
    Byte1:=Ord(Ord(HexStr[002]) And 064=064)*009+Ord(HexStr[002]) And 015;
    GetStrToHex:=Byte0*016+Byte1;
  End
  Else
  GetStrToHex:=000;

End;




Function  Is50: Bool;
Var
  Byte0 : Byte;

Begin

  Asm
    Mov   DX,03D4h
    Mov   AL,09h
    Out   DX,AL
    Mov   DX,03D5h
    In    AL,DX
    And   AL,031
    Inc   AL
    Mov   Byte0,AL
  End;
  If Byte0<016 Then Is50:=BT Else Is50:=BF;

End;




Function  IsCrsrOff: Bool;
Var
  ByteH : Byte;
  ByteL : Byte;
  Word0 : Word;
  Word1 : Word;

Begin

  Asm
    Mov   DX,03D4h
    Mov   AL,0Eh
    Out   DX,AL
    Mov   DX,03D5h
    In    AL,DX
    Mov   ByteH,AL
    Mov   DX,03D4h
    Mov   AL,0Fh
    Out   DX,AL
    Mov   DX,03D5h
    In    AL,DX
    Mov   ByteL,AL
  End;
  Word0:=ByteL;
  Word1:=ByteH;
  Word0:=Word1*256+Word0;
  If Word0=4000 Then IsCrsrOff:=BT Else IsCrsrOff:=BF;

End;




Function  IsHex(HStr: ST02): Bool;
Var
  Byte0 : Byte;

Begin

  IsHex:=BF;
  HStr:=UpCaseStr(HStr);
  For Byte0:=001 To 002 Do
  Begin
    If Ord(HStr[Byte0])<048 Then Exit;
    If Ord(HStr[Byte0])>070 Then Exit;
    If  (Ord(HStr[Byte0])>057)
    And (Ord(HStr[Byte0])<065) Then Exit;
  End;
  IsHex:=BT;

End;




Function  KeyPressed: Bool;
Begin

  KeyPressed:=MemW[Seg0040:$001A]<>MemW[Seg0040:$001C];

End;




Procedure MakePath(Path: ST79);
Var
  Byte0 : Byte;
  IORes : IntM;
  Stri0 : ST79;
  Stri1 : ST79;

Begin

  GetDir(000,Stri0);
  {$I-} ChDir(Path); {$I+}
  IOResult2:=IOResult;
  If IOResult2>000 Then
  Begin
    Stri1:='';
    Byte0:=000;
    Repeat
      Repeat
        Inc(Byte0);
        Stri1[Byte0]:=Path[Byte0];
      Until (Stri1[Byte0]='\') Or (Byte0=Length(Path));
      Stri1[000]:=Chr(Byte0);
      If Stri1[Byte0]='\' Then
      Begin
        {$I-} ChDir(Copy(Stri1,001,Length(Stri1)-001)); {$I+}
        IOResult2:=IOResult;
        If IOResult2>000 Then
        {$I-} MkDir(Copy(Stri1,001,Length(Stri1)-001)); {$I+}
        IOResult2:=IOResult;
      End
      Else
      Begin
        {$I-} ChDir(Stri1); {$I+}
        IOResult2:=IOResult;
        If IOResult2>000 Then
        {$I-} MkDir(Stri1); {$I+}
      End
    Until Byte0=Length(Path);
  End;
  {$I-} ChDir(Stri0); {$I+}
  IORes:=IOResult;

End;




Function  MakeTime(TStr: ST80): ST80;
Var
  Byte0 : Byte;
  Byte1 : Byte;
  Stri0 : ST80;
  TIndx : Byte;
  TTime : Array[000..002] Of IntL;

Procedure Help1;
Begin
  Inc(TIndx);
  If Byte0>000 Then
  Begin
    If Byte1>000 Then
    Begin
      If Byte0<Byte1 Then
      Begin
        Val(Copy(TStr,001,Byte0-001),TTime[TIndx],ValCode);
        Delete(TStr,001,Byte0);
        Byte0:=Pos('.',TStr);
        Help1;
      End
      Else
      Begin
        Val(Copy(TStr,001,Byte1-001),TTime[TIndx],ValCode);
        Delete(TStr,001,Byte1);
        Byte1:=Pos(':',TStr);
        Help1;
      End;
    End
    Else
    Begin
      Val(Copy(TStr,001,Byte0-001),TTime[TIndx],ValCode);
      Delete(TStr,001,Byte0);
      Byte0:=Pos('.',TStr);
      Help1;
    End;
  End
  Else
  If Byte1>000 Then
  Begin
    Val(Copy(TStr,001,Byte1-001),TTime[TIndx],ValCode);
    Delete(TStr,001,Byte1);
    Byte1:=Pos(':',TStr);
    Help1;
  End
  Else
  If TStr<>'' Then
  Val(TStr,TTime[TIndx],ValCode);
End;

Begin

  TIndx:=255;
  MakeTime:=Time;
  If  (Pos('.',TStr)=000)
  And (Pos(':',TStr)=000) Then Exit;
  For Byte0:=000 To 002 Do TTime[Byte0]:=000;
  Byte0:=Pos('.',TStr);
  Byte1:=Pos(':',TStr);
  Help1;
  If TTime[000]<024 Then
  If TTime[001]<060 Then
  If TTime[002]<060 Then
  Begin
    Str(TTime[000]:002,TStr);
    TStr:=FillString(TStr,#032,#048);
    Str(TTime[001]:002,Stri0);
    Stri0:=FillString(Stri0,#032,#048);
    TStr:=TStr+':'+Stri0;
    Str(TTime[002]:002,Stri0);
    Stri0:=FillString(Stri0,#032,#048);
    MakeTime:=TStr+':'+Stri0;
  End;

End;




Procedure MemErrorOut(ProcNam: ST80;ErrNum: Word;ErrNot: Word);
Var
  Long0 : IntL;
  Stri0 : ST80;
  Word0 : Word;

Begin

  If ErrNum>000 Then
  If ErrNum<>ErrNot Then
  Begin
    If ErrNum=008 Then
    Begin
      Word0:=GetFreeMem;
      Long0:=Word0;
      Word0:=Long0*016 Div 1024;
      Str(Word0,Stri0);
      Stri0:=' (Available: '+Stri0+' KB)';
    End
    Else
    Stri0:='';
    ErrorOut(ProcNam+':'+GetDosError(ErrNum)+Stri0,001,'',#000);
  End;

End;




Procedure MoveMemToVec(IndexT: Byte;IndexField: Word);
Begin

  Move(Mem[VecSel[IndexT]:IndexField*016],VecRec[IndexT],016);

End;




Procedure MoveVecToMem(IndexT: Byte;IndexField: Word);
Begin

  Move(VecRec[IndexT],Mem[VecSel[IndexT]:IndexField*016],016);

End;




Procedure MyExit;
Var
  Word0 : Word;

Begin

  ExitProc:=OldExit;
  SetIntVec($1C,OldInt1C);
  TextMode(CO80);
  MouseInit;
  XMSCallFunc(XMSHANDLE,FreeEMB);


End;




Function  MyKeyPressed: Bool;
Var
  BEvnt : Bool;

Begin

  BEvnt:=KeyPressed;
  If Not BEvnt Then
  BEvnt:=BOOLMOUSEEVENT;
  If Not BEvnt Then
  BEvnt:=V24Avail;
  MyKeyPressed:=BEvnt;

End;




Procedure Ok(OkStr: STFF);
Begin

  OptionsR(010,003,OkStr,'~Ok','O',BT);

End;




Procedure OptionsR(xp,yp: Byte;txtstr,keystr: STFF;
          DefaultKey: char;boolselfxy: Bool);
Begin

  OptionsN(xp,yp,txtstr,keystr,DefaultKey,boolselfxy);

End;




Function  Pos(substr,s: STFF): Byte;
Var
  bool0   : Bool;
  Byte0   : Byte;
  Byte1   : Byte;
  Byte2   : Byte;
  Byte3   : Byte;
  Byte4   : Byte;
  string0 : STFF;
Begin
  Pos:=000;
  If Length(substr)>Length(s) Then Exit;

  Byte1:=Length(s);
  If Byte1=000 Then Exit;
  Byte0:=000;
  Byte2:=Length(substr);
  For Byte3:=000 To Byte1-Byte2 Do
  Begin
    bool0:=true;
    Byte4:=001;
    Repeat
      If  (s[Byte3+Byte4]<>substr[Byte4])
      And (substr[Byte4]<>'?') Then bool0:=false;
      Inc(Byte4);
    Until Not bool0 Or (Byte4>Byte2);
    If bool0 Then
    Begin
      Pos:=Byte3+001;
      Exit;
    End;
  End;
End;




Procedure PressKey(Code1,Code2: Byte);
Const
  Index : Word=000;

Var
  Word0 : Word;
  Word1 : Word;
  Word2 : Word;

Begin

  Word0:=MemW[Seg0040:$001A];
  Word1:=MemW[Seg0040:$001C];
  Word2:=Word1;
  Inc(Word1,002);
  If Word1>00061 Then Word1:=00030;
  Mem[Seg0040:$0000+Word2]:=Code1;
  Mem[Seg0040:$0001+Word2]:=Code2;
  MemW[Seg0040:$001C]:=Word1;

End;




Procedure ScreenOff;
Begin
  Asm
    cli
    mov   dx,$03ba
    in    al,dx
    mov   dx,$03da
    in    al,dx
    mov   dx,$03c0
    in    al,dx
    and   al,11011111b
    out   dx,al
    sti
  End;
End;




Procedure ScreenOn;
Begin
  Asm
    cli
    mov   dx,$03ba
    in    al,dx
    mov   dx,$03da
    in    al,dx
    mov   dx,$03c0
    in    al,dx
    or    al,00100000b
    out   dx,al
    sti
  End;
End;




Procedure ScreenParams(BSave: Bool);
Begin

  EScreenParams(BSave);

End;




Procedure SegOfsDec(Var ISeg,IOfs: Word;DecVal: Word);
Var
  Word0 : Word;

Begin

  Word0:=IOfs;
  Dec(IOfs,DecVal);
  If IOfs>Word0 Then Dec(ISeg,4096);

End;




Procedure SegOfsInc(Var ISeg,IOfs: Word;IncVal: Word);
Var
  Word0 : Word;

Begin

  Word0:=IOfs;
  Inc(IOfs,IncVal);
  If IOfs<Word0 Then
  Inc(ISeg,4096);

End;




Procedure SetCrsrPos(Line,Tab: Byte);
Var
  Regs0 : Regi;

Begin

  With Regs0 Do
  Begin
    AX:=$0200;
    DX:=Line*256+Tab;
    Intr($10,Regs0);
  End;

End;




Procedure SetFileMode(accessmode: Byte);
Begin

  FileMode:=$00;
  FileMode:=FileMode Or accessmode;

End;




Procedure SetScreenMode(Mode,Color: Byte);
Begin

  If Mode=001 Then
  Begin
    If Not Is50 Then
    TextMode(CO80 Or 256);
  End
  Else
  If Is50 Then
  TextMode(CO80);
  Window(ScrM[Mode,000],ScrM[Mode,001],ScrM[Mode,002],ScrM[Mode,003]);
  ClrScr(Color);

End;




Procedure Shadow(X1,X2,Y1,Y2: Byte);
Var
  Byte0 : Byte;
  Byte1 : Byte;

Begin

  Byte0:=X2-X1+001;
  For Byte1:=001 To Byte0 Do
  If X1+Byte1<=079 Then
  Mem[SegB800:Y2*160+X1*002+Byte1*002+001]:=008;
  For Byte0:=Y1+001 To Y2 Do
  For Byte1:=000 To 001 Do
  If X2+Byte1<=079 Then
  Mem[SegB800:Byte0*160+(X2+Byte1)*002+001]:=008;

End;




Procedure ShowP(sptxt: ST80;Var ShwBool: Bool;
          Var ShwHandle: Byte;Width,PX,PY: Byte;PNow,PEnd: IntL;BNew: Bool);
Const
  BIs50     : Bool=BF;

Var
  Byte0     : Byte;
  Byte1     : Byte;
  Byte2     : Byte;
  shor0     : IntS;
  Stri0     : ST10;
  Stri1     : ST80;

Procedure MakeBlock;
Var
  Byte1     : Byte;
  Byte2     : Byte;
Begin
  Byte0:=000;
  BIs50:=Is50;
  If BIs50 Then
  Begin
    Byte0:=001;
    If PY+007<025 Then PY:=PY+024;
  End;
  Mem[SegB800:px*002+py*160]:=218;
  Mem[SegB800:px*002+py*160+001]:=048;
  Mem[SegB800:(px+width)*002+py*160]:=191;
  Mem[SegB800:(px+width)*002+py*160+001]:=063;
  Mem[SegB800:px*002+(py+006+Byte0)*160]:=192;
  Mem[SegB800:px*002+(py+006+Byte0)*160+001]:=048;
  Mem[SegB800:(px+width)*002+(py+006+Byte0)*160]:=217;
  Mem[SegB800:(px+width)*002+(py+006+Byte0)*160+001]:=063;
  For Byte1:=001 To width-001 Do
  Begin
    Mem[SegB800:(px+Byte1)*002+py*160]:=196;
    Mem[SegB800:(px+Byte1)*002+py*160+001]:=048;
    Mem[SegB800:(px+Byte1)*002+(py+006+Byte0)*160]:=196;
    Mem[SegB800:(px+Byte1)*002+(py+006+Byte0)*160+001]:=063;
  End;
  For Byte1:=001 To 005+Byte0 Do
  Begin
    Mem[SegB800:px*002+(py+Byte1)*160]:=179;
    Mem[SegB800:px*002+(py+Byte1)*160+001]:=048;
    Mem[SegB800:(px+width)*002+(py+Byte1)*160]:=179;
    Mem[SegB800:(px+width)*002+(py+Byte1)*160+001]:=063;
  End;
  For Byte1:=001 To 005+Byte0 Do
  For Byte2:=001 To width-001 Do
  Begin
    Mem[SegB800:(px+Byte2)*002+(py+Byte1)*160]:=032;
    Mem[SegB800:(px+Byte2)*002+(py+Byte1)*160+001]:=048;
  End;
End;

Procedure MakeHandle;
Var
  Byte0 : Byte;
Begin
  For Byte0:=000 To SHWC Do
  If Not SHOWPBO[Byte0] Then
  Begin
    SHOWPHA[Byte0]:=Byte0;
    SHOWPBO[Byte0]:=BT;
    shwhandle:=Byte0;
    shwbool:=false;
    Exit;
  End;
  ErrorOut('ShowP: No handles free',001,'',#000);
End;

Begin

  If PEnd>000 Then
  Begin
    If ShwBool Then
    Begin
      CrsrOff;
      MakeBlock;
      MakeHandle;
      ShwBool:=BF;
      If PNow>000 Then
      Begin
        If Not BNew Then
        SHOWSUB[SHWHandle]:=PNow
        Else
        SHOWSUB[SHWHandle]:=000;
      End
      Else
      SHOWSUB[SHWHandle]:=000;
      SHOWPLP[shwhandle]:=000;
      WriteVR(CutString(sptxt,width-004),
      px+(width-Length(CutString(sptxt,width-004))) Div 002,py+002);
      Stri1:='';For Byte2:=000 To width-004 Do Stri1:=Stri1+#177;
      For Byte1:=000 To Byte0 Do WriteVR(Stri1,px+002,py+004+Byte1);
      SHOWPEE[shwhandle]:=(width-003)/(PEnd-SHOWSUB[SHWHandle]+001);
      Shadow(px+001,px+001+width,py,py+007+Byte0);
    End;
    If SHOWPHA[shwhandle]<255 Then
    Begin
      Byte0:=000;
      If BIs50 Then
      Begin
        Byte0:=001;
        If PY+007<025 Then PY:=PY+024;
      End;
      For Byte1:=000 To Byte0 Do
      For Shor0:=SHOWPLP[shwhandle] To
      Round(SHOWPEE[shwhandle]*(pnow-SHOWSUB[SHWHandle]+001))-001 Do
      Mem[SegB800:(px+002+shor0)*002+(py+004+Byte1)*160]:=219;
      SHOWPLP[shwhandle]:=Round(SHOWPEE[shwhandle]*(pnow-SHOWSUB[SHWHandle]+001));
      If pnow-SHOWSUB[SHWHandle]>=pend-SHOWSUB[SHWHandle] Then
      ShowPClr(shwhandle);
      If PEnd=000 Then PEnd:=001;
      Str((PNow-SHOWSUB[SHWHandle])/
      (PEnd-SHOWSUB[SHWHandle])*100:001:000,Stri0);Stri0:=Stri0+'%';
      WriteVR(Stri0,(Width-Length(Stri0)) Div 002+PX+001,PY+003);
    End;
  End;

End;




Procedure ShowPClr(SHWHandle: Byte);
Begin

  If SHWHandle<=SHWC Then
  If SHOWPBO[SHWHandle] Then
  If SHOWPHA[SHWHandle]=SHWHandle Then
  Begin
    SHOWPBO[SHWHandle]:=BF;
    SHOWPHA[SHWHandle]:=255;
    SHOWSUB[SHWHandle]:=000;
  End;

End;




Procedure Sound(Frequence,Delay: Word);
Begin

  CRT.Sound(Frequence);
  CRT.Delay(Delay);
  NoSound;

End;




Procedure SoundDn;
Var
  Word0 : Word;

Begin

  For Word0:=1000 DownTo 0700 Do
  Begin
    CRT.Sound(Word0);
    Delay(001);
  End;
  NoSound;

End;




Procedure SoundError;
Var
  Byte0 : Byte;

Begin

  For Byte0:=000 To 031 Do
  Begin
    Sound(512,005);
    CRT.Delay(005);
  End;

End;




Procedure SoundHallo;
Var
  Byte0 : Byte;

Begin

  For Byte0:=000 To 019 Do
  Begin
    Sound(1500,005);
    CRT.Delay(005);
  End;
  Delay(030);
  For Byte0:=000 To 012 Do
  Begin
    Sound(2000,005);
    CRT.Delay(005);
  End;
  Delay(030);
  For Byte0:=000 To 009 Do
  Begin
    Sound(2500,005);
    CRT.Delay(005);
  End;
  Delay(030);
  For Byte0:=000 To 005 Do
  Begin
    Sound(3000,005);
    CRT.Delay(005);
  End;
  Delay(030);
  For Byte0:=000 To 005 Do
  Begin
    Sound(3000,005);
    CRT.Delay(005);
  End;
  Delay(030);
  For Byte0:=000 To 029 Do
  Begin
    Sound(2500,005);
    CRT.Delay(005);
  End;

End;




Procedure SoundUp;
Var
  Word0 : Word;

Begin

  For Word0:=000 To 399 Do
  Sound(Word0,002);

End;




Procedure Sti; Assembler;
Asm

  Sti

End;




Function  StopTime(Var STPH: Hand;Var MilliS: IntL): Bool;
Var
  Byte0 : Byte;
  Real0 : Real;
  Stri0 : ST80;

Begin

  StopTime:=BF;
  If STPH=255 Then
  If MilliS>000 Then
  Begin
    For Byte0:=000 To 019 Do
    If TIMEH[Byte0]=255 Then
    If TIMECNTR[Byte0]=000 Then
    Begin
      STPH:=Byte0;
      Real0:=MilliS;
      Real0:=Real0/1000*18.2;
      TIMECNTR[STPH]:=Round(Real0);
      TIMEH[STPH]:=STPH;
      MilliS:=000;
      Exit;
    End;
    ErrorOut('StopTime: No handles free',001,'',#000);
  End;
  If STPH<020 Then
  If TIMEH[STPH]=STPH Then
  Begin
    If TIMECNTR[STPH]=000 Then
    Begin
      StopTime:=BT;
      TIMEH[STPH]:=255;
      STPH:=255;
    End;
  End
  Else
  ErrorOut('StopTime: handle error',001,'',#000);

End;




Procedure StopTimeFree(Var STPH: Hand);
Begin

  If STPH<020 Then
  Begin
    TIMEH[STPH]:=255;
    TIMECNTR[STPH]:=000;
    STPH:=255;
  End;

End;




Procedure StringInString(Str1: STFF;Var Str2: STFF;Index: Byte);
Var
  Byte0 : Byte;
  Byte1 : Byte;

Begin

  Byte0:=001;
  For Byte1:=Index To Length(Str2) Do
  Begin
    If Byte0>Length(Str1) Then Exit;
    Str2[Byte1]:=Str1[Byte0];
    Inc(Byte0);
  End;

End;




Function  StrTurnAround(TAStr: STFF): STFF;
Var
  Byte0 : Byte;
  Stri0 : STFF;

Begin

  Stri0:='';
  If Length(TAStr)>000 Then
  For Byte0:=000 To Length(TAStr)-001 Do
  Stri0:=Stri0+TAStr[Length(TAStr)-Byte0];
  StrTurnAround:=Stri0;

End;




Procedure TempI;
Var
  BoolErr : Bool;
  Size    : Word;
  Stri0   : ST03;
  Word0   : Word;
  Word1   : Word;
  Word2   : Word;

Begin

  BoolErr:=BooleanErr;
  Str(TempIOByte,Stri0);
  If TempIOByte>=020 Then
  ErrorOut('TempI: TempIOByte='+Stri0+'. Program end',001,'',#000);
  Size:=Ord(Is50);
  Size:=4000+4000*Size;
  Begin
    TempIOSeg[TempIOByte]:=GetBuf(Size+002,Word1,Word2);
    MemErrorOut('TempI',Word1,000);
    MemW[TempIOSeg[TempIOByte]:0]:=Size;
    Move(Mem[SegB800:0],Mem[TempIOSeg[TempIOByte]:2],Size);
  End;
  Inc(TempIOByte);
  BooleanErr:=BoolErr;

End;




Procedure TempO;
Var
  BoolErr : Bool;
  Stri0   : ST03;
  Word0   : Word;

Begin

  BoolErr:=BooleanErr;
  Dec(TempIOByte);
  If TempIOByte=255 Then
  ErrorOut('TempO: TempIOByte=255. Program end',001,'',#000);
  Word0:=MemW[TempIOSeg[TempIOByte]:0];
  Move(Mem[TempIOSeg[TempIOByte]:2],Mem[SegB800:0],Word0);
  FreeBuf(TempIOSeg[TempIOByte],Word0);
  MemErrorOut('TempO',Word0,000);
  BooleanErr:=BoolErr;

End;




Function  Time: ST80;
Var
  Hour  : Word;
  Mic   : Word;
  Min   : Word;
  Sec   : Word;
  Stri0 : ST02;
  Stri1 : ST08;

Begin

  GetTime(Hour,Min,Sec,Mic);
  Str(Hour:002,Stri0);
  Stri1:=Stri0+':';
  Str(Min:002,Stri0);
  Stri1:=Stri1+Stri0+':';
  Str(Sec:002,Stri0);
  Stri1:=Stri1+Stri0;
  Stri1:=FillString(Stri1,#032,#048);
  Time:=Stri1;

End;




Procedure UnPackPGX(PSeg,POfs: Word;PGXx: Byte;Size: Word);
Label ENDE,
      LOOP1,
      LOOP2,
      NOTSAME,
      SAME;

Var
  Byte0    : Byte;
  Byte1    : Byte;
  Byte2    : Byte;
  Word0    : Word;
  Word1    : Word;
  PackSeg  : Word;

Begin

  PackSeg:=GetBuf(PackSize-007,Word0,Word1);
  MemErrorOut('UnPackPGX ('+NamLst[PGXx]+'): GetBuf ',Word0,000);
  Move(Mem[PSeg:POfs],Mem[PackSeg:0],PackSize-007);

  Byte2:=000;
  Word0:=000;

  LOOP1:
  Word1:=000;

  LOOP2:
  Byte0:=Mem[PackSeg:Word0];
  Inc(Word0);
  If Byte0<128 Then Goto NOTSAME;
  Byte0:=Byte0 And 127;
  Byte1:=Mem[PackSeg:Word0];
  Inc(Word0);

  SAME:
  Mem[Screen_Sel[PGXx]:Word1*002+Byte2]:=Byte1;
  Inc(Word1);
  Dec(Byte0);
  If Byte0>000 Then Goto SAME;
  If Word1<Size Then Goto LOOP2;
  Goto ENDE;

  NOTSAME:
  Mem[Screen_Sel[PGXx]:Word1*002+Byte2]:=Mem[PackSeg:Word0];
  Inc(Word0);
  Inc(Word1);
  Dec(Byte0);
  If Byte0>000 Then Goto NOTSAME;
  If Word1<Size Then Goto LOOP2;

  ENDE:
  Inc(Byte2);
  If Byte2<002 Then Goto LOOP1;

  FreeBuf(PackSeg,Word0);
  MemErrorOut('UnPackPGX ('+NamLst[PGXx]+'): FreeBuf',Word0,000);

End;




Procedure UnPackBlk(Size: Word);
Label ENDE1,
      ENDE2,
      LOOP1,
      LOOP2,
      NOTSAME1,
      NOTSAME2,
      SAME1,
      SAME2;

Var
  Byte0 : Byte;
  Byte1 : Byte;
  Word0 : Word;
  Word1 : Word;

Begin

  Word0:=000;
  Word1:=000;

  LOOP1:
  Byte0:=Mem[BLKPAKSEG:0+Word0];
  Inc(Word0);
  If Byte0<128 Then Goto NOTSAME1;
  Byte0:=Byte0 And 127;
  Byte1:=Mem[BLKPAKSEG:0+Word0];
  Inc(Word0);

  SAME1:
  Mem[ARRAYBL:Word1]:=Byte1;
  Inc(Word1);
  Dec(Byte0);
  If Byte0>000 Then Goto SAME1;
  If Word1<size Then Goto LOOP1;
  Goto ENDE1;

  NOTSAME1:
  Mem[ARRAYBL:Word1]:=Mem[BLKPAKSEG:0+Word0];
  Inc(Word0);
  Inc(Word1);
  Dec(Byte0);
  If Byte0>000 Then Goto NOTSAME1;
  If Word1<size Then Goto LOOP1;

  ENDE1:
  Inc(size,size);

  LOOP2:
  Byte0:=Mem[BLKPAKSEG:0+Word0];
  Inc(Word0);
  If Byte0<128 Then Goto NOTSAME2;
  Byte0:=Byte0 And 127;
  Byte1:=Mem[BLKPAKSEG:0+Word0];
  Inc(Word0);

  SAME2:
  Mem[ARRAYBL:Word1]:=Byte1;
  Inc(Word1);
  Dec(Byte0);
  If Byte0>000 Then Goto SAME2;
  If Word1<size Then Goto LOOP2;
  Goto ENDE2;

  NOTSAME2:
  Mem[ARRAYBL:Word1]:=Mem[BLKPAKSEG:0+Word0];
  Inc(Word0);
  Inc(Word1);
  Dec(Byte0);
  If Byte0>000 Then Goto NOTSAME2;
  If Word1<size Then Goto LOOP2;

  ENDE2:

End;




Function  UpCase(UChar: Char): Char;
Begin

  Case UChar Of
  '' : UpCase:='';
  '' : UpCase:='';
  '' : UpCase:='';
  Else
  UpCase:=System.UpCase(UChar);
  End;

End;




Function  UpCaseStr(UStr: STFF): STFF;
Var
  Byte0 : Byte;

Begin

  For Byte0:=001 To Length(UStr) Do
  UStr[Byte0]:=UpCase(UStr[Byte0]);
  UpCaseStr:=UStr;

End;




Function  V24Avail: Boolean;
Begin

  V24Avail:=(MemW[V24HPSeg:V24HPOfs]<>MemW[V24TPSeg:V24TPOfs]);

End;




Procedure Wait;
Const
  STPH0 : Hand=255;

Var
  Long0 : IntL;

Procedure Help1;
Begin
  If STPH0=255 Then
  Long0:=300000;
End;

Procedure HelpStopTime;
Begin
  If StopTime(STPH0,Long0) Then
  Begin
    ScreenParams(BT);
    SwapVectors;
    Exec(PRGPATH+'\LSCHRIFT.EXE','7WCOPY.LSI');
    SwapVectors;
    FNBNAME:='';
    FNB25NAME:='';
    ScreenParams(BF);
  End;
End;

Procedure Wait2;
Begin
  Case Char1 of
  #015 : BooleanTL   :=BT;
  #018 : BooleanAltE :=BT;
  #019 : BooleanAltRi:=BT;
  #022 : BooleanAltUp:=BT;
  #023 : BooleanAltI :=BT;
  #024 : BooleanAltO :=BT;
  #025 : ;
  #031 : ;
  #032 : Begin
           BooleanAltD:=BT;
           BooleanAltDn:=BT;
         End;
  #033 : Begin
           BooleanAltF:=BT;
           BooleanShowList:=BT;
         End;
  #038 : Begin
           BooleanAltL:=BT;
           BooleanAltLe:=BT;
         End;
  #044 : BooleanAltZ:=BT;
  #047 : BooleanAltV:=BT;
  #060 : BooleanF2   :=BT;
  #061 : BooleanF3   :=BT;
  #062 : BooleanF4   :=BT;
  #063 : BooleanF5   :=BT;
  #064 : BooleanF6   :=BT;
  #065 : BooleanF7   :=BT;
  #066 : BooleanF8   :=BT;
  #067 : BooleanF9   :=BT;
  #068 : BooleanFA   :=BT;
  #071 : BooleanHome :=BT;
  #072 : BooleanUp   :=BT;
  #073 : BooleanPU   :=BT;
  #075 : BooleanLeft :=BT;
  #077 : BooleanRig  :=BT;
  #079 : BooleanEnd  :=BT;
  #080 : BooleanDn   :=BT;
  #081 : BooleanPD   :=BT;
  #082 : BooleanIns  :=BT;
  #083 : BooleanDel  :=BT;
  #087 : BooleanShiftF4:=BT;
  Else
  Begin
    {SoundError;}
    BooleanNoK:=BT;
  End;
  End;
End;

Begin

  Repeat
    Help1;
    WaitClr;
    HelpStopTime;
    If MyKeyPressed Then
    Begin
      BOOLWAIT:=BT;
      If Not BOOLMOUSEEVENT Then
      Begin
        BooleanNoK:=BF;
        Char0:=ReadKey;
        If Char0=#000 Then
        Char1:=ReadKey;
        Case Char0 Of
        #000 : Wait2;
        #001 : BooleanCntrlA :=BT;
        #002 : BooleanCntrlB :=BT;
        #011 : Begin
                 BooleanCntrlC:=BT;
                 BooleanCntrlK:=BT;
               End;
        #004 : BooleanCntrlD :=BT;
        #005 : BooleanCntrlE :=BT;
        #015 : BooleanCntrlO :=BT;
        #016 : BooleanCntrlP :=BT;
        #018 : BooleanCntrlR :=BT;
        #019 : BooleanCntrlS :=BT;
        #004 : BooleanCntrlDn:=BT;
        #012 : BooleanCntrlLe:=BT;
        #018 : BooleanCntrlRi:=BT;
        #021 : BooleanCntrlUp:=BT;
        #024 : BooleanCntrlX :=BT;
        #025 : BooleanCntrlY :=BT;
        #010 : Boolean13C    :=BT;
        #013 : Boolean13     :=BT;
        #008 : BooleanBack   :=BT;
        #027 : BooleanEx     :=BT;
        #032 : Boolean32     :=BT;
        #009 : BooleanTR     :=BT;
        End;
        If BooleanBack Then BooleanKey:=BT;
        If BooleanDel  Then BooleanKey:=BT;
        If BooleanIns  Then BooleanKey:=BT;
        Case Char0 Of
        #032..#223,
        #225..#255 : BooleanKey:=BT;
        End;
      End;
    End;
  Until Not BooleanNoK Or Not BOOLWAIT Or BOOLMOUSEEVENT;
  If BOOLWAIT Then
  If STPH0<255 Then
  StopTimeFree(STPH0);

End;




Procedure WaitClr;
Begin

  ASM
    Mov   Boolean13,000
    Mov   Boolean13C,000
    Mov   Boolean32,000
    Mov   BooleanAltD,000
    Mov   BooleanAltDn,000
    Mov   BooleanAltE,000
    Mov   BooleanAltF,000
    Mov   BooleanAltF1,000
    Mov   BooleanAltI,000
    Mov   BooleanAltL,000
    Mov   BooleanAltLe,000
    Mov   BooleanAltO,000
    Mov   BooleanAltRi,000
    Mov   BooleanAltUp,000
    Mov   BooleanAltV,000
    Mov   BooleanAltZ,000
    Mov   BooleanBack,000
    Mov   BooleanBlockD,000
    Mov   BooleanBlockR,000
    Mov   BooleanCntrlA,000
    Mov   BooleanCntrlB,000
    Mov   booleanCntrlC,000
    Mov   BooleanCntrlD,000
    Mov   BooleanCntrlE,000
    Mov   BooleanCntrlEnd,000
    Mov   BooleanCntrlK,000
    Mov   BooleanCntrlO,000
    Mov   BooleanCntrlP,000
    Mov   BooleanCntrlR,000
    Mov   BooleanCntrlS,000
    Mov   BooleanCntrlDn,000
    Mov   BooleanCntrlF3,000
    Mov   BooleanCntrlF4,000
    Mov   BooleanCntrlF5,000
    Mov   BooleanCntrlF7,000
    Mov   BooleanCntrlFA,000
    Mov   BooleanCntrlLe,000
    Mov   BooleanCntrlRi,000
    Mov   BooleanCntrlUp,000
    Mov   BooleanCntrlX,000
    Mov   BooleanCntrlY,000
    Mov   BooleanDel,000
    Mov   BooleanDn,000
    Mov   BooleanEnd,000
    Mov   BooleanEx,000
    Mov   BooleanF1,000
    Mov   BooleanF2,000
    Mov   BooleanF3,000
    Mov   BooleanF4,000
    Mov   BooleanF5,000
    Mov   BooleanF6,000
    Mov   BooleanF7,000
    Mov   BooleanF8,000
    Mov   BooleanF9,000
    Mov   BooleanFA,000
    Mov   BooleanHome,000
    Mov   BooleanIns,000
    Mov   BooleanKey,000
    Mov   BooleanLeft,000
    Mov   BooleanNoK,001
    Mov   BooleanPD,000
    Mov   BooleanPU,000
    Mov   BooleanRig,000
    Mov   BooleanShiftF1,000
    Mov   BooleanShiftF4,000
    Mov   BooleanShiftIns,000
    Mov   BooleanShowList,000
    Mov   BooleanTL,000
    Mov   BooleanTR,000
    Mov   BooleanUp,000
    Mov   BOOLMOUSEEVENT,000
    Mov   Char0,000
  End;

End;




Procedure WaitForVerticalRetrace; Assembler;
Asm

  Mov  DX,$03DA
  @WFR:
  In   AL,DX
  Test AL,008
  Je   @WFR

End;




Procedure WhereIsCrsr(Var XPos,YPos: Byte);
Var
  ByteH : Byte;
  ByteL : Byte;
  Word0 : Word;
  Word1 : Word;

Begin

  Asm
    Mov   DX,03D4h
    Mov   AL,0Eh
    Out   DX,AL
    Mov   DX,03D5h
    In    AL,DX
    Mov   ByteH,AL
    Mov   DX,03D4h
    Mov   AL,0Fh
    Out   DX,AL
    Mov   DX,03D5h
    In    AL,DX
    Mov   ByteL,AL
  End;
  Word0:=ByteL;
  Word1:=ByteH;
  Word0:=Word1*256+Word0;
  YPos:=Word0 Div 080;
  XPos:=Word0-(YPos*080);

End;




Procedure Write7(Count: Byte);
Var
  Byte0 : Byte;

Begin

  For Byte0:=001 To Count Do
  Begin
    Sound(1000,500);
    Delay(500);
  End;
  Delay(500);

End;




Procedure WriteInRAM(VStr: STFF;X,Y,Col1,Col2: Byte);
Var
  Bool0 : Bool;
  Byte0 : Byte;
  Byte1 : Byte;

Begin

  Bool0:=BF;
  Byte0:=001;
  Byte1:=000;
  If Length(VStr)>000 Then
  Repeat
    If  (Col1<>Col2)
    And (VStr[Byte0]='~') Then
    Begin
      Mem[SegB800:Y*160+(X+Byte1)*002+001]:=Col2;
      Bool0:=BT;
    End
    Else
    Begin
      Mem[SegB800:Y*160+(X+Byte1)*002]:=Ord(VStr[Byte0]);
      If Not Bool0 Then Mem[SegB800:Y*160+(X+Byte1)*002+001]:=Col1
      Else Bool0:=BF;
      Inc(Byte1);
    End;
    Inc(Byte0);
  Until Byte0>Length(VStr);

End;




Procedure WriteVR(VStr: STFF;X,Y: Byte);
Var
  Byte0 : Byte;

Begin

  For Byte0:=001 To Length(VStr) Do
  Mem[SegB800:Y*160+X*002+(Byte0-001)*002]:=Ord(VStr[Byte0]);

End;




Procedure WriteVRN(VStr: STFF;X,Y: Byte;Width,Depth,MLen: Byte);
Var
  Byte0 : Byte;
  Byte1 : Byte;
  Byte2 : Byte;
  Byte3 : Byte;
  Byte4 : Byte;
  Byte5 : Byte;

Begin

  If Length(VStr)>000 Then
  Begin
    Byte0:=001;
    Byte3:=000;
    Byte4:=Pos('~',VStr);
    If Byte4>000 Then Delete(VStr,Byte4,001);
    Repeat
      Byte1:=000;
      Byte2:=000;
      Repeat
        If (VStr[Byte0+Byte1]=#032)
        Or (VStr[Byte0+Byte1]=#045) Then Byte2:=Byte1;
        Inc(Byte1);
      Until (Byte0+Byte1=Length(VStr)) Or (Byte1=Width);
      If (Byte2=000)
      Or (Byte0+Byte1=Length(VStr)) Then Byte2:=Byte1;
      For Byte1:=000 To Byte2 Do
      Begin
        If Byte0+Byte1=Byte4 Then
        Begin
          Byte5:=000;
          Repeat
            Mem[SegB800:(y+Byte3)*160+(x+Byte4-
            Byte0+(Width-Byte2) Div 002)*002+001]:=143;
            Inc(Byte4);
            Inc(Byte5);
          Until Byte5=MLen;
          Byte4:=000;
        End;
        Mem[SegB800:(y+Byte3)*160+(x+Byte1+(Width-Byte2) Div 002)*002]:=
        Ord(VStr[Byte0+Byte1]);
      End;
      Inc(Byte3);
      Inc(Byte0,Byte2+001);
    Until (Byte3=Depth) Or (Byte0>=Length(VStr));
  End;

End;




Procedure ZCopy(SPath,TPath: ST79;BShow: Bool);
Var
  CSeg   : Word;
  Device : Byte;
  Error  : IntM;
  HandFS : Hand;
  HandFT : Hand;
  Long0  : IntL;
  Long1  : IntL;
  MSize  : Word;
  Result : Word;
  Time   : IntL;
  SHWB0  : Bool;
  SHWH0  : Byte;

Procedure Help1;
Begin
  If Error=000 Then
  Error:=IOResult2;
End;

Begin

  TempI;
  OFileF(HandFS,SPath,FRead,001);
  If IOResult2=000 Then
  Begin
    OFileF(HandFT,TPath,FNew,001);
    If IOResult2=000 Then
    Begin
      ArrFVarFTime[HandFT]:=
      ArrFVarFTime[HandFS];
      Long0:=FileSize(HandFS);
      Device:=Ord(TPath[001])-064;
      If DiskFree(Device)>Long0 Then
      Begin
        CSeg:=GetBuf(16384,Result,MSize);
        MemErrorOut('ZCopy',Result,000);
        Long1:=FileSize(HandFS);
        Error:=000;
        Long0:=000;
        SHWB0:=BT;
        Repeat
          If BShow Then
          ShowP('Kopiere '+CutString(SPath,058),
          SHWB0,SHWH0,060,010,014,Long0,Long1,BF);
          BlockRead(HandFS,Mem[CSeg:0],16384,Result);
          Help1;
          BlockWrite(HandFT,Mem[CSeg:0],Result,Result);
          Help1;
          Inc(Long0,Result);
        Until Result<16384;
        If BShow Then
        ShowP('Kopiere '+CutString(SPath,058),
        SHWB0,SHWH0,060,010,014,Long0,Long1,BF);
        If Long0<Long1 Then
        If BShow Then ShowPClr(SHWH0);
        FreeBuf(CSeg,Result);
        MemErrorOut('ZCopy',Result,000);
      End
      Else
      Begin
        Error:=008;
        ErrorOut('ZCopy: target drive has not enough '+
        'bytes free',000,'',#000);
      End;
      SetFTime(FVarF,HandFT,Time);
      Help1;
      OFileF(HandFT,'',FClose,001);
      Help1;
    End
    Else
    Error:=IOResult2;
    OFileF(HandFS,'',FClose,001);
    Help1;
  End
  Else
  Error:=IOResult2;
  If Error<>000 Then
  BooleanErr:=BT
  Else
  BooleanErr:=BF;
  TempO;

End;




Procedure Test(TStr: STFF;BWait: Bool;Line: Byte);
Begin

  If BWait Then Click;
  WriteInRAM(BuendigL2(080,'*'+TStr+'*'),000,Line,007,007);
  If BWait Then Wait;

End;




Procedure AllocateFVarHandle(VTyp: VTyps;Var FVHandle: Hand);
Var
  Byte0 : Byte;
  Word0 : Word;
  Word1 : Word;

Begin

  BooleanErr:=BF;
  Case VTyp Of
  FVarF : Begin
            For Byte0:=000 To MaxHandlesF Do
            If ArrFHndF[Byte0] And 32768>000 Then
            Begin
              ArrFHndF[Byte0]:=ArrFHndF[Byte0] And 000 Or 16384 Or Byte0;
              FVHandle:=Byte0;
              Exit;
            End;
            ErrorOut('All handles from type FVarF are allocated',001,'',#000);
          End;
  FVarT : Begin
            For Byte0:=000 To MaxHandlesT Do
            If ArrFHndT[Byte0] And 32768>000 Then
            Begin
              ArrFHndT[Byte0]:=ArrFHndT[Byte0] And 000 Or 16384 Or Byte0;
              ArrFVarTSeg[Byte0]:=GetBuf(TSSize+016,Word0,Word1);
              MemErrorOut('AllocFVarHandle TSeg',Word0,000);
              ArrFVarTIdxHRead[Byte0]:=000;
              FVHandle:=Byte0;
              Exit;
            End;
            ErrorOut('All handles from type FVarT are allocated',001,'',#000);
          End;
  End;

End;




Procedure BlockRead(HNum: Hand;Var VR;CntrR: Word;Var CntrHR: Word);
Begin

  If ArrFHndF[HNum]=HNum Then
  Begin
    BlockRead2F(HNum,VR,CntrR,CntrHR);
    ErrHandIO(IOResult2,PNBlockRead,HNum);
  End
  Else
  ErrorOut('BlockRead: Handle not defined',001,'',#000);

End;




Procedure BlockRead2F(HNum: Hand;Var VR;CntrR: Word;Var CntrHR: Word);
Begin

  EBlockRead2F(HNum,VR,CntrR,CntrHR);

End;




Procedure BlockRead2T(HNum: Hand;Var VR;CntrR: Word;Var CntrHR: Word);
Begin

  EBlockRead2T(HNum,VR,CntrR,CntrHR);

End;




Procedure BlockWrite(HNum: Hand;Var VW;CntrW: Word;Var CntrHW: Word);
Begin

  If ArrFHndF[HNum]=HNum Then
  Begin
    BlockWrite2F(HNum,VW,CntrW,CntrHW);
    ErrHandIO(IOResult2,PNBlockWrite,HNum);
  End
  Else
  ErrorOut('BlockWrite: Handle not defined',001,'',#000);

End;




Procedure BlockWrite2F(HNum: Hand;Var VW;CntrW: Word;Var CntrHW: Word);
Begin

  EBlockWrite2F(HNum,VW,CntrW,CntrHW);

End;




Procedure CommitFile(VTyp: VTyps;HNum: Hand);
Begin

  ECommitFile(VTyp,HNum);

End;




Function  EOF(VTyp: VTyps;HNum: Hand): Bool;
Var
  EOFX  : Bool;
  Long0 : IntL;

Begin

  EOFX:=BT;
  Case VTyp Of
  FVarF : If ArrFHndF[HNum]=HNum Then
          Begin
            EOFX:=EOF2F(HNum);
            ErrHandIO(IOResult2,PNEOF_F,HNum);
          End
          Else
          ErrorOut('EOF: Handle for FVarF not defined',001,'',#000);
  FVarT : If ArrFHndT[HNum] And 49407=HNum Then
          Begin
            If FilePos2T(HNum)<FileSize2T(HNum) Then EOFX:=BF
            Else
            Begin
              If Mem[ArrFVarTSeg[HNum]:
              ArrFVarTIdxTRead[HNum]]=026 Then EOFX:=BT
              Else
              If ArrFVarTIdxHRead[HNum]<=000 Then EOFX:=BT Else EOFX:=BF;
            End;
            ErrHandIO(IOResult2,PNEOF_T,HNum);
          End
          Else
          ErrorOut('EOF: Handle for FVarT not defined',001,'',#000);
  End;
  EOF:=EOFX;

End;




Function  EOF2F(HNum: Hand): Bool;
Begin

  EOF2F:=EEOF2F(HNum);

End;




Procedure ErrHandIO(Error: Word;PIONam: ProcsIO;HNum: Hand);
Begin

  If Error>000 Then
  Begin
    ScreenParams(BT);
    SetScreenMode(000,007);
    SetGround('',BT);
    ErrHandIO2(Error,PIONam,HNum);
    ScreenParams(BF);
  End;

End;




Procedure ErrHandIO2(Error: Word;PIONam: ProcsIO;HNum: Hand);
Begin

  EErrHandIO2(Error,PIONam,HNum);

End;




Function  FilePos(HNum: Hand): IntL;
Begin

  If ArrFHndF[HNum]=HNum Then
  Begin
    FilePos:=FilePos2F(HNum);
    ErrHandIO(IOResult2,PNFilePos,HNum);
  End
  Else
  ErrorOut('FilePos: Handle not defined',001,'',#000);

End;




Function  FilePos2F(HNum: Hand): IntL;
Begin

  FilePos2F:=EFilePos2F(HNum);

End;




Function  FilePos2T(HNum: Hand): IntL;
Begin

  FilePos2T:=EFilePos2T(HNum);

End;




Function  FileSize(HNum: Hand): IntL;
Begin

  If ArrFHndF[HNum]=HNum Then
  Begin
    FileSize:=FileSize2F(HNum);
    ErrHandIO(IOResult2,PNFileSize,HNum);
  End
  Else
  ErrorOut('FileSize: Handle not defined',001,'',#000);

End;




Function  FileSize2F(HNum: Hand): IntL;
Begin

  FileSize2F:=EFileSize2F(HNum);

End;




Function  FileSize2T(HNum: Hand): IntL;
Begin

  FileSize2T:=EFileSize2T(HNum);

End;




Procedure FreeFVarHandle(VTyp: VTyps;FVHandle: Hand);
Var
  Word0 : Word;

Begin

  Case VTyp Of
  FVarF : Begin
            If ArrFHndF[FVHandle] And 32768=000 Then
            Begin
              If ArrFHndF[FVHandle] And 16384=000 Then
              Begin
                ArrFHndF[FVHandle]:=32768;
              End
              Else
              ErrorOut('FreeFVarHandle: Handle '+
              'FVarF war noch nicht auf HNum zurckgesetzt',001,'',#000);
            End
            Else
            ErrorOut('FreeFVarHandle: Handle '+
            'FVarF war schon frei',001,'',#000);
          End;
  FVarT : Begin
            If ArrFHndT[FVHandle] And 32768=000 Then
            Begin
              If ArrFHndT[FVHandle] And 16384=000 Then
              Begin
                ArrFHndT[FVHandle]:=32768;
                FreeBuf(ArrFVarTSeg[FVHandle],Word0);
                MemErrorOut('FreeFVarHandle',Word0,009);
                ArrFVarTSeg[FVHandle]:=000;
              End
              Else
              ErrorOut('FreeFVarHandle: Handle '+
              'FVarT war noch nicht auf HNum zurckgesetzt',001,'',#000);
            End
            Else
            ErrorOut('FreeFVarHandle: Handle '+
            'FVarT war schon frei',001,'',#000);
          End;
  End;

End;




Procedure GetFAttr(VTyp: VTyps;HNum: Hand;Var Attr: Word);
Procedure GetFAttrHelp;
Begin
  If VTyp=FVarF Then
  Begin
    ArrFHndF[HNum]:=ArrFHndF[HNum] And 000 Or HNum;
  End
  Else
  If VTyp=FVarT Then
  Begin
    ArrFHndT[HNum]:=ArrFHndT[HNum] And 8192 Or HNum;
  End;
End;
Begin

  Case VTyp Of
  FVarF : If ArrFHndF[HNum]=HNum Or 16384 Then
          Dos.GetFAttr(ArrFVarF[HNum],Attr)
          Else
          ErrorOut('GetFAttr: Handle fr FVarF nicht'+
          ' definiert oder Datei offen',001,'',#000);
  FVarT : If ArrFHndT[HNum] And 57343=HNum Or 16384 Then
          Dos.GetFAttr(ArrFVarT[HNum],Attr)
          Else
          ErrorOut('GetFAttr: Handle fr FVarT nicht'+
          ' definiert oder Datei offen',001,'',#000);
  End;
  GetFAttrHelp;
  FreeFVarHandle(VTyp,HNum);

End;




Function  GetFreeFVars: Word;
Var
  Byte0 : Byte;
  ByteF : Byte;
  ByteT : Byte;
  Word0 : Word;

Begin

  ByteF:=000;
  For Byte0:=000 To MaxHandlesF Do
  If ArrFHndF[Byte0] And 32768>000 Then Inc(ByteF);
  ByteT:=000;
  For Byte0:=000 To MaxHandlesT Do
  If ArrFHndT[Byte0] And 32768>000 Then Inc(ByteT);
  Word0:=ByteF;
  Word0:=Word0 ShL 008;
  Word0:=Word0 Or ByteT;
  GetFreeFVars:=Word0;

End;




Procedure GetFTime(VTyp: VTyps;HNum: Hand;Var Time: IntL);
Begin

  Case VTyp Of
  FVarF : If ArrFHndF[HNum]=HNum Then
          Dos.GetFTime(ArrFVarF[HNum],Time)
          Else
          ErrorOut('GetFTime: Handle fr FVarF nicht definiert',001,'',#000);
  FVarT : If ArrFHndT[HNum] And 255=HNum Then
          Dos.GetFTime(ArrFVarT[HNum],Time)
          Else
          ErrorOut('GetFTime: Handle fr FVarT nicht definiert',001,'',#000);
  End;

End;




Procedure GetPathFromFVar(VTyp: VTyps;HNum: Hand;Var GPath: ST79);
Var
  Byte0 : Byte;
  Byte1 : Byte;

Begin

  If VTyp=FVarF Then
  Begin
    With FileRec(ArrFVarF[HNum]) Do
    Begin
      Byte0:=000;
      Byte1:=000;
      Repeat
        If Name[Byte0]=#000 Then
        Begin
          Byte1:=Byte0;
          Move(Name[000],GPath[001],Byte1);
          GPath[000]:=Chr(Byte1);
          Exit;
        End;
        Inc(Byte0);
      Until Byte0>079;
    End;
  End
  Else
  If VTyp=FVarT Then
  Begin
    With FileRec(ArrFVarT[HNum]) Do
    Begin
      Byte0:=000;
      Byte1:=000;
      Repeat
        If Name[Byte0]=#000 Then
        Begin
          Byte1:=Byte0;
          Move(Name[000],GPath[001],Byte1);
          GPath[000]:=Chr(Byte1);
          Exit;
        End;
        Inc(Byte0);
      Until Byte0>079;
    End;
  End;

End;




Procedure IniFVarHandles;
Var
  Byte0 : Byte;

Begin

  For Byte0:=000 To MaxHandlesF Do
  Begin
    ArrFHndF[Byte0]:=32768;
    FillChar(ArrFVarF[Byte0],
    SizeOf(ArrFVarF[Byte0]),000);
  End;
  For Byte0:=000 To MaxHandlesT Do
  Begin
    ArrFHndT[Byte0]:=32768;
    ArrFVarTSeg[Byte0]:=000;
    FillChar(ArrFVarT[Byte0],
    SizeOf(ArrFVarT[Byte0]),000);
  End;

End;




Function  IsFileAlloc(Path: ST79): Bool;
Var
  HandF : Hand;
  IORes : IntM;

Begin

  OFileF(HandF,Path,FReadWrite,001);
  Seek(HandF,FileSize(HandF));
  Truncate(HandF);
  IORes:=IOResult2;
  OFileF(HandF,'',FClose,001);
  If IORes=000 Then
  IsFileAlloc:=BF
  Else
  IsFileAlloc:=BT;

End;




Procedure OFile(VTyp: VTyps;Var HNum: Hand;
          FPath: ST79;OMod: OMods;RSize: Word);
Begin

  TempI;
  EOFile(VTyp,HNum,FPath,OMod,RSize);
  TempO;

End;




Procedure OFileF(Var HNum: Hand;FPath: ST79;
          OMod: OMods;RSize: Word);
Begin

  OFile(FVarF,HNum,FPath,OMod,RSize);

End;




Procedure OFileT(Var HNum: Hand;TPath: ST79;OMod: OMods);
Begin

  OFile(FVarT,HNum,TPath,OMod,001);

End;




Procedure Read(HNum: Hand;Var RChar: Char);
Begin

  If ArrFHndT[HNum] And 49407=HNum Then
  Begin
    BlockRead2T(HNum,RChar,001,CntrHROW0);
    ErrHandIO(IOResult2,PNRead,HNum);
  End
  Else
  ErrorOut('Read: Handle not defined',001,'',#000);

End;




Procedure ReadLn(HNum: Hand);
Var
  BoolGotStr : Bool;
  HlpIdx     : IntM;
  HlpStr     : STFF;
  IDXHR      : IntM;
  IDXTR      : IntM;
  RdSeg      : Word;

Procedure ReadLnHelp(MoveSize: Word);
Begin
  Inc(IDXTR,MoveSize+001);
  Dec(IDXHR,MoveSize+001);
End;

Begin

  HlpStr:='';
  BoolGotStr:=BF;
  If ArrFHndT[HNum] And 49407=HNum Then
  Begin
    IDXHR:=ArrFVarTIdxHRead[HNum]; {Noch zu lesende Bytes im Puffer}
    IDXTR:=ArrFVarTIdxTRead[HNum]; {Zeiger auf nchstes zu lesendes Byte}
    RdSeg:=ArrFVarTSeg[HNum];
    Repeat
      If IDXHR<=000 Then
      Begin
        BlockRead2T(HNum,Mem[RdSeg:0],TSSize,CntrHROW0);
        ErrHandIO(IOResult2,PNReadLnS,HNum);
        If CntrHROW0=000 Then BoolGotStr:=BT;
        IDXHR:=CntrHROW0;
        IDXTR:=000;
      End;
      If Mem[RdSeg:IDXTR]=$0A Then
      Begin
        Dec(IDXHR);
        Inc(IDXTR);
      End;
      If Not BoolGotStr Then
      If IDXHR>000 Then
      Begin
        HlpIdx:=000;
        While (HlpIdx<IDXHR-001)
        And   (Mem[RdSeg:IDXTR+HlpIdx]<>$0D) Do Inc(HlpIdx);
        If Mem[RdSeg:IDXTR+HlpIdx]=$0D Then
        Begin
          ReadLnHelp(HlpIdx);
          BoolGotStr:=BT;
        End
        Else
        ReadLnHelp(HlpIdx+001);
      End;
    Until BoolGotStr;
    If Mem[RdSeg:IDXTR]=$0A Then
    Begin
      Dec(IDXHR);
      Inc(IDXTR);
    End;
    ArrFVarTIdxHRead[HNum]:=IDXHR;
    ArrFVarTIdxTRead[HNum]:=IDXTR;
  End
  Else
  ErrorOut('ReadLn: Handle not defined',001,'',#000);

End;




Procedure ReadLnS(HNum: Hand;Var RStr: STFF;StrSize: Word);
Var
  BoolGotStr : Bool;
  HlpIdx     : IntM;
  HlpStr     : STFF;
  IDXHR      : IntM;
  IDXTR      : IntM;
  RdSeg      : Word;

Procedure ReadLnSHelp(MoveSize: Word);
Begin
  Move(Mem[RdSeg:IDXTR],HlpStr[Ord(HlpStr[000])+001],MoveSize);
  HlpStr[000]:=Chr(Ord(HlpStr[000])+MoveSize);
  Inc(IDXTR,MoveSize+001);
  Dec(IDXHR,MoveSize+001);
End;

Begin

  HlpStr:='';
  BoolGotStr:=BF;
  If ArrFHndT[HNum] And 49407=HNum Then
  Begin
    IDXHR:=ArrFVarTIdxHRead[HNum]; {Noch zu lesende Bytes im Puffer}
    IDXTR:=ArrFVarTIdxTRead[HNum]; {Zeiger auf nchstes zu lesendes Byte}
    RdSeg:=ArrFVarTSeg[HNum];
    Repeat
      If IDXHR<=000 Then
      Begin
        BlockRead2T(HNum,Mem[RdSeg:0],TSSize,CntrHROW0);
        ErrHandIO(IOResult2,PNReadLnS,HNum);
        If CntrHROW0=000 Then BoolGotStr:=BT;
        IDXHR:=CntrHROW0;
        IDXTR:=000;
      End;
      If Mem[RdSeg:IDXTR]=$0A Then
      Begin
        Dec(IDXHR);
        Inc(IDXTR);
      End;
      If Not BoolGotStr Then
      If IDXHR>000 Then
      Begin
        HlpIdx:=000;
        While (HlpIdx<IDXHR-001)
        And (Mem[RdSeg:IDXTR+HlpIdx]<>$0D) Do Inc(HlpIdx);
        If Mem[RdSeg:IDXTR+HlpIdx]=$0D Then
        Begin
          ReadLnSHelp(HlpIdx);
          BoolGotStr:=BT;
        End
        Else
        ReadLnSHelp(HlpIdx+001);
      End;
    Until BoolGotStr;
    If Mem[RdSeg:IDXTR]=$0A Then
    Begin
      Dec(IDXHR);
      Inc(IDXTR);
    End;
    ArrFVarTIdxHRead[HNum]:=IDXHR;
    ArrFVarTIdxTRead[HNum]:=IDXTR;
  End
  Else
  ErrorOut('ReadLnS: Handle not defined',001,'',#000);
  RStr:=Copy(HlpStr,001,StrSize-001);

End;




Procedure Seek(HNum: Hand;SIntL: IntL);
Begin

  If ArrFHndF[HNum]=HNum Then
  Begin
    Seek2F(HNum,SIntL);
    ErrHandIO(IOResult2,PNSeek,HNum);
  End
  Else
  ErrorOut('Seek: Handle not defined',001,'',#000);

End;




Procedure Seek2F(HNum: Hand;SIntL: IntL);
Begin

  ESeek2F(HNum,SIntL);

End;




Procedure Seek2T(HNum: Hand;SIntL: IntL);
Begin

  ESeek2T(HNum,SIntL);

End;




Procedure SetFAttr(VTyp: VTyps;HNum: Hand;Attr: Byte);
Procedure SetFAttrHelp;
Begin
  If VTyp=FVarF Then
  Begin
    ArrFHndF[HNum]:=ArrFHndF[HNum] And 000 Or HNum;
  End
  Else
  If VTyp=FVarT Then
  Begin
    ArrFHndT[HNum]:=ArrFHndT[HNum] And 8192 Or HNum;
  End;
End;
Begin

  Case VTyp Of
  FVarF : If ArrFHndF[HNum]=HNum Or 16384 Then
          Dos.SetFAttr(ArrFVarF[HNum],Attr)
          Else
          ErrorOut('SetFAttr: Handle fr FVarF nicht'+
          ' definiert oder Datei offen',001,'',#000);
  FVarT : If ArrFHndT[HNum] And 57343=HNum Or 16384 Then
          Dos.SetFAttr(ArrFVarT[HNum],Attr)
          Else
          ErrorOut('SetFAttr: Handle fr FVarT nicht'+
          ' definiert oder Datei offen',001,'',#000);
  End;
  SetFAttrHelp;
  FreeFVarHandle(VTyp,HNum);

End;




Procedure SetFTime(VTyp: VTyps;HNum: Hand;Time: IntL);
Begin

  ESetFTime(VTyp,HNum,Time);

End;




Procedure SetUnUsed(HNum: Hand);
Begin

  ESetUnUsed(HNum);

End;




Procedure Truncate(HNum: Hand);
Begin

  If ArrFHndF[HNum]=HNum Then
  Begin
    Truncate2F(HNum);
    ErrHandIO(IOResult2,PNTruncate,HNum);
  End
  Else
  ErrorOut('Truncate: Handle not defined',001,'',#000);

End;




Procedure Truncate2F(HNum: Hand);
Begin

  ETruncate2F(HNum);

End;




Procedure Write(HNum: Hand;WChar: Char);
Begin

  If ArrFHndT[HNum]=HNum Then
  Begin
    Repeat
      {$I-} System.BlockWrite(ArrFVarT[HNum],WChar,001); {$I+}
      IOResult2:=IOResult;
      ErrHandIO(IOResult2,PNWrite,HNum);
    Until (IOResult2=000) Or BooleanEx;
  End
  Else
  ErrorOut('Write: Handle not defined',001,'',#000);

End;




Procedure WriteLn(HNum: Hand;WStr: STFF);
Begin

  If ArrFHndT[HNum]=HNum Then
  Begin
    Repeat
      {$I-} System.BlockWrite(ArrFVarT[HNum],WStr[001],Length(WStr)); {$I+}
      IOResult2:=IOResult;
      WStr:=#013+#010;
      {$I-} System.BlockWrite(ArrFVarT[HNum],WStr[001],002); {$I+}
      IOResult2:=IOResult;
      ErrHandIO(IOResult2,PNWriteLn,HNum);
    Until (IOResult2=000) Or BooleanEx;
  End
  Else
  ErrorOut('WriteLn: Handle not defined',001,'',#000);

End;




Procedure WriteS(HNum: Hand;WStr: STFF);
Begin

  If ArrFHndT[HNum]=HNum Then
  Begin
    {$I-} System.BlockWrite(ArrFVarT[HNum],WStr[001],Length(WStr)); {$I+}
    IOResult2:=IOResult;
    ErrHandIO(IOResult2,PNWriteS,HNum);
  End
  Else
  ErrorOut('WriteS: Handle not defined',001,'',#000);

End;


Procedure Help2;
Var
  DStr : ST67;
  EStr : ST04;

Begin

  PRGNAME:=GetProgName;
  PRGPATH:=GetProgPath;
  FSplit(PRGNAME,DStr,PRGHN,EStr);

End;




BEGIN {Initialisierung}

  Help2;

END.
