Unit SWCLSN;


{$F+}


Interface


Uses CRT,
     DOS,
     Graph,
     SWCVaria;

Procedure ArrowField0(Name: ST08;FX,FY,WX,WY: Word);
Procedure ArrowField1(Name: ST08;FX,FY,WX,WY: Word);
Procedure ClrField(Name: ST08;FX,FY,WX,WY: Word);
Procedure ColorField(Name: ST08;FX,FY,WX,WY: Word);
Procedure ColorFieldX(Name: ST08;Line: IntL;Field: Word;Color: Byte);
Procedure EdiTitle(Name: ST08;FX,FY,WX,WY: Word);
Function  GetCharLeft(Name: ST08): Byte;
Function  GetCharRight(Name: ST08): Byte;
Function  GetCountFields(Name: ST08): Word;
Function  GetFieldLength(Name: ST08): Word;
Function  GetFreeLSNIs: Byte;
Function  GetLastLine(LPath: ST79): IntL;
Function  GetListLong(Name: ST08;Line: IntL;FNum: Word): IntL;
Function  GetListReal(Name: ST08;Line: IntL;FNum: Word): Real;
Function  GetListStr(Name: ST08;Line: IntL;
          FNum: Word;Format: Byte): STFF;
Function  GetTitStr(Name: ST08;FNum: Word;Format: Byte): STFF;
Procedure GoListFieldLeft(Name: ST08;FX,WX: Word);
Procedure GoListFieldRight(Name: ST08;FX,WX: Word);
Function  IsLSN(LSNPath: ST79): Bool;
Procedure LineOut(Name: ST08;FX,FY,WX: Word);
Procedure ListDelLine(Name: ST08;Line: IntL;Var WY: Word;OTxt: ST80);
Procedure ListInsLine(Name: ST08;Line: IntL;OTxt: ST80);
Function  LSNChkLS2(I: Byte): Bool;
Procedure LSNChkW(I,FX,WX,Y: Byte;ChkSeg: Word); {LSNCheckWrite}
Procedure LSNEdit(Name: ST08;
          FX,FY,WX,WY: Word;
          LPath,TPath: ST79;
          OpenMode: IntL;
          B50: Bool;
          Line: IntL;
          B13Ex,BFree,BClr,BScrP,BCol,BChkLSN: Bool);
Procedure LSNFrame(Name: ST08;FX,FY,WX,WY: Word;FCntr: IntS);
Procedure LSNFree(Name: ST08);
Function  LSNGetNextLSNI: Hand;
Procedure LSNGetPageDates(Name: ST08;Var FX,FY,WX,WY: Byte);
Function  LSNIGet(Name: ST08): Byte;
Procedure LSNLoad(Name: ST08;LPath,TPath: ST79;OMod: FOM);
Procedure LSNNoPRNCodeDelPRN(Name: ST08;
          B0,FY: Byte;LSeg,OSeg: Word;Var LSize: Word);
Procedure LSNPage(Name: ST08;FX,FY,WX,WY: Byte);
Procedure LSNSearchJ(Name: ST08;SStr: STFF;
          F,U: IntL;Tab: Word;Var LStart,LEnd: IntL;BPos,BBig: Bool);
Function  LSNSearchJ2(Name: ST08;
          SStr: STFF;Tab: Word;F,U: IntL;BPos,BBig: Bool): IntL;
Function  LSNSearchJ3(Name: ST08;SStr: STFF;Tab: Word;F,U: IntL): IntL;
Function  LSNSearchJIB(Name: ST08;SStr: STFF;Tab: Word;F,U: IntL): IntL;
Function  LSNSearchO(Name: ST08;SStr: STFF;Tab: Word;F,U: IntL): IntL;
Procedure LSNShadow(Name: ST08;FX,FY,WX,WY: Byte);
Procedure LSNShowXY(Name: ST08;FX,FY,WX: Word);
Procedure LSNSort(Name: ST08;BAsk: Bool;SortP: SArr);
Procedure LSNSortFU(Name: ST08;BAsk: Bool;SortP: SArr;SF,SU: IntL);
Function  LSNTest(Name: ST08): Bool;
Procedure LSNTOut(Name: ST08;FX,FY,WX: Word);
Procedure MakeInsLines(ALen: TLen;UpTo,Width: Word);
Procedure MoveLineToLine(names,namet: ST08;lines,linet: IntL);
Procedure OpenInsLine(Var HandF: Hand;ALen: TLen;UpTo,Width: Word);
Procedure PutListStr(Name: ST08;Line: IntL;FNum: Word;PStr: STFF);
Procedure ReadOneLine(Name: ST08;Line: IntL);
Procedure UnColorField(Name: ST08;FX,FY,WX,WY: Word;BClr: Bool);
Procedure WriteListLine(Name: ST08;Line: IntL);




Implementation



Uses SWCLSNE,
     SWCSubPr,
     SWCUtil;




Procedure ArrowField0(Name: ST08;FX,FY,WX,WY: Word);
Var
  BOkSeg : Word;
  I      : Byte;
  Long0  : IntL;
  Word0  : Word;
  Word1  : Word;

Begin

  I:=LSNIGet(Name);
  If Not LSNChkLS2(I) Then
  Begin
    Long0:=FileY[I]+CrsrY[I]-001;
    BOkSeg:=GetBuf(WX+016,Word0,Word1);
    MemErrorOut('ArrowField0',Word0,000);
    LSNChkW(I,FX,WX,CrsrY[I]-001,BOkSeg);
    For Word0:=FX+001 To FX+WX-002 Do
    If Mem[BOkSeg:Word0-FX-001]=001 Then
    Begin
      Word1:=(FY+CrsrY[I]+001)*160+Word0*002;
      If (Mem[SegB800:Word1]=016)
      Or (Mem[SegB800:Word1]=017) Then
      Begin
        Mem[SegB800:Word1]:=032;
        If  (Long0>=BlockA[I])
        And (Long0<=BlockB[I]) Then
        Mem[SegB800:Word1+001]:=062
        Else
        Mem[SegB800:Word1+001]:=007;
      End;
    End
    Else
    If Mem[BOkSeg:Word0-FX-001]=002 Then
    Begin
      Word1:=(FY+CrsrY[I]+001)*160+Word0*002;
      If (Mem[SegB800:Word1]=016)
      Or (Mem[SegB800:Word1]=017) Then
      Begin
        Mem[SegB800:Word1]:=032;
        Mem[SegB800:Word1+001]:=008;
      End;
    End;
    FreeBuf(BOkSeg,Word0);
    MemErrorOut('ArrowField0',Word0,000);
  End;

End;




Procedure ArrowField1(Name: ST08;FX,FY,WX,WY: Word);
Var
  BOkSeg : Word;
  I      : Byte;
  Long0  : IntL;
  Toggl  : Bool;
  Word0  : Word;
  Word1  : Word;

Begin

  I:=LSNIGet(Name);
  If Not LSNChkLS2(I) Then
  Begin
    Toggl:=BF;
    Long0:=FileY[I]+CrsrY[I]-001;
    BOkSeg:=GetBuf(WX+016,Word0,Word1);
    MemErrorOut('ArrowField1',Word0,000);
    LSNChkW(I,FX,WX,CrsrY[I]-001,BOkSeg);
    For Word0:=FX+001 To FX+WX-002 Do
    If Mem[BOkSeg:Word0-FX-001]=001 Then
    Begin
      Word1:=(FY+CrsrY[I]+001)*160+Word0*002;
      If Mem[SegB800:Word1]=032 Then
      Begin
        If Not Toggl Then
        Begin
          Toggl:=BT;
          Mem[SegB800:Word1]:=017;
        End
        Else
        Begin
          Toggl:=BF;
          Mem[SegB800:Word1]:=016;
        End;
        If  (Long0>=BlockA[I])
        And (Long0<=BlockB[I]) Then
        Mem[SegB800:Word1+001]:=062
        Else
        Mem[SegB800:Word1+001]:=015;
      End;
    End
    Else
    If Mem[BOkSeg:Word0-FX-001]=002 Then
    Begin
      Word1:=(FY+CrsrY[I]+001)*160+Word0*002;
      If Mem[SegB800:Word1]=032 Then
      Begin
        If Not Toggl Then
        Begin
          Toggl:=BT;
          Mem[SegB800:Word1]:=017;
        End
        Else
        Begin
          Toggl:=BF;
          Mem[SegB800:Word1]:=016;
        End;
        Mem[SegB800:Word1+001]:=008;
      End;
    End;
    FreeBuf(BOkSeg,Word0);
    MemErrorOut('ArrowField1',Word0,000);
  End;

End;




Procedure ClrField(Name: ST08;FX,FY,WX,WY: Word);
Var
  I : Byte;

Begin

  I:=LSNIGet(Name);
  PutListStr(Name,FileY[I]+CrsrY[I]-001,Field[I],'');
  LSNPage(Name,FX,FY,WX,WY);

End;




Procedure ColorField(Name: ST08;FX,FY,WX,WY: Word);
Var
  BOkSeg : Word;
  Byte0  : Byte;
  Color  : Byte;
  I      : Byte;
  TColor : Byte;
  Word0  : Word;
  Word1  : Word;

Begin

  I:=LSNIGet(Name);
  BOkSeg:=GetBuf(WX+016,Word0,Word1);
  MemErrorOut('ColorField',Word0,000);
  LSNChkW(I,FX,WX,FY+CrsrY[I]-001,BOkSeg);
  If Not LSNChkLS2(I) Then
  Begin
    Byte0:=FX+CrsrX[I];
    If BoolClr[I] Then Color:=078 Else Color:=046;
    If Byte0>FX Then
    Repeat
      Word0:=(FY+CrsrY[I]+001)*160+Byte0*002;
      If Mem[SegB800:Word0]<>032 Then
      Begin
        If Mem[BOkSeg:Byte0-FX-001]=001 Then
        Begin
          If ColSeg[I]>000 Then
          Begin
            TColor:=Mem[ColSeg[I]:LineSize[I]];
            If Mem[SegB800:Word0+001]<>TColor Then
            Mem[SegB800:Word0+001]:=Color;
          End
          Else
          TColor:=112;
          If Mem[SegB800:Word0+001]<>TColor Then
          Mem[SegB800:Word0+001]:=Color;
          Dec(Byte0);
        End
        Else
        If Mem[BOkSeg:Byte0-FX-001]=002 Then
        Begin
          If ColSeg[I]>000 Then
          Begin
            TColor:=Mem[ColSeg[I]:LineSize[I]];
            If Mem[SegB800:Word0+001]<>TColor Then
            Mem[SegB800:Word0+001]:=Color;
          End
          Else
          TColor:=112;
          If Mem[SegB800:Word0+001]<>TColor Then
          Mem[SegB800:Word0+001]:=Color;
          Dec(Byte0);
        End
        Else
        Dec(Byte0);
      End
      Else
      Dec(Byte0);
    Until (Byte0=FX)
    Or ((Mem[BOkSeg:Byte0-FX]=001) And (Mem[SegB800:Word0]=032));
    Byte0:=FX+CrsrX[I];
    Repeat
      Word0:=(FY+CrsrY[I]+001)*160+Byte0*002;
      If Mem[SegB800:Word0]<>032 Then
      Begin
        If Mem[BOkSeg:Byte0-FX-001]=001 Then
        Begin
          If ColSeg[I]>000 Then
          Begin
            TColor:=Mem[ColSeg[I]:LineSize[I]];
            If Mem[SegB800:Word0+001]<>TColor Then
            Mem[SegB800:Word0+001]:=Color;
          End
          Else
          TColor:=112;
          If Mem[SegB800:Word0+001]<>TColor Then
          Mem[SegB800:Word0+001]:=Color;
          Inc(Byte0);
        End
        Else
        If Mem[BOkSeg:Byte0-FX-001]=002 Then
        Begin
          If ColSeg[I]>000 Then
          Begin
            TColor:=Mem[ColSeg[I]:LineSize[I]];
            If Mem[SegB800:Word0+001]<>TColor Then
            Mem[SegB800:Word0+001]:=Color;
          End
          Else
          TColor:=112;
          If Mem[SegB800:Word0+001]<>TColor Then
          Mem[SegB800:Word0+001]:=Color;
          Inc(Byte0);
        End
        Else
        Inc(Byte0);
      End
      Else
      Inc(Byte0);
    Until (Byte0=FX+WX-001)
    Or ((Mem[BOkSeg:Byte0-FX]=001) And (Mem[SegB800:Word0]=032));
  End
  Else
  Begin
    Byte0:=FX+CrsrX[I];
    If BoolClr[I] Then Color:=078 Else Color:=046;
    If Byte0>FX Then
    Repeat
      Word0:=(FY+CrsrY[I]+001)*160+Byte0*002;
      If Mem[SegB800:Word0]<>124 Then
      Begin
        If Mem[BOkSeg:Byte0-FX-001]=001 Then
        Begin
          If ColSeg[I]>000 Then
          Begin
            TColor:=Mem[ColSeg[I]:LineSize[I]];
            If Mem[SegB800:Word0+001]<>TColor Then
            Mem[SegB800:Word0+001]:=Color;
          End
          Else
          TColor:=112;
          If Mem[SegB800:Word0+001]<>TColor Then
          Mem[SegB800:Word0+001]:=Color;
          Dec(Byte0);
        End
        Else
        If Mem[BOkSeg:Byte0-FX-001]=002 Then
        Begin
          If ColSeg[I]>000 Then
          Begin
            TColor:=Mem[ColSeg[I]:LineSize[I]];
            If Mem[SegB800:Word0+001]<>TColor Then
            Mem[SegB800:Word0+001]:=Color;
          End
          Else
          TColor:=112;
          If Mem[SegB800:Word0+001]<>TColor Then
          Mem[SegB800:Word0+001]:=Color;
          Dec(Byte0);
        End
        Else
        Dec(Byte0);
      End
      Else
      Dec(Byte0);
    Until (Byte0=FX)
    Or ((Mem[BOkSeg:Byte0-FX]=001) And (Mem[SegB800:Word0]=124));
    Byte0:=FX+CrsrX[I];
    Repeat
      Word0:=(FY+CrsrY[I]+001)*160+Byte0*002;
      If Mem[SegB800:Word0]<>124 Then
      Begin
        If Mem[BOkSeg:Byte0-FX-001]=001 Then
        Begin
          If ColSeg[I]>000 Then
          Begin
            TColor:=Mem[ColSeg[I]:LineSize[I]];
            If Mem[SegB800:Word0+001]<>TColor Then
            Mem[SegB800:Word0+001]:=Color;
          End
          Else
          TColor:=112;
          If Mem[SegB800:Word0+001]<>TColor Then
          Mem[SegB800:Word0+001]:=Color;
          Inc(Byte0);
        End
        Else
        Inc(Byte0);
      End
      Else
      Inc(Byte0);
    Until (Byte0>=FX+WX-001)
    Or ((Mem[BOkSeg:Byte0-FX]=001) And (Mem[SegB800:Word0]=124));
  End;
  FreeBuf(BOkSeg,Word0);
  MemErrorOut('ColorField',Word0,000);

End;




Procedure ColorFieldX(Name: ST08;Line: IntL;Field: Word;Color: Byte);
Begin

  EColorFieldX(Name,Line,Field,Color);

End;




Procedure EdiTitle(Name: ST08;FX,FY,WX,WY: Word);
Label ET5,
      ETBACK,
      ETDEL,
      ETEND,
      ETEX,
      ETHOME,
      ETINS,
      ETLEFT,
      ETRIGHT,
      ETSET,
      ETTL,
      ETTR;

Var
  CX     : IntS;
  CY     : IntS;
  I      : Byte;
  TitEdg : IntL;
  Word0  : Word;

Procedure ShowXY;
Var
  Byte0 : Byte;
  Byte1 : Byte;
  StrX  : ST10;
  StrXY : ST23;
  StrY  : ST10;

Begin
  Str(CY,StrY);
  Str(TitEdg+CX,StrX);
  StrXY:=#032+StrX+':'+StrY+#032;
  For Byte0:=001 To Length(StrXY) Do
  Begin
    If Byte0>WX-003 Then Exit;
    Mem[SegB800:(FX+001+Byte0)*002+FY*160]:=Ord(StrXY[Byte0]);
  End;
  For Byte1:=Byte0+001 To WX-003 Do
  Mem[SegB800:(FX+001+Byte1)*002+FY*160]:=205;
End;

Procedure TitOut;
Var
  Byte0  : Byte;
Begin
  For Byte0:=000 To WX-003 Do
  Mem[SegB800:(FY+001)*160+
  (FX+001)*002+Byte0*002]:=Mem[TitSeg[I]:TitEdg+Byte0];
End;

Begin

  CX:=001;
  CY:=001;
  TitEdg:=000;
  I:=LSNIGet(Name);
  ScreenParams(BT);
  Window(FX+002,FY+002,FX+WX-001,FY+002);
  TextBackGround(000);
  TextColor(012);
  Crt.ClrScr;

  ET5:
  TitOut;
  ShowXY;
  GotoXY(CX,CY);
  Wait;
  If Boolean13   Then Goto ET5;
  If BooleanBack Then Goto ETBACK;
  If BooleanDel  Then Goto ETDEL;
  If BooleanDn   Then Goto ET5;
  If BooleanEnd  Then Goto ETEND;
  If BooleanEx   Then Goto ETEX;
  If BooleanF1   Then Goto ET5;
  If BooleanF2   Then Goto ET5;
  If BooleanF3   Then Goto ET5;
  If BooleanF4   Then Goto ET5;
  If BooleanF5   Then Goto ET5;
  If BooleanF6   Then Goto ET5;
  If BooleanF7   Then Goto ET5;
  If BooleanF8   Then Goto ET5;
  If BooleanF9   Then Goto ET5;
  If BooleanFA   Then Goto ET5;
  If BooleanHome Then Goto ETHOME;
  If BooleanIns  Then Goto ETINS;
  If BooleanLeft Then Goto ETLEFT;
  If BooleanPD   Then Goto ET5;
  If BooleanPU   Then Goto ET5;
  If BooleanRig  Then Goto ETRIGHT;
  If BooleanTL   Then Goto ETTL;
  If BooleanTR   Then Goto ETTR;
  If BooleanUp   Then Goto ET5;
  Goto ETSET;

  ETBACK:
  If (CX=001) And (TitEdg=000) Then Goto ET5;
  For Word0:=TitEdg+CX-001 To LineSize[I]-001 Do
  Mem[TitSeg[I]:Word0-001]:=Mem[TitSeg[I]:Word0];
  Mem[TitSeg[I]:LineSize[I]-001]:=032;
  Goto ETLEFT;

  ETDEL:
  For Word0:=TitEdg+CX To LineSize[I]-001 Do
  Mem[TitSeg[I]:Word0-001]:=Mem[TitSeg[I]:Word0];
  Mem[TitSeg[I]:LineSize[I]-001]:=032;
  Goto ET5;

  ETEND:
  CX:=WX-002;
  TitEdg:=LineSize[I]-(WX-002);
  Goto ET5;

  ETEX:
  ScreenParams(BF);
  Seek(LSNHandle[I],002);
  BlockWrite(LSNHandle[I],Mem[TitSeg[I]:0],LineSize[I],CntrHROW0);
  Exit;

  ETHOME:
  CX:=001;
  TitEdg:=000;
  Goto ET5;

  ETINS:
  For Word0:=LineSize[I]-001 DownTo TitEdg+CX Do
  Mem[TitSeg[I]:Word0]:=Mem[TitSeg[I]:Word0-001];
  Mem[TitSeg[I]:TitEdg+CX-001]:=032;
  Goto ET5;

  ETLEFT:
  Dec(CX);
  If CX>000 Then Goto ET5;
  Inc(CX);
  Dec(TitEdg);
  If TitEdg>=000 Then Goto ET5;
  Inc(TitEdg);
  Goto ET5;

  ETRIGHT:
  Inc(CX);
  If CX<WX-001 Then Goto ET5;
  Dec(CX);
  Inc(TitEdg);
  If TitEdg<LineSize[I]-(WX-003) Then Goto ET5;
  Dec(TitEdg);
  Goto ET5;

  ETSET:
  Mem[TitSeg[I]:TitEdg+CX-001]:=Ord(Char0);
  Goto ETRIGHT;

  ETTL:
  Dec(CX,WX Div 002);
  If CX>000 Then Goto ET5;
  CX:=001;
  Dec(TitEdg,WX Div 002);
  If TitEdg>=000 Then Goto ET5;
  TitEdg:=000;
  Goto ET5;

  ETTR:
  Inc(CX,WX Div 002);
  If CX<WX-001 Then Goto ET5;
  CX:=WX-002;
  Inc(TitEdg,WX Div 002);
  If TitEdg<LineSize[I]-(WX-003) Then Goto ET5;
  TitEdg:=LineSize[I]-(WX-002);
  Goto ET5;

End;




Function  GetCharLeft(Name: ST08): Byte;
Var
  I     : Byte;

Begin

  I:=LSNIGet(Name);
  ReadOneLine(Name,FileY[I]+CrsrY[I]-001);
  GetCharLeft:=Mem[LineSeg[I]:FileX[I]+CrsrX[I]-002];

End;




Function  GetCharRight(Name: ST08): Byte;
Var
  I     : Byte;
  Stri0 : ST80;

Begin

  I:=LSNIGet(Name);
  ReadOneLine(Name,FileY[I]+CrsrY[I]-001);
  GetCharRight:=Mem[LineSeg[I]:FileX[I]+CrsrX[I]];

End;




Function  GetCountFields(Name: ST08): Word;
Var
  I     : Byte;
  Word0 : Word;
  Word1 : Word;

Begin

  I:=LSNIGet(Name);
  If Not LSNChkLS2(I) Then
  Begin
    Word0:=000;
    Word1:=000;
    While Word0<LineSize[I]-001 Do
    Begin
      While (Mem[LineSeg[I]:Word0]=032)
      And (Word0<LineSize[I]-001) Do Inc(Word0);
      While (Mem[LineSeg[I]:Word0]<>032)
      And (Word0<LineSize[I]-001) Do Inc(Word0);
      If Word0<LineSize[I]-001 Then Inc(Word1);
    End;
  End
  Else
  Begin
    Word0:=000;
    Word1:=000;
    While Word0<LineSize[I]-001 Do
    Begin
      While (Mem[LineSeg[I]:Word0]=124)
      And (Word0<LineSize[I]-001) Do Inc(Word0);
      While (Mem[LineSeg[I]:Word0]<>124)
      And (Word0<LineSize[I]-001) Do Inc(Word0);
      If Word0<LineSize[I] Then Inc(Word1);
    End;
  End;
  GetCountFields:=Word1;

End;




Function  GetFieldLength(Name: ST08): Word;
Var
  FCntr : Word;
  FLeng : Word;
  I     : Byte;
  LIndx : Word;

Begin

  I:=LSNIGet(Name);
  If Not LSNChkLS2(I) Then
  Begin
    FCntr:=000;
    LIndx:=000;
    ReadOneLine(Name,FileY[I]+CrsrY[I]-001);
    While FCntr<=Field[I] Do
    Begin
      While (Mem[LineSeg[I]:LIndx]=032)
      And (LIndx<LineSize[I]-001) Do Inc(LIndx);
      FLeng:=000;
      While (Mem[LineSeg[I]:LIndx]<>032)
      And (LIndx<LineSize[I]-001) Do
      Begin
        Inc(FLeng);
        Inc(LIndx);
      End;
      Inc(FCntr);
    End;
  End
  Else
  Begin
    FCntr:=000;
    LIndx:=000;
    ReadOneLine(Name,FileY[I]+CrsrY[I]-001);
    While FCntr<=Field[I] Do
    Begin
      While (Mem[LineSeg[I]:LIndx]=124)
      And (LIndx<LineSize[I]-001) Do Inc(LIndx);
      FLeng:=000;
      While (Mem[LineSeg[I]:LIndx]<>124)
      And (LIndx<LineSize[I]-001) Do
      Begin
        Inc(FLeng);
        Inc(LIndx);
      End;
      Inc(FCntr);
    End;
  End;
  GetFieldLength:=FLeng;

End;




Function  GetFreeLSNIs: Byte;
Var
  Byte0  : Byte;
  Byte1  : Byte;

Begin

  Byte0:=000;
  For Byte1:=000 To LSN Do
  If LSNNam[Byte1]='' Then Inc(Byte0);
  GetFreeLSNIs:=Byte0;

End;




Function  GetLastLine(LPath: ST79): IntL;
Var
  HandF : Hand;
  LSize : Word;

Begin

  OFileF(HandF,LPath,FRead,001);
  If IOResult2=000 Then
  Begin
    BlockRead(HandF,LSize,002,CntrHROW0);
    GetLastLine:=(FileSize(HandF)-002) Div LSize-001;
    OFileF(HandF,'',FClose,001);
  End
  Else
  ErrorOut('GetLastLine: '+LPath+
  ': '+GetDosError(IOResult2),001,'',#000);

End;




Function  GetListLong(Name: ST08;Line: IntL;FNum: Word): IntL;
Var
  Long0 : IntL;
  Stri0 : STFF;

Begin

  Stri0:=GetListStr(Name,Line,FNum,000);
  Val(Stri0,Long0,VALCODE);
  GetListLong:=Long0;

End;




Function  GetListReal(Name: ST08;Line: IntL;FNum: Word): real;
Var
  Real0 : Real;
  Stri0 : STFF;

Begin

  Stri0:=GetListStr(Name,Line,FNum,000);
  Val(Stri0,Real0,ValCode);
  GetListReal:=Real0;

End;




Function  GetListStr(Name: ST08;Line: IntL;
          FNum: Word;Format: Byte): STFF;
Var
  Byte0 : Byte;
  FCntr : Word;
  FLeng : Word;
  I     : Byte;
  LastI : Word;
  LIndx : Word;
  Stri0 : STFF;
  Stri1 : STFF;

Begin

  I:=LSNIGet(Name);
  If FNum<CntFields[I] Then
  Begin
    If LSNChkLS2(I) Then
    Begin
      FCntr:=000;
      LIndx:=000;
      ReadOneLine(Name,Line);
      While FCntr<=FNum Do
      Begin
        While Mem[LineSeg[I]:LIndx]=124 Do Inc(LIndx);
        FLeng:=000;
        LastI:=LIndx;
        While Mem[LineSeg[I]:LIndx]<>124 Do
        Begin
          Inc(LIndx);
          Inc(FLeng);
        End;
        Inc(FCntr);
      End;
    End
    Else
    Begin
      FCntr:=000;
      LIndx:=000;
      ReadOneLine(Name,Line);
      While FCntr<=FNum Do
      Begin
        While Mem[LineSeg[I]:LIndx]=032 Do Inc(LIndx);
        FLeng:=000;
        LastI:=LIndx;
        While Mem[LineSeg[I]:LIndx]<>032 Do
        Begin
          Inc(LIndx);
          Inc(FLeng);
        End;
        Inc(FCntr);
      End;
    End;
  End
  Else
  Begin
    Str(FNum,Stri0);
    Str(CntFields[I],Stri1);
    ErrorOut('GetListStr: '+Name+': '+
    'Called fieldnumber ('+Stri0+
    ') bigger than possible ('+Stri1+')',001,'',#000);
  End;
  If FLeng>255 Then FLeng:=255;
  Move(Mem[LineSeg[I]:LastI],Stri0[001],FLeng);
  Stri0[000]:=Chr(FLeng);
  Stri0:=FillString(Stri0,#000,#032);
  Byte0:=Format And 127;
  Case Byte0 Of
  000 : Stri0:=BuendigLR(Stri0);
  001 : Stri0:=BuendigRSpecial(Stri0);
  002 : ;
  End;
  If Format And 128=128 Then
  Stri0:=UpCaseStr(Stri0);
  GetListStr:=Stri0;

End;




Function  GetTitStr(Name: ST08;FNum: Word;Format: Byte): STFF;
Var
  Byte0 : Byte;
  FCntr : Word;
  FLeng : Word;
  I     : Byte;
  IFrom : Word;
  IUpto : Word;
  LIndx : Word;
  Stri0 : STFF;

Begin

  FCntr:=000;
  LIndx:=000;
  I:=LSNIGet(Name);
  If Not LSNChkLS2(I) Then
  Begin
    ReadOneLine(Name,000);
    Repeat
      While Mem[LineSeg[I]:LIndx]=032 Do Inc(LIndx);
      IFrom:=LIndx;
      While Mem[LineSeg[I]:LIndx]<>032 Do Inc(LIndx);
      IUpto:=LIndx;
      Inc(FCntr);
    Until FCntr>FNum;
  End
  Else
  Begin
    ReadOneLine(Name,000);
    Repeat
      While Mem[LineSeg[I]:LIndx]=124 Do Inc(LIndx);
      IFrom:=LIndx;
      While Mem[LineSeg[I]:LIndx]<>124 Do Inc(LIndx);
      IUpto:=LIndx;
      Inc(FCntr);
    Until FCntr>FNum;
  End;
  FLeng:=IUpto-IFrom;
  If FLeng>255 Then FLeng:=255;
  Move(Mem[TitSeg[I]:IFrom],Stri0[001],FLeng);
  Stri0[000]:=Chr(FLeng);
  Byte0:=Format And 127;
  Case Byte0 Of
  000 : Stri0:=BuendigLR(Stri0);
  001 : Stri0:=BuendigRSpecial(Stri0);
  002 : ;
  End;
  If Format And 128=128 Then Stri0:=UpCaseStr(Stri0);
  GetTitStr:=Stri0;

End;




Procedure GoListFieldLeft(Name: ST08;FX,WX: Word);
Var
  FCntr : Word;
  FLeng : Word;
  I     : Byte;
  LastI : Word;
  LIndx : IntL;
  Word0 : Word;

Begin

  I:=LSNIGet(Name);
  If Not LSNChkLS2(I) Then
  Begin
    LastI:=FileX[I];
    FCntr:=CntFields[I];
    LIndx:=LineSize[I]-001;
    While FCntr>Field[I] Do
    Begin
      While (Mem[LineSeg[I]:LIndx]=032)
      And (LIndx>000) Do Dec(LIndx);
      FLeng:=000;
      While (Mem[LineSeg[I]:LIndx]<>032)
      And (LIndx>000) Do
      Begin
        Inc(FLeng);
        Dec(LIndx);
      End;
      LastI:=LIndx;
      Dec(FCntr);
    End;
    FileX[I]:=LastI-001;
    If LastI+WX-002>LineSize[I]-001 Then
    Begin
      Word0:=LastI+WX-002-(LineSize[I]-001);
      Dec(FileX[I],Word0);
      If FileX[I]<000 Then FileX[I]:=000;
      If LineSize[I]<077 Then
      CrsrX[I]:=WX-(LineSize[I]-LastI)
      Else
      If LineSize[I]=077 Then
      CrsrX[I]:=WX-(LineSize[I]-LastI)+001
      Else
      CrsrX[I]:=WX-(LineSize[I]-LastI)+002;
    End
    Else CrsrX[I]:=003;
  End
  Else
  Begin
    LastI:=FileX[I];
    FCntr:=CntFields[I];
    LIndx:=LineSize[I]-001;
    While FCntr>Field[I] Do
    Begin
      While (Mem[LineSeg[I]:LIndx]=124)
      And (LIndx>000) Do Dec(LIndx);
      FLeng:=000;
      While (Mem[LineSeg[I]:LIndx]<>124)
      And (LIndx>000) Do
      Begin
        Inc(FLeng);
        Dec(LIndx);
      End;
      LastI:=LIndx;
      Dec(FCntr);
    End;
    FileX[I]:=LastI-001;
    If LastI+WX-002>LineSize[I]-001 Then
    Begin
      Word0:=LastI+WX-002-(LineSize[I]-001);
      Dec(FileX[I],Word0);
      If FileX[I]<000 Then FileX[I]:=000;
      If LineSize[I]<077 Then
      CrsrX[I]:=WX-(LineSize[I]-LastI)
      Else
      If LineSize[I]=077 Then
      CrsrX[I]:=WX-(LineSize[I]-LastI)+001
      Else
      CrsrX[I]:=WX-(LineSize[I]-LastI)+002;
    End
    Else CrsrX[I]:=003;
  End;

End;




Procedure GoListFieldRight(Name: ST08;FX,WX: Word);
Var
  FCntr : Word;
  FLeng : Word;
  I     : Byte;
  LIndx : Word;
  Word0 : Word;

Begin

  I:=LSNIGet(Name);
  If Not LSNChkLS2(I) Then
  Begin
    If Field[I]>000 Then
    Begin
      FCntr:=000;
      LIndx:=000;
      Repeat
        FLeng:=000;
        While (Mem[LineSeg[I]:LIndx]=032)
        And (LIndx<LineSize[I]-001) Do Inc(LIndx);
        While (Mem[LineSeg[I]:LIndx]<>032)
        And (LIndx<LineSize[I]-001) Do
        Begin
          Inc(FLeng);
          Inc(LIndx);
        End;
        Inc(FCntr);
      Until FCntr=Field[I];
      CrsrX[I]:=003;
      FileX[I]:=LIndx;
      If LIndx+WX-002>LineSize[I]-001 Then
      Begin
        Word0:=LIndx+WX-002-(LineSize[I]-001);
        Dec(FileX[I],Word0);
        If FileX[I]<000 Then FileX[I]:=000;
        If LineSize[I]<077 Then
        CrsrX[I]:=WX-(LineSize[I]-LIndx)+001
        Else
        CrsrX[I]:=WX-(LineSize[I]-LIndx)+002;
      End;
    End;
  End
  Else
  Begin
    If Field[I]>000 Then
    Begin
      FCntr:=000;
      LIndx:=000;
      Repeat
        FLeng:=000;
        While (Mem[LineSeg[I]:LIndx]=124)
        And (LIndx<LineSize[I]-001) Do Inc(LIndx);
        While (Mem[LineSeg[I]:LIndx]<>124)
        And (LIndx<LineSize[I]-001) Do
        Begin
          Inc(FLeng);
          Inc(LIndx);
        End;
        Inc(FCntr);
      Until FCntr=Field[I];
      CrsrX[I]:=002;
      FileX[I]:=LIndx;
      If LIndx+WX-002>LineSize[I]-001 Then
      Begin
        Word0:=LIndx+WX-002-(LineSize[I]-001);
        Dec(FileX[I],Word0);
        If FileX[I]<000 Then FileX[I]:=000;
        If LineSize[I]<077 Then
        CrsrX[I]:=WX-(LineSize[I]-LIndx)+000
        Else
        CrsrX[I]:=WX-(LineSize[I]-LIndx)+001;
      End;
    End;
  End;

End;




Function  IsLSN(LSNPath: ST79): Bool;
Begin

  IsLSN:=BT;

End;




Procedure LineOut(Name: ST08;FX,FY,WX: Word);
Var
  Byte0  : Byte;
  I      : Byte;
  Word0  : Word;

Begin

  Byte0:=001;
  I:=LSNIGet(Name);
  ReadOneLine(Name,FileY[I]+CrsrY[I]-001);
  For Word0:=FileX[I] To FileX[I]+WX-003 Do
  Begin
    Mem[SegB800:
    (FX+Byte0)*002+(FY+001+CrsrY[I])*160]:=Mem[LineSeg[I]:Word0];
    Inc(Byte0);
  End;

End;




Procedure ListDelLine(Name: ST08;Line: IntL;Var WY: Word;OTxt: ST80);
Label DELX;
Var
  I     : Byte;
  Long0 : IntL;
  Long1 : IntL;
  SavFr : IntL;
  SavTo : IntL;
  SHWB0 : Bool;
  SHWH0 : Byte;

Begin

  If OTxt<>'' Then
  Begin
    OptionsR(022,005,'Attention ! '+OTxt,'~YesE~xit','Y',BT);
    If BooleanEx Then Exit;
  End;
  I:=LSNIGet(Name);
  If (Line<=LastLine[I]) And (LastLine[I]>000) Then
  Begin
    TempI;
    BooleanErr:=BF;
    Dec(LastLine[I]);
    If Line-001=LastLine[I] Then
    Begin
      Seek(LSNHandle[I],(Line+001)*LineSize[I]+002);
      Goto DELX;
    End;
    SHWB0:=BT;
    Long0:=000;
    Long1:=lastline[I]-Line;
    SavFr:=(Line+002)*LineSize[I]+002;
    SavTo:=(Line+001)*LineSize[I]+002;
    Repeat
      If OTxt<>'' Then
      ShowP('Erase line',SHWB0,
      SHWH0,020,030,007,Long0,Long1,BF);
      Seek(LSNHandle[I],SavFr);
      BlockRead(LSNHandle[I],Mem[LineSeg[I]:0],LineSize[I],CntrHROW0);
      Seek(LSNHandle[I],SavTo);
      BlockWrite(LSNHandle[I],Mem[LineSeg[I]:0],LineSize[I],CntrHROW0);
      Inc(SavFr,LineSize[I]);
      Inc(SavTo,LineSize[I]);
      Inc(Long0);
    Until SavFr>=FileSize(LSNHandle[I]);
    DELX:
    Truncate(LSNHandle[I]);
    If FileY[I]+CrsrY[I]-001>LastLine[I] Then
    If FileY[I]>000 Then Dec(FileY[I]) Else
    Begin
      If FileY[I]+CrsrY[I]>WY-004 Then Dec(CrsrY[I]);
      Dec(WY);
    End;
    If FileY[I]+WY-004>LastLine[I] Then
    If FileY[I]>000 Then Dec(FileY[I]) Else
    Begin
      If FileY[I]+CrsrY[I]>WY-004 Then Dec(CrsrY[I]);
      Dec(WY);
    End;
    If BlockA[I]>000 Then
    Begin
      If Line<BlockA[I] Then
      Dec(BlockA[I]);
    End;
    If BlockB[I]>000 Then
    Begin
      If Line<=BlockB[I] Then
      Dec(BlockB[I]);
    End;
    TempO;
  End
  Else
  BooleanErr:=BT;

End;




Procedure ListInsLine(Name: ST08;Line: IntL;OTxt: ST80);
Label INSX;
Var
  I     : Byte;
  Long0 : IntL;
  Long1 : IntL;
  SavFr : IntL;
  Word0 : Word;
  SHWB0 : Bool;
  SHWH0 : Byte;

Begin

  If OTxt<>'' Then
  Begin
    OptionsR(022,005,OTxt,'~YesE~xit','Y',BT);
    If BooleanEx Then Exit;
    WaitClr;
  End;

  TempI;
  BooleanErr:=BF;
  I:=LSNIGet(Name);
  If Line>LastLine[I] Then
  Begin
    Seek(LSNHandle[I],FileSize(LSNHandle[I]));
    For Word0:=000 To LineSize[I]-001 Do
    If Mem[LineSeg[I]:Word0]<>032 Then
    Mem[LineSeg[I]:Word0]:=000;
    BlockWrite(LSNHandle[I],Mem[LineSeg[I]:0],LineSize[I],CntrHROW0);
    {Achtung: Die Zeile unter mir habe ich am 19.09.2001 herausgenommen}
    {Inc(FileY[I]);}
  End
  Else
  Begin
    SHWB0:=BT;
    Long0:=000;
    Long1:=LastLine[I]-line;
    SavFr:=(LastLine[I]+001)*LineSize[I]+002;
    Repeat
      If OTxt<>'' Then
      ShowP('Fge Zeile ein',SHWB0,
      SHWH0,030,025,007,Long0,Long1,BF);
      Seek(LSNHandle[I],SavFr);
      BlockRead(LSNHandle[I],Mem[LineSeg[I]:0],LineSize[I],CntrHROW0);
      BlockWrite(LSNHandle[I],Mem[LineSeg[I]:0],LineSize[I],CntrHROW0);
      Dec(SavFr,LineSize[I]);Inc(Long0);
    Until (SavFr-002) Div LineSize[I]<=Line;
    For Word0:=000 To LineSize[I]-001 Do
    If LSNChkLS2(I) Then
    Begin
      If Mem[LineSeg[I]:Word0]<>124 Then
      Mem[LineSeg[I]:Word0]:=000;
    End
    Else
    If Mem[LineSeg[I]:Word0]<>032 Then
    Mem[LineSeg[I]:Word0]:=000;
    WriteListLine(Name,Line);
  End;
  Inc(LastLine[I]);
  TempO;

End;




Function  LSNChkLS2(I: Byte): Bool;
Var
  Byte0 : Byte;

Begin

  LSNChkLS2:=BF;
  Seek(LSNHandle[I],002+LineSize[I]);
  BlockRead(LSNHandle[I],Byte0,001,CntrHROW0);
  If Byte0=124 Then LSNChkLS2:=BT;

End;




Procedure LSNChkW(I,FX,WX,Y: Byte;ChkSeg: Word);
Var
  Byte0 : Byte;
  Word0 : Word;

Begin

  FillChar(Mem[ChkSeg:0],WX+016,001);
  For Byte0:=000 To LSN Do
  If  (SHWIDX[I]<SHWIDX[Byte0])
  And (LSNNam[Byte0]<>'') Then
  For Word0:=000 To WX-003 Do
  Begin
    If  (Y+001>=FrY1[Byte0])
    And (Y<=FrY2[Byte0]+001)
    And (Word0+FX>=FrX2[Byte0]+001)
    And (Word0+FX<=FrX2[Byte0]+002) Then Mem[ChkSeg:Word0]:=002;
    If  (Y=FrY2[Byte0]+001)
    And (Word0+FX>=FrX1[Byte0]+001)
    And (Word0+FX<=FrX2[Byte0]+001) Then Mem[ChkSeg:Word0]:=002;
    If  (Word0+FX+001>=FrX1[Byte0])
    And (Word0+FX<FrX2[Byte0]+001)
    And (Y+002>=FrY1[Byte0])
    And (Y<=FrY2[Byte0]) Then Mem[ChkSeg:Word0]:=000;
  End;

End;




Procedure LSNEdit(Name: ST08;
          FX,FY,WX,WY: Word;
          LPath,TPath: ST79;
          OpenMode: IntL;
          B50: Bool;
          Line: IntL;
          B13Ex,BFree,BClr,BScrP,BCol,BChkLSN: Bool);

Var
  BErr  : Bool;

Begin

  ELSNEdit(Name,FX,FY,WX,WY,LPath,TPath,
  OpenMode,B50,Line,B13Ex,BFree,BClr,BScrP,BCol,BChkLSN);
  BErr:=BooleanErr;
  BooleanErr:=BErr;

End;




Procedure LSNFrame(Name: ST08;FX,FY,WX,WY: Word;FCntr: IntS);
Var
  Byte0  : Byte;
  Byte1  : Byte;
  I      : Byte;

Begin

  I:=LSNIGet(Name);
  If FrCntr[I]<FCntr Then
  Begin
    FrCntr[I]:=FCntr;
    If WY>LastLine[I]+004 Then WY:=LastLine[I]+004;
    If FY+WY>Ord(Is50)*025+024 Then WY:=Ord(Is50)*025+024-FY;
    Mem[SegB800:FX*002+FY*160]:=218;
    Mem[SegB800:FX*002+FY*160+001]:=112;
    Mem[SegB800:FX*002+FY*160+002]:=196;
    Mem[SegB800:FX*002+FY*160+003]:=112;
    Mem[SegB800:(FX+WX-001)*002+FY*160]:=191;
    Mem[SegB800:(FX+WX-001)*002+FY*160+001]:=127;
    Mem[SegB800:FX*002+(FY+WY-001)*160]:=192;
    Mem[SegB800:FX*002+(FY+WY-001)*160+001]:=112;
    Mem[SegB800:(FX+WX-001)*002+(FY+WY-001)*160]:=217;
    Mem[SegB800:(FX+WX-001)*002+(FY+WY-001)*160+001]:=127;
    For Byte0:=001 To WX-002 Do
    Begin
      Mem[SegB800:(FX+Byte0)*002+FY*160+001]:=112;
      Mem[SegB800:(FX+Byte0)*002+(FY+WY-001)*160]:=196;
      Mem[SegB800:(FX+Byte0)*002+(FY+WY-001)*160+001]:=127;
    End;
    For Byte0:=001 To WY-002 Do
    Begin
      Mem[SegB800:FX*002+(FY+Byte0)*160]:=179;
      Mem[SegB800:FX*002+(FY+Byte0)*160+001]:=112;
      Mem[SegB800:(FX+WX-001)*002+(FY+Byte0)*160]:=179;
      Mem[SegB800:(FX+WX-001)*002+(FY+Byte0)*160+001]:=127;
    End;
    Window(FX+002,FY+002,FX+WX-001,FY+002);
    TextBackGround(000);
    TextColor(012);
    Crt.ClrScr;
    Window(FX+002,FY+003,FX+WX-001,FY+WY-001);
    TextBackGround(000);
    TextColor(007);
    Crt.ClrScr;
    LSNShadow(Name,FX,FY,WX,WY);
  End;

End;




Procedure LSNFree(Name: ST08);
Var
  Byte0  : Byte;
  I      : Byte;
  Word0  : Word;

Begin

  I:=LSNIGet(Name);
  FreeBuf(LineSeg[I],Word0);
  MemErrorOut('LSNFree',Word0,000);
  FreeBuf(TitSeg[I],Word0);
  MemErrorOut('LSNFree',Word0,000);
  If ColSeg[I]>000 Then
  Begin
    FreeBuf(ColSeg[I],Word0);
    MemErrorOut('FreeList',Word0,000);
  End;
  OFileF(LSNHandle[I],'',FClose,001);
  If SHWIDX[I]>=000 Then
  For Byte0:=000 To LSN Do
  If LSNNam[Byte0]<>'' Then
  If SHWIDX[Byte0]>SHWIDX[I] Then
  Dec(SHWIDX[Byte0]);
  SHWIDX[I]:=-001;
  BooleanErr:=BF;
  FrX1[I]:=-001;
  FrX2[I]:=-001;
  FrY1[I]:=-001;
  FrY2[I]:=-001;
  LSNNam[I]:='';

End;




Function  LSNGetNextLSNI: Hand;
Var
  Byte0 : Byte;

Begin

  For Byte0:=000 To LSN Do
  If LSNNam[Byte0]='' Then
  Begin
    LSNGetNextLSNI:=Byte0;
    Exit;
  End;

End;




Procedure LSNGetPageDates(Name: ST08;Var FX,FY,WX,WY: Byte);
Var
  I : Byte;

Begin

  I:=LSNIGet(Name);
  FX:=FrX1[I];FY:=FrY1[I];
  WX:=FrX2[I]-FrX1[I]+002;
  WY:=FrY2[I]-FrY1[I]+003;

End;




Function  LSNIGet(Name: ST08): Byte;
Begin

  LSNI:=000;
  For LSNI:=000 To LSN Do
  If LSNNam[LSNI]=Name Then
  Begin
    LSNIGet:=LSNI;
    Exit;
  End;
  ErrorOut('LSNIGet: '+Name+' not found',001,'',#000);

End;




Procedure LSNLoad(Name: ST08;LPath,TPath: ST79;OMod: FOM);
Var
  Byte0   : Byte;
  DStr    : ST67;
  EStr    : ST04;
  HandF   : Hand;
  I       : Byte;
  Long0   : IntL;
  Long1   : IntL;
  NStr    : ST08;
  PXX     : ST04;
  Stri0   : ST02;
  Word0   : Word;
  Word1   : Word;

Begin

  FSplit(LPath,DStr,NStr,EStr);
  OFileF(HandF,LPath,FRead,001);
  If IOResult2=000 Then
  Begin
    OFileF(HandF,'',FClose,001);
    If IsLSN(LPath) Then
    Begin
      If Not LSNTest(Name) Then
      Begin
        LSNI:=000;
        While (LSNNam[LSNI]<>'') And (LSNI<LSN) Do Inc(LSNI);
        If LSNNam[LSNI]='' Then
        Begin
          I:=LSNI;
          LSNNam[I]:=Name;
          If OMod=Rd Then
          OFileF(LSNHandle[I],LPath,FRead,001)
          Else
          If OMod=RdWr Then
          OFileF(LSNHandle[I],LPath,FReadWrite,001)
          Else
          If OMod=RdWr2 Then
          OFileF(LSNHandle[I],LPath,FReadWrite2,001);
          If IOResult2=000 Then
          Begin
            CrsrX[I]:=001;
            CrsrY[I]:=001;
            Field[I]:=000;
            FileX[I]:=000;
            FileY[I]:=000;
            BoolFix[I]:=BF;
            ColSeg[I]:=000;
            BLSNPage[I]:=BT;
            BlockA[I]:=-001;
            BlockB[I]:=-001;
            FPath[I]:=LPath;
            FrCntr[I]:=-001;
            BoolWrite[I]:=BF;
            FieldPos[I]:=001;
            LisSiz[I]:=FileSize(LSNHandle[I]);
            BlockRead(LSNHandle[I],LineSize[I],002,CntrHROW0);
            LineSeg[I]:=GetBuf(LineSize[I],Word0,Word1);
            MemErrorOut('LoadList',Word0,000);
            TitSeg[I]:=GetBuf(LineSize[I],Word0,Word1);
            MemErrorOut('LSNLoad',Word0,000);
            LastLine[I]:=(FileSize(LSNHandle[I])-002) Div LineSize[I]-002;
            If TPath<>'' Then
            Begin
              OFileF(HandF,TPath,FRead,001);
              If IOResult2=000 Then
              Begin
                FillChar(Mem[TitSeg[I]:0],LineSize[I],032);
                BlockRead(HandF,Mem[TitSeg[I]:0],LineSize[I],Word0);
                OFileF(HandF,'',FClose,001);
              End;
            End
            Else
            Begin
              Seek(LSNHandle[I],002);
              BlockRead(LSNHandle[I],Mem[TitSeg[I]:0],LineSize[I],CntrHROW0);
            End;
            If FileSize(LSNHandle[I])>=002+LineSize[I]*002 Then
            Begin
              ReadOneLine(Name,000);
              CntFields[I]:=GetCountFields(Name);
              BooleanErr:=BF;
            End
            Else
            Begin
              LSNFree(Name);
              BooleanErr:=BT;
            End;
          End
          Else
          LSNNam[I]:='';
        End
        Else
        Begin
          ErrorOut('LSNLoad: '+Name+
          '. No more place free',001,'',#000);
          BooleanErr:=BT;
        End;
      End;
    End
    Else
    Begin
      ErrorOut('LSNLoad: '+Name+
      ': file '+CutString(LPath,060)+' is no list',000,'',#000);
      BooleanErr:=BT;
    End;
  End
  Else
  Begin
    ErrorOut('List '+
    CutString(LPath,060)+' not found',000,'',#000);
    BooleanErr:=BT;
  End;

End;




Procedure LSNNoPRNCodeDelPRN(Name: ST08;
          B0,FY: Byte;LSeg,OSeg: Word;Var LSize: Word);
Var
  I      : Byte;
  BEvent : Bool;
  Word0  : Word;
  Word1  : Word;

Begin

  I:=LSNIGet(Name);
  For Word0:=(B0-FY-002)*LineSize[I] To
  (B0-FY-002)*LineSize[I]+LineSize[I]-001 Do
  Mem[LSeg:Word0-((B0-FY-002)*LineSize[I])]:=Mem[OSeg:Word0];
  If ((Copy(Name,001,005)='TEDIT')
  Or (Copy(Name,001,005)='TRONLY')) And BNoPRNCode[I] Then
  Begin
    Word0:=002;
    LSize:=LineSize[I];
    Repeat
      If Mem[LSeg:Word0]=Ord('{') Then
      Begin
        BEvent:=BF;
        Word1:=Word0+001;
        Repeat
          If Mem[LSeg:Word1]=Ord('}') Then
          BEvent:=BT
          Else
          Inc(Word1);
        Until BEvent Or (Word1>LSize-002);
        If BEvent Then
        Begin
          Move(Mem[LSeg:Word1+001],Mem[LSeg:Word0],LSize-(Word1-Word0+003));
          Dec(LSize,Word1-Word0+001);
        End;
      End;
      Inc(Word0);
    Until Word0>LSize-004;
  End
  Else
  LSize:=LineSize[I];

End;




Procedure LSNPage(Name: ST08;FX,FY,WX,WY: Byte);
Var
  BChngd : Bool;
  BEvent : Bool;
  BOkSeg : Word;
  BoolC  : Bool;
  BX1    : Word;
  BX2    : Word;
  Byte0  : Byte;
  Byte1  : Byte;
  Col    : Byte;
  I      : Byte;
  LSeg   : Word;
  LSize  : Word;
  OutSeg : Word;
  OutSiz : IntL;
  Result : Word;
  Toggle : Bool;
  Word0  : Word;
  Word1  : Word;

Procedure Help1;
Var
  IntS0 : IntS;
  IntS1 : IntS;
Begin
  IntS0:=-001;
  For IntS1:=000 To LSN Do
  If IntS1<>I Then If LSNNam[IntS1]<>'' Then
  If SHWIDX[IntS1]>IntS0 Then IntS0:=SHWIDX[IntS1];
  SHWIDX[I]:=IntS0;
  Inc(SHWIDX[I]);
  If FrX1[I]=-001 Then
  Begin
    FrX1[I]:=FX;
    FrY1[I]:=FY;
    FrX2[I]:=WX+FrX1[I]-002;
    FrY2[I]:=WY+FrY1[I]-003;
  End;
End;

Procedure HelpHelpTXT;
Begin
  If Name='HELPTXT' Then
  If (Mem[SegB800:Word1]=060)
  Or (Mem[SegB800:Word1]=062) Then
  Mem[SegB800:Word1+001]:=Col And 112 Or 014;
End;

Begin

  Col:=007;
  Toggle:=BF;
  I:=LSNIGet(Name);
  If SHWIDX[I]=-001 Then Help1;
  If WY>LastLine[I]+004 Then WY:=LastLine[I]+004;
  If FY+WY>Ord(Is50)*025+024 Then WY:=Ord(Is50)*025+024-FY;
  BOkSeg:=GetBuf(WX+016,Word0,Result);
  MemErrorOut('LSNPage',Word0,000);
  OutSiz:=LineSize[I]*(WY-003);
  Begin
    OutSeg:=GetBuf(OutSiz,Word0,Result);
    MemErrorOut('LSNPage',Word0,000);
    LSeg:=GetBuf(LineSize[I],Word0,Result);
    MemErrorOut('LSNPage',Word0,000);
    Seek(LSNHandle[I],(FileY[I]+001)*LineSize[I]+002);
    BlockRead(LSNHandle[I],Mem[OutSeg:0],OutSiz,CntrHROW0);
    Begin
      If BooleanBlockD
      Or BooleanBlockR Then
      WaitForVerticalRetrace;
      For Byte0:=FY+002 To FY+WY-002 Do
      Begin
        If  BlockB[I]>-001 Then
        If  (FileY[I]+Byte0-FY-002>=BlockA[I])
        And (FileY[I]+Byte0-FY-002<=BlockB[I]) Then
        Col:=062 Else Col:=007;
        LSNNoPRNCodeDelPRN(Name,Byte0,FY,LSeg,OutSeg,LSize);
        Byte1:=001;
        LSNChkW(I,FX,WX,Byte0-002,BOkSeg);
        For Word0:=FileX[I] To FileX[I]+WX-003 Do
        If Mem[BOkSeg:Word0-FileX[I]]=001 Then
        Begin
          Word1:=(FX+Byte1)*002+Byte0*160;
          If  (Word0<LSize)
          And (FileY[I]+Byte0-FY-002<=LastLine[I]) Then
          Mem[SegB800:Word1]:=Mem[LSeg:Word0]
          Else
          Mem[SegB800:Word1]:=032;
          Mem[SegB800:Word1+001]:=Col;
          HelpHelpTXT;
          If ColSeg[I]>000 Then
          Begin
            If Mem[ColSeg[I]:Word0] And 127=060 Then Toggle:=BT;
            If Mem[ColSeg[I]:Word0] And 127<>060 Then Toggle:=BF;
            If Toggle Then Mem[SegB800:Word1+001]:=
            Mem[ColSeg[I]:LineSize[I]];
          End;
          Inc(Byte1);
        End
        Else
        If Mem[BOkSeg:Word0-FileX[I]]=002 Then
        Begin
          Word1:=(FX+Byte1)*002+Byte0*160;
          If  (Word0<LSize)
          And (FileY[I]+Byte0-FY-002<=LastLine[I]) Then
          Mem[SegB800:Word1]:=Mem[LSeg:Word0-FileX[I]]
          Else
          Mem[SegB800:Word1]:=032;
          HelpHelpTXT;
          If ColSeg[I]>000 Then
          Begin
            If Mem[ColSeg[I]:Word0] And 127=060 Then Toggle:=BT;
            If Mem[ColSeg[I]:Word0] And 127<>060 Then Toggle:=BF;
            If Toggle Then Mem[SegB800:Word1+001]:=
            Mem[ColSeg[I]:LineSize[I]];
          End;
          Inc(Byte1);
        End
        Else
        Inc(Byte1);
      End;
    End;
    FreeBuf(LSeg,Word0);
    MemErrorOut('LSNPage',Word0,000);
    FreeBuf(OutSeg,Word0);
    MemErrorOut('LSNPage',Word0,000);
  End;
  FreeBuf(BOkSeg,Result);
  MemErrorOut('LSNPage',Result,000);

End;




Procedure LSNPage2(Name: ST08;FX,FY,WX,WY: Byte);
Var
  BChngd : Bool;
  BEvent : Bool;
  BOkSeg : Word;
  BoolC  : Bool;
  BX1    : Word;
  BX2    : Word;
  Byte0  : Byte;
  Byte1  : Byte;
  Col    : Byte;
  I      : Byte;
  LSeg   : Word;
  LSize  : Word;
  OutSeg : Word;
  OutSiz : IntL;
  Result : Word;
  Toggle : Bool;
  Word0  : Word;
  Word1  : Word;

Procedure Help1;
Var
  IntS0 : IntS;
  IntS1 : IntS;
Begin
  IntS0:=-001;
  For IntS1:=000 To LSN Do
  If IntS1<>I Then If LSNNam[IntS1]<>'' Then
  If SHWIDX[IntS1]>IntS0 Then IntS0:=SHWIDX[IntS1];
  SHWIDX[I]:=IntS0;
  Inc(SHWIDX[I]);
  If FrX1[I]=-001 Then
  Begin
    FrX1[I]:=FX;
    FrY1[I]:=FY;
    FrX2[I]:=WX+FrX1[I]-002;
    FrY2[I]:=WY+FrY1[I]-003;
  End;
End;

Procedure HelpHelpTXT;
Begin
  If Name='HELPTXT' Then
  If (Mem[SegB800:Word1]=060)
  Or (Mem[SegB800:Word1]=062) Then
  Mem[SegB800:Word1+001]:=Col And 112 Or 014;
End;

Begin

  Col:=007;
  Toggle:=BF;
  I:=LSNIGet(Name);
  If SHWIDX[I]=-001 Then Help1;
  If WY>LastLine[I]+004 Then WY:=LastLine[I]+004;
  If FY+WY>Ord(Is50)*025+024 Then WY:=Ord(Is50)*025+024-FY;
  BOkSeg:=GetBuf(WX+016,Word0,Result);
  MemErrorOut('LSNPage',Word0,000);
  OutSiz:=LineSize[I]*(WY-003);
  LSize:=LineSize[I];
  Begin
    OutSeg:=GetBuf(OutSiz,Word0,Result);
    MemErrorOut('LSNPage',Word0,000);
    LSeg:=GetBuf(LineSize[I],Word0,Result);
    MemErrorOut('LSNPage',Word0,000);
    Seek(LSNHandle[I],(FileY[I]+001)*LineSize[I]+002);
    BlockRead(LSNHandle[I],Mem[OutSeg:0],OutSiz,CntrHROW0);
    For Byte0:=FY+002 To FY+WY-002 Do
    Begin
      If  BlockB[I]>-001 Then
      If  (FileY[I]+Byte0-FY-002>=BlockA[I])
      And (FileY[I]+Byte0-FY-002<=BlockB[I]) Then
      Col:=062 Else Col:=007;
      Byte1:=001;
      LSNChkW(I,FX,WX,Byte0-002,BOkSeg);
      For Word0:=FileX[I] To FileX[I]+WX-003 Do
      If Mem[BOkSeg:Word0-FileX[I]]=001 Then
      Begin
        Word1:=(FX+Byte1)*002+Byte0*160;
        If  (Word0<LSize)
        And (FileY[I]+Byte0-FY-002<=LastLine[I]) Then
        Mem[SegB800:Word1]:=Mem[LSeg:Word0]
        Else
        Mem[SegB800:Word1]:=032;
        Mem[SegB800:Word1+001]:=Col;
        HelpHelpTXT;
        If ColSeg[I]>000 Then
        Begin
          If Mem[ColSeg[I]:Word0] And 127=060 Then Toggle:=BT;
          If Mem[ColSeg[I]:Word0] And 127<>060 Then Toggle:=BF;
          If Toggle Then Mem[SegB800:Word1+001]:=
          Mem[ColSeg[I]:LineSize[I]];
        End;
        Inc(Byte1);
      End
      Else
      If Mem[BOkSeg:Word0-FileX[I]]=002 Then
      Begin
        Word1:=(FX+Byte1)*002+Byte0*160;
        If  (Word0<LSize)
        And (FileY[I]+Byte0-FY-002<=LastLine[I]) Then
        Mem[SegB800:Word1]:=Mem[LSeg:Word0-FileX[I]]
        Else
        Mem[SegB800:Word1]:=032;
        HelpHelpTXT;
        If ColSeg[I]>000 Then
        Begin
          If Mem[ColSeg[I]:Word0] And 127=060 Then Toggle:=BT;
          If Mem[ColSeg[I]:Word0] And 127<>060 Then Toggle:=BF;
          If Toggle Then Mem[SegB800:Word1+001]:=
          Mem[ColSeg[I]:LineSize[I]];
        End;
        Inc(Byte1);
      End
      Else
      Inc(Byte1);
    End;
    FreeBuf(LSeg,Word0);
    MemErrorOut('LSNPage',Word0,000);
    FreeBuf(OutSeg,Word0);
    MemErrorOut('LSNPage',Word0,000);
  End;
  FreeBuf(BOkSeg,Result);
  MemErrorOut('LSNPage',Result,000);

End;




Procedure LSNSearchJ(Name: ST08;SStr: STFF;
          F,U: IntL;Tab: Word;Var LStart,LEnd: IntL;BPos,BBig: Bool);
Begin

  ELSNSearchJ(Name,SStr,F,U,Tab,LStart,LEnd,BPos,BBig);

End;




Function  LSNSearchJ2(Name: ST08;
          SStr: STFF;Tab: Word;F,U: IntL;BPos,BBig: Bool): IntL;
Begin

  LSNSearchJ2:=ELSNSearchJ2(Name,SStr,Tab,F,U,BPos,BBig);

End;




Function  LSNSearchJ3(Name: ST08;SStr: STFF;Tab: Word;F,U: IntL): IntL;
Begin

  LSNSearchJ3:=ELSNSearchJ3(Name,SStr,Tab,F,U);

End;




Function  LSNSearchJIB(Name: ST08;SStr: STFF;Tab: Word;F,U: IntL): IntL;
Begin

  LSNSearchJIB:=ELSNSearchJIB(Name,SStr,Tab,F,U);

End;




Function  LSNSearchO(Name: ST08;SStr: STFF;Tab: Word;F,U: IntL): IntL;
Begin

  LSNSearchO:=ELSNSearchO(Name,SStr,Tab,F,U);

End;




Procedure LSNShadow(Name: ST08;FX,FY,WX,WY: Byte);
Var
  I : Byte;

Begin

  I:=LSNIGet(Name);
  If WY>LastLine[I]+004 Then WY:=LastLine[I]+004;
  Shadow(FX+001,FX+WX,FY,FY+WY);

End;




Procedure LSNShowXY(Name: ST08;FX,FY,WX: Word);
Var
  Byte0 : Byte;
  Byte1 : Byte;
  I     : Byte;
  StrF  : ST06;
  StrX  : ST10;
  StrXY : ST30;
  StrY  : ST12;

Begin

  I:=LSNIGet(Name);
  Str(Field[I],StrF);
  Str(FieldPos[I],StrX);
  Str(FileY[I]+CrsrY[I],StrY);
  StrXY:=#032+StrF+':'+StrX+':'+StrY+#032;
  For Byte0:=001 To Length(StrXY) Do
  Begin
    If Byte0>WX-003 Then Exit;
    Mem[SegB800:(FX+001+Byte0)*002+FY*160]:=Ord(StrXY[Byte0]);
  End;
  For Byte1:=Byte0+001 To WX-003 Do
  Mem[SegB800:(FX+001+Byte1)*002+FY*160]:=196;

End;




Procedure LSNSort(Name: ST08;BAsk: Bool;SortP: SArr);
Begin

  If ((Name='SORTLIST') Or (Pos('HELP',Name)>000)) Then
  Begin
    If BAsk Then
    ErrorOut('This list could not be '+
    'sorted',000,'',#000);
    BooleanErr:=BT;
  End
  Else
  Begin
    If LastLine[LSNIGet(Name)]<001 Then
    Begin
      If BAsk Then
      ErrorOut('For sorting there must exist '+
      '2 records at least',000,'',#000);
      BooleanErr:=BT;
    End
    Else
    Begin
      ELSNSortFU(Name,BAsk,SortP,000,LastLine[LSNIGet(Name)]);
      BooleanErr:=BF;
    End;
  End;

End;




Procedure LSNSortFU(Name: ST08;BAsk: Bool;SortP: SArr;SF,SU: IntL);
Begin

  ELSNSortFU(Name,BAsk,SortP,SF,SU);

End;




Function  LSNTest(Name: ST08): Bool;
Var
  Byte0 : Byte;

Begin

  LSNTest:=BF;
  For Byte0:=000 To LSN Do
  If LSNNam[Byte0]=Name Then
  Begin
    LSNTest:=BT;
    Exit;
  End;

End;




Procedure LSNTOut(Name: ST08;FX,FY,WX: Word);
Var
  Byte0  : Byte;
  I      : Byte;
  Word0  : Word;

Begin

  Byte0:=001;
  I:=LSNIGet(Name);
  For Word0:=FileX[I] To FileX[I]+WX-003 Do
  Begin
    If Word0<LineSize[I] Then
    Mem[SegB800:(FX+Byte0)*002+(FY+001)*160]:=Mem[TitSeg[I]:Word0]
    Else
    Mem[SegB800:(FX+Byte0)*002+(FY+001)*160]:=032;
    Inc(Byte0);
  End;

End;




Procedure MakeInsLines(ALen: TLen;UpTo,Width: Word);
Var
  BIns  : Bool;
  HandF : Hand;
  Lines : Word;
  LSeg  : Word;
  Stri0 : ST04;
  Word0 : Word;
  Word1 : Word;
  Word2 : Word;

Begin

  BIns:=BF;
  LSeg:=GetBuf(Width,Word0,Word1);
  MemErrorOut('MakeInsLines',Word0,000);
  For Word0:=000 To UpTo Do
  Begin
    If Not BIns Then
    Begin
      If ALen[Word0]<000 Then
      If Word0>000 Then
      Begin
        BIns:=BT;
        Lines:=001;
        Str(Lines:003,Stri0);
        Stri0:=FillString(Stri0,#032,#048);
        OFileF(HandF,PRGPATH+'\'+Stri0+'.INS',FNew,001);
        FillChar(Mem[LSeg:000],Width,032);
        Word1:=000;
        For Word2:=000 To UpTo Do
        If ALen[Word2]>000 Then
        Begin
          FillChar(Mem[LSeg:Word1+002],ALen[Word2],000);
          Inc(Word1,ALen[Word2]+002);
        End;
        BlockWrite(HandF,Mem[LSeg:000],Width,CntrHROW0);
        OFileF(HandF,'',FClose,001);
      End
      Else
      ErrorOut('Field zero must be defined in main line',001,'',#000);
    End
    Else
    Begin
      If ALen[Word0]>=000 Then BIns:=BF;
      If ALen[Word0]<000 Then
      If ALen[Word0-001]<000 Then
      Begin
        Inc(Lines);
        Str(Lines:003,Stri0);
        Stri0:=FillString(Stri0,#032,#048);
        OFileF(HandF,PRGPATH+'\TEMPS\'+Stri0+'.INS',FNew,001);
        FillChar(Mem[LSeg:000],Width,032);
        Word1:=000;
        For Word2:=000 To UpTo Do
        If ALen[Word2]>000 Then
        Begin
          FillChar(Mem[LSeg:Word1+002],ALen[Word2],000);
          Inc(Word1,ALen[Word2]+002);
        End;
        BlockWrite(HandF,Mem[LSeg:000],Width,CntrHROW0);
        OFileF(HandF,'',FClose,001);
      End;
    End;
  End;
  FreeBuf(LSeg,Word0);
  MemErrorOut('MakeInsLines',Word0,000);

End;




Procedure MoveLineToLine(NameS,NameT: ST08;LineS,LineT: IntL);
Var
  IS : Byte;
  IT : Byte;

Begin

  IS:=LSNIGet(NameS);
  IT:=LSNIGet(NameT);
  ReadOneLine(NameS,LineS);
  Move(Mem[LineSeg[IS]:0],Mem[LineSeg[IT]:0],LineSize[IT]);
  WriteListLine(NameT,LineT);

End;




Procedure OpenInsLine(Var HandF: Hand;ALen: TLen;Upto,Width: Word);
Var
  BIns  : Bool;
  Line  : Word;
  Stri0 : ST04;
  Word0 : Word;

Begin

  BIns:=BF;
  For Word0:=000 To UpTo Do
  Begin
    If Not BIns Then
    Begin
      If ALen[Word0]<000 Then
      Begin
        BIns:=BT;
        Line:=001;
      End;
    End
    Else
    Begin
      If ALen[Word0]>=000 Then BIns:=BF;
      If ALen[Word0]<000 Then
      If ALen[Word0-001]<000 Then Inc(Line);
    End;
  End;
  Str(Line:003,Stri0);
  Stri0:=FillString(Stri0,#032,#048);
  OFileF(HandF,PRGPATH+'\'+Stri0+'.INS',FReadWrite,001);

End;




Procedure PutListStr(Name: ST08;Line: IntL;FNum: Word;PStr: STFF);
Var
  FCntr : Word;
  FLeng : Word;
  I     : Byte;
  LastI : Word;
  LIndx : Word;

Begin

  I:=LSNIGet(Name);
  ReadOneLine(Name,Line);
  PStr:=FillString(PStr,#032,#000);
  FCntr:=000;
  LIndx:=000;
  While FCntr<=FNum Do
  Begin
    While ((Mem[LineSeg[I]:LIndx]=032)
    Or (Mem[LineSeg[I]:LIndx]=124))
    And (LIndx<LineSize[I]-001) Do Inc(LIndx);
    FLeng:=000;
    LastI:=LIndx;
    While (Mem[LineSeg[I]:LIndx]<>032)
    And (Mem[LineSeg[I]:LIndx]<>124)
    And (LIndx<LineSize[I]-001) Do
    Begin
      Inc(FLeng);
      Inc(LIndx);
    End;
    Inc(FCntr);
  End;
  FillChar(Mem[LineSeg[I]:LastI],FLeng,000);
  If Length(PStr)<FLeng Then FLeng:=Length(PStr);
  Move(PStr[001],Mem[LineSeg[I]:LastI],FLeng);
  Seek(LSNHandle[I],(Line+001)*LineSize[I]+002);
  BlockWrite(LSNHandle[I],Mem[LineSeg[I]:0],LineSize[I],CntrHROW0);

End;




Procedure ReadOneLine(Name: ST08;Line: IntL);
Var
  I     : Byte;
  Stri0 : ST80;

Begin

  I:=LSNIGet(Name);
  If Line<=Lastline[I] Then
  Begin
    Seek(LSNHandle[I],(Line+001)*LineSize[I]+002);
    BlockRead(LSNHandle[I],Mem[LineSeg[I]:0],LineSize[I],CntrHROW0);
  End
  Else
  Begin
    Str(Line,Stri0);
    ErrorOut('ReadOneLine, Name: '+
    Name+'  Line too big: '+Stri0,001,'',#000);
  End;

End;




Procedure UnColorField(Name: ST08;FX,FY,WX,WY: Word;BClr: Bool);
Var
  BOkSeg : Word;
  CByte  : Byte;
  Col    : Byte;
  Byte0  : Byte;
  I      : Byte;
  TColor : Byte;
  Word0  : Word;
  Word1  : Word;

Procedure Help11;
Begin
  CByte:=032;
  I:=LSNIGet(Name);
  If LSNChkLS2(I) Then CByte:=124;
End;

Procedure Help12;
Begin
  BOkSeg:=GetBuf(WX+016,Word0,Word1);
  MemErrorOut('UnColorField',Word0,000);
End;

Procedure Help13;
Begin
  FreeBuf(BOkSeg,Word0);
  MemErrorOut('UnColorField',Word0,000);
End;

Begin

  Help11;
  Help12;
  Col:=007;
  BoolClr[I]:=BClr;
  Byte0:=FX+CrsrX[I];
  LSNChkW(I,FX,WX,FY+CrsrY[I]-001,BOkSeg);
  If  BlockB[I]>-001 Then
  If  (FileY[I]+CrsrY[I]-001>=BlockA[I])
  And (FileY[I]+CrsrY[I]-001<=BlockB[I])
  Then Col:=062 Else Col:=007;
  If Byte0>FX Then
  Repeat
    Word0:=(FY+CrsrY[I]+001)*160+Byte0*002;
    If Mem[SegB800:Word0]<>CByte Then
    Begin
      If Mem[BOkSeg:Byte0-FX-001]=001 Then
      Begin
        If ColSeg[I]>000 Then
        Begin
          TColor:=Mem[ColSeg[I]:LineSize[I]];
          If Mem[SegB800:Word0+001]<>TColor Then
          Mem[SegB800:Word0+001]:=Col;
        End
        Else
        TColor:=112;
        If Mem[SegB800:Word0+001]<>TColor Then
        Mem[SegB800:Word0+001]:=Col;
        If Name='HELPTXT' Then
        If (Mem[SegB800:Word0]=060)
        Or (Mem[SegB800:Word0]=062) Then
        Mem[SegB800:Word0+001]:=Col And 112 Or 014;
        Dec(Byte0);
      End
      Else
      If Mem[BOkSeg:Byte0-FX-001]=002 Then
      Begin
        If ColSeg[I]>000 Then
        Begin
          TColor:=Mem[ColSeg[I]:LineSize[I]];
          If Mem[SegB800:Word0+001]<>TColor Then
          Mem[SegB800:Word0+001]:=008;
        End
        Else
        TColor:=112;
        If Mem[SegB800:Word0+001]<>TColor Then
        Mem[SegB800:Word0+001]:=008;
        If Name='HELPTXT' Then
        If (Mem[SegB800:Word0]=060)
        Or (Mem[SegB800:Word0]=062) Then
        Mem[SegB800:Word0+001]:=Col And 112 Or 014;
        Dec(Byte0);
      End
      Else
      Dec(Byte0);
    End
    Else
    Dec(Byte0);
  Until (Byte0=FX)
  Or ((Mem[BOkSeg:Byte0-FX]=001) And (Mem[SegB800:Word0]=CByte));
  Byte0:=FX+CrsrX[I];
  Repeat
    Word0:=(FY+CrsrY[I]+001)*160+Byte0*002;
    If Mem[SegB800:Word0]<>CByte Then
    Begin
      If Mem[BOkSeg:Byte0-FX-001]=001 Then
      Begin
        If ColSeg[I]>000 Then
        Begin
          TColor:=Mem[ColSeg[I]:LineSize[I]];
          If Mem[SegB800:Word0+001]<>TColor Then
          Mem[SegB800:Word0+001]:=Col;
        End
        Else
        TColor:=112;
        If Mem[SegB800:Word0+001]<>TColor Then
        Mem[SegB800:Word0+001]:=Col;
        If Name='HELPTXT' Then
        If (Mem[SegB800:Word0]=060)
        Or (Mem[SegB800:Word0]=062) Then
        Mem[SegB800:Word0+001]:=Col And 112 Or 014;
        Inc(Byte0);
      End
      Else
      If Mem[BOkSeg:Byte0-FX-001]=002 Then
      Begin
        If ColSeg[I]>000 Then
        Begin
          TColor:=Mem[ColSeg[I]:LineSize[I]];
          If Mem[SegB800:Word0+001]<>TColor Then
          Mem[SegB800:Word0+001]:=008;
        End
        Else
        TColor:=112;
        If Mem[SegB800:Word0+001]<>TColor Then
        Mem[SegB800:Word0+001]:=008;
        If Name='HELPTXT' Then
        If (Mem[SegB800:Word0]=060)
        Or (Mem[SegB800:Word0]=062) Then
        Mem[SegB800:Word0+001]:=Col And 112 Or 014;
        Inc(Byte0);
      End
      Else
      Inc(Byte0);
    End
    Else
    Inc(Byte0);
  Until (Byte0=FX+WX-001)
  Or ((Mem[BOkSeg:Byte0-FX]=001) And (Mem[SegB800:Word0]=CByte));
  Help13;

End;




Procedure WriteListLine(Name: ST08;Line: IntL);
Var
  I : Byte;

Begin

  I:=LSNIGet(Name);
  If Line<000 Then Line:=FileY[I]+CrsrY[I]-001;
  Seek(LSNHandle[I],(Line+001)*LineSize[I]+002);
  BlockWrite(LSNHandle[I],Mem[LineSeg[I]:0],LineSize[I],CntrHROW0);

End;




END.
